#line 1 "ad_x86_gen.cpp"
//
// Copyright (c) 1997, 2018, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode){

  switch(opcode) {
  case UNIVERSE:
    return new UniverseOper( );
  case LABEL:
    return new labelOper( );
  case SREGI:
    return new sRegIOper( );
  case SREGP:
    return new sRegPOper( );
  case SREGF:
    return new sRegFOper( );
  case SREGD:
    return new sRegDOper( );
  case SREGL:
    return new sRegLOper( );
  case METHOD:
    return new methodOper( );
  case IMMI:
    return new immIOper(_leaf->get_int() );
  case IMMI0:
    return new immI0Oper(_leaf->get_int() );
  case IMMI1:
    return new immI1Oper(_leaf->get_int() );
  case IMMI_M1:
    return new immI_M1Oper(_leaf->get_int() );
  case IMMI2:
    return new immI2Oper(_leaf->get_int() );
  case IMMI8:
    return new immI8Oper(_leaf->get_int() );
  case IMMI16:
    return new immI16Oper(_leaf->get_int() );
  case IMMU31:
    return new immU31Oper(_leaf->get_int() );
  case IMMI_32:
    return new immI_32Oper(_leaf->get_int() );
  case IMMI_1_31:
    return new immI_1_31Oper(_leaf->get_int() );
  case IMMI_32_63:
    return new immI_32_63Oper(_leaf->get_int() );
  case IMMI_1:
    return new immI_1Oper(_leaf->get_int() );
  case IMMI_2:
    return new immI_2Oper(_leaf->get_int() );
  case IMMI_3:
    return new immI_3Oper(_leaf->get_int() );
  case IMMP:
    return new immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP0:
    return new immP0Oper(_leaf->bottom_type()->is_ptr() );
  case IMML:
    return new immLOper(_leaf->get_long() );
  case IMML0:
    return new immL0Oper(_leaf->get_long() );
  case IMML_M1:
    return new immL_M1Oper(_leaf->get_long() );
  case IMML_127:
    return new immL_127Oper(_leaf->get_long() );
  case IMML_32BITS:
    return new immL_32bitsOper(_leaf->get_long() );
  case IMML32:
    return new immL32Oper(_leaf->get_long() );
  case IMMDPR0:
    return new immDPR0Oper(_leaf->getd() );
  case IMMDPR1:
    return new immDPR1Oper(_leaf->getd() );
  case IMMDPR:
    return new immDPROper(_leaf->getd() );
  case IMMD:
    return new immDOper(_leaf->getd() );
  case IMMD0:
    return new immD0Oper(_leaf->getd() );
  case IMMFPR0:
    return new immFPR0Oper(_leaf->getf() );
  case IMMFPR1:
    return new immFPR1Oper(_leaf->getf() );
  case IMMFPR:
    return new immFPROper(_leaf->getf() );
  case IMMF:
    return new immFOper(_leaf->getf() );
  case IMMF0:
    return new immF0Oper(_leaf->getf() );
  case IMMI_16:
    return new immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new immI_24Oper(_leaf->get_int() );
  case IMMI_255:
    return new immI_255Oper(_leaf->get_int() );
  case IMMI_65535:
    return new immI_65535Oper(_leaf->get_int() );
  case RREGI:
    return new rRegIOper( );
  case XREGI:
    return new xRegIOper( );
  case EAXREGI:
    return new eAXRegIOper( );
  case EBXREGI:
    return new eBXRegIOper( );
  case ECXREGI:
    return new eCXRegIOper( );
  case EDXREGI:
    return new eDXRegIOper( );
  case EDIREGI:
    return new eDIRegIOper( );
  case NAXREGI:
    return new naxRegIOper( );
  case NADXREGI:
    return new nadxRegIOper( );
  case NCXREGI:
    return new ncxRegIOper( );
  case ESIREGI:
    return new eSIRegIOper( );
  case ANYREGP:
    return new anyRegPOper( );
  case EREGP:
    return new eRegPOper( );
  case EREGP_NO_EBP:
    return new eRegP_no_EBPOper( );
  case NAXREGP:
    return new naxRegPOper( );
  case NABXREGP:
    return new nabxRegPOper( );
  case PREGP:
    return new pRegPOper( );
  case EAXREGP:
    return new eAXRegPOper( );
  case EBXREGP:
    return new eBXRegPOper( );
  case ECXREGP:
    return new eCXRegPOper( );
  case ESIREGP:
    return new eSIRegPOper( );
  case EDIREGP:
    return new eDIRegPOper( );
  case EREGL:
    return new eRegLOper( );
  case EADXREGL:
    return new eADXRegLOper( );
  case EBCXREGL:
    return new eBCXRegLOper( );
  case EADXREGL_LOW_ONLY:
    return new eADXRegL_low_onlyOper( );
  case EFLAGSREG:
    return new eFlagsRegOper( );
  case EFLAGSREGU:
    return new eFlagsRegUOper( );
  case EFLAGSREGUCF:
    return new eFlagsRegUCFOper( );
  case FLAGSREG_LONG_LTGE:
    return new flagsReg_long_LTGEOper( );
  case FLAGSREG_LONG_EQNE:
    return new flagsReg_long_EQNEOper( );
  case FLAGSREG_LONG_LEGT:
    return new flagsReg_long_LEGTOper( );
  case FLAGSREG_ULONG_LTGE:
    return new flagsReg_ulong_LTGEOper( );
  case FLAGSREG_ULONG_EQNE:
    return new flagsReg_ulong_EQNEOper( );
  case FLAGSREG_ULONG_LEGT:
    return new flagsReg_ulong_LEGTOper( );
  case REGDPR:
    return new regDPROper( );
  case REGDPR1:
    return new regDPR1Oper( );
  case REGDPR2:
    return new regDPR2Oper( );
  case REGNOTDPR1:
    return new regnotDPR1Oper( );
  case REGFPR:
    return new regFPROper( );
  case REGFPR1:
    return new regFPR1Oper( );
  case REGF:
    return new regFOper( );
  case VLREGF:
    return new vlRegFOper( );
  case REGD:
    return new regDOper( );
  case VLREGD:
    return new vlRegDOper( );
  case VECS:
    return new vecSOper( );
  case LEGVECS:
    return new legVecSOper( );
  case VECD:
    return new vecDOper( );
  case LEGVECD:
    return new legVecDOper( );
  case VECX:
    return new vecXOper( );
  case LEGVECX:
    return new legVecXOper( );
  case VECY:
    return new vecYOper( );
  case LEGVECY:
    return new legVecYOper( );
  case DIRECT:
    return new directOper(_leaf->bottom_type()->is_ptr() );
  case INDIRECT:
    return new indirectOper( );
  case INDOFFSET8:
    return new indOffset8Oper(_kids[1]->_leaf->get_int() );
  case INDOFFSET32:
    return new indOffset32Oper(_kids[1]->_leaf->get_int() );
  case INDOFFSET32X:
    return new indOffset32XOper(_kids[0]->_leaf->bottom_type()->is_ptr() );
  case INDINDEXOFFSET:
    return new indIndexOffsetOper(_kids[1]->_leaf->get_int() );
  case INDINDEX:
    return new indIndexOper( );
  case INDINDEXSCALE:
    return new indIndexScaleOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALEOFFSET:
    return new indIndexScaleOffsetOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_int() );
  case LOAD_LONG_REGP:
    return new load_long_RegPOper( );
  case LOAD_LONG_INDIRECT:
    return new load_long_indirectOper( );
  case LOAD_LONG_INDOFFSET32:
    return new load_long_indOffset32Oper(_kids[1]->_leaf->get_int() );
  case STACKSLOTP:
    return new stackSlotPOper( );
  case STACKSLOTI:
    return new stackSlotIOper( );
  case STACKSLOTF:
    return new stackSlotFOper( );
  case STACKSLOTD:
    return new stackSlotDOper( );
  case STACKSLOTL:
    return new stackSlotLOper( );
  case INDIRECT_WIN95_SAFE:
    return new indirect_win95_safeOper( );
  case INDOFFSET8_WIN95_SAFE:
    return new indOffset8_win95_safeOper(_kids[1]->_leaf->get_int() );
  case INDOFFSET32_WIN95_SAFE:
    return new indOffset32_win95_safeOper(_kids[1]->_leaf->get_int() );
  case INDINDEXOFFSET_WIN95_SAFE:
    return new indIndexOffset_win95_safeOper(_kids[1]->_leaf->get_int() );
  case INDINDEXSCALE_WIN95_SAFE:
    return new indIndexScale_win95_safeOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALEOFFSET_WIN95_SAFE:
    return new indIndexScaleOffset_win95_safeOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_int() );
  case CMPOP:
    return new cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPU:
    return new cmpOpUOper(_leaf->as_Bool()->_test._test );
  case CMPOPUCF:
    return new cmpOpUCFOper(_leaf->as_Bool()->_test._test );
  case CMPOPUCF2:
    return new cmpOpUCF2Oper(_leaf->as_Bool()->_test._test );
  case CMPOP_FCMOV:
    return new cmpOp_fcmovOper(_leaf->as_Bool()->_test._test );
  case CMPOP_COMMUTE:
    return new cmpOp_commuteOper(_leaf->as_Bool()->_test._test );
  case CMPOPU_COMMUTE:
    return new cmpOpU_commuteOper(_leaf->as_Bool()->_test._test );
  case VECZ:
    return new vecZOper( );
  case LEGVECZ:
    return new legVecZOper( );
  case CMPOP_VCMPPD:
    return new cmpOp_vcmppdOper(_leaf->as_Bool()->_test._test );
  case _ADDP_EREGP_RREGI:    return NULL;
  case _LSHIFTI_RREGI_IMMI2:    return NULL;
  case _ADDP_EREGP__LSHIFTI_RREGI_IMMI2:    return NULL;
  case _ADDP_EREGP_NO_EBP_RREGI:    return NULL;
  case _ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _LOADL_MEMORY_:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _ANDI__LOADUB_MEMORY__IMMI:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LSHIFTI__LOADS_MEMORY__IMMI_24:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LSHIFTI__LOADUS_MEMORY__IMMI_24:    return NULL;
  case _ANDI__LOADUS_MEMORY__IMMI_255:    return NULL;
  case _ANDI__LOADUS_MEMORY__IMMI:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_24:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_16:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMI_255:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMI_65535:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMU31:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _CONVL2I_EREGL_:    return NULL;
  case _ROUNDDOUBLE_REGDPR1_:    return NULL;
  case _ROUNDFLOAT_REGFPR1_:    return NULL;
  case _CONVD2F_REGDPR1_:    return NULL;
  case _BINARY_CMPOP_EFLAGSREG:    return NULL;
  case _BINARY_RREGI_RREGI:    return NULL;
  case _BINARY_CMPOPU_EFLAGSREGU:    return NULL;
  case _BINARY_CMPOPUCF_EFLAGSREGUCF:    return NULL;
  case _BINARY_RREGI__LOADI_MEMORY_:    return NULL;
  case _BINARY_EREGP_EREGP:    return NULL;
  case _BINARY_CMPOP_FCMOV_EFLAGSREGU:    return NULL;
  case _BINARY_REGDPR1_REGDPR:    return NULL;
  case _BINARY_REGFPR1_REGFPR:    return NULL;
  case _BINARY_REGDPR_REGDPR:    return NULL;
  case _BINARY_REGFPR_REGFPR:    return NULL;
  case _BINARY_REGF_REGF:    return NULL;
  case _BINARY_REGD_REGD:    return NULL;
  case _BINARY_EREGL_EREGL:    return NULL;
  case _ADDI__LOADI_MEMORY__RREGI:    return NULL;
  case _ADDI_RREGI__LOADI_MEMORY_:    return NULL;
  case _ADDI__LOADI_MEMORY__IMMI:    return NULL;
  case _ADDI__LOADI_MEMORY__IMMI1:    return NULL;
  case _ADDI__LOADI_MEMORY__IMMI_M1:    return NULL;
  case _BINARY_EAXREGP_EREGP:    return NULL;
  case _BINARY_EAXREGI_RREGI:    return NULL;
  case _BINARY_EADXREGL_EBCXREGL:    return NULL;
  case _BINARY_EAXREGP_ECXREGP:    return NULL;
  case _BINARY_EAXREGI_ECXREGI:    return NULL;
  case _SUBI__LOADI_MEMORY__RREGI:    return NULL;
  case _SUBI_IMMI0_RREGI:    return NULL;
  case _CONVI2L_NADXREGI_:    return NULL;
  case _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY:    return NULL;
  case _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32:    return NULL;
  case _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_:    return NULL;
  case _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32:    return NULL;
  case _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63:    return NULL;
  case _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63:    return NULL;
  case _CONVI2L_EAXREGI_:    return NULL;
  case _ANDL__CONVI2L_EAXREGI__IMML_32BITS:    return NULL;
  case _ANDL__CONVI2L_NADXREGI__IMML_32BITS:    return NULL;
  case _RSHIFTI__LOADI_MEMORY__IMMI1:    return NULL;
  case _RSHIFTI__LOADI_MEMORY__IMMI8:    return NULL;
  case _LSHIFTI_XREGI_IMMI_24:    return NULL;
  case _LSHIFTI_XREGI_IMMI_16:    return NULL;
  case _ANDI__LOADI_MEMORY__RREGI:    return NULL;
  case _ANDI_RREGI__LOADI_MEMORY_:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMI:    return NULL;
  case _XORI_RREGI_IMMI_M1:    return NULL;
  case _SUBI_IMMI0__LOADI_MEMORY_:    return NULL;
  case _ADDI_RREGI_IMMI_M1:    return NULL;
  case _CASTP2X_EREGP_:    return NULL;
  case _ORI__LOADI_MEMORY__RREGI:    return NULL;
  case _ORI_RREGI__LOADI_MEMORY_:    return NULL;
  case _ORI__LOADI_MEMORY__IMMI:    return NULL;
  case _LSHIFTI_RREGI_IMMI1:    return NULL;
  case _URSHIFTI_RREGI_IMMI_M1:    return NULL;
  case _LSHIFTI_RREGI_IMMI8:    return NULL;
  case _URSHIFTI_RREGI_IMMI8:    return NULL;
  case _LSHIFTI_NCXREGI_ECXREGI:    return NULL;
  case _SUBI_IMMI0_ECXREGI:    return NULL;
  case _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI:    return NULL;
  case _SUBI_IMMI_32_ECXREGI:    return NULL;
  case _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI:    return NULL;
  case _URSHIFTI_RREGI_IMMI1:    return NULL;
  case _LSHIFTI_RREGI_IMMI_M1:    return NULL;
  case _URSHIFTI_NCXREGI_ECXREGI:    return NULL;
  case _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI:    return NULL;
  case _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI:    return NULL;
  case _XORI__LOADI_MEMORY__RREGI:    return NULL;
  case _XORI_RREGI__LOADI_MEMORY_:    return NULL;
  case _XORI__LOADI_MEMORY__IMMI:    return NULL;
  case _CMPLTMASK_RREGI_RREGI:    return NULL;
  case _ANDI__CMPLTMASK_RREGI_RREGI_RREGI:    return NULL;
  case _SUBI_RREGI_RREGI:    return NULL;
  case _ANDI_RREGI__CMPLTMASK_RREGI_RREGI:    return NULL;
  case _LOADL_LOAD_LONG_MEMORY_:    return NULL;
  case _XORL_EREGL_IMML_M1:    return NULL;
  case _SUBL_IMML0_EREGL:    return NULL;
  case _SUBL_IMML0__LOADL_MEMORY_:    return NULL;
  case _ADDL_EREGL_IMML_M1:    return NULL;
  case _ADDL__LOADL_MEMORY__IMML_M1:    return NULL;
  case _LOADD_MEMORY_:    return NULL;
  case _SUBD_REGDPR_REGDPR:    return NULL;
  case _ADDD_REGDPR_REGDPR:    return NULL;
  case _ADDD__LOADD_MEMORY__REGDPR:    return NULL;
  case _ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_:    return NULL;
  case _ADDD_REGDPR__LOADD_MEMORY_:    return NULL;
  case _ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__:    return NULL;
  case _ADDD_REGDPR_IMMDPR:    return NULL;
  case _MULD_REGDPR_REGDPR:    return NULL;
  case _DIVD_REGDPR_REGDPR:    return NULL;
  case _LOADF_MEMORY_:    return NULL;
  case _MULF__LOADF_MEMORY__REGFPR:    return NULL;
  case _MULF_REGFPR__LOADF_MEMORY_:    return NULL;
  case _MULF_REGFPR_REGFPR:    return NULL;
  case _SUBF_REGFPR_REGFPR:    return NULL;
  case _CONVI2L_RREGI_:    return NULL;
  case _BINARY_EDIREGP_ECXREGI:    return NULL;
  case _BINARY_ESIREGP_EDXREGI:    return NULL;
  case _BINARY_EDIREGP_ESIREGP:    return NULL;
  case _BINARY_EDIREGP_EDXREGI:    return NULL;
  case _BINARY_ESIREGP_IMMI:    return NULL;
  case _BINARY_ESIREGP_EAXREGI:    return NULL;
  case _ANDI_RREGI_IMMI:    return NULL;
  case _ANDI_RREGI_MEMORY:    return NULL;
  case _LOADP_MEMORY_:    return NULL;
  case _BINARY_NADXREGI_EAXREGI:    return NULL;
  case _PARTIALSUBTYPECHECK_ESIREGP_EAXREGP:    return NULL;
  case _BINARY_CMPOP_FLAGSREG_LONG_LTGE:    return NULL;
  case _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_:    return NULL;
  case _BINARY_CMPOP_FLAGSREG_LONG_EQNE:    return NULL;
  case _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT:    return NULL;
  case _LOADVECTOR_MEMORY_:    return NULL;
  case _BINARY_CMPOP_VCMPPD_IMMI8:    return NULL;
  case _BINARY_LEGVECY_LEGVECY:    return NULL;
  case _BINARY_VECX_VECX:    return NULL;
  case _BINARY_VECX__LOADVECTOR_MEMORY_:    return NULL;
  case _BINARY_VECY_VECY:    return NULL;
  case _BINARY_VECY__LOADVECTOR_MEMORY_:    return NULL;
  case _BINARY_VECZ_VECZ:    return NULL;
  case _BINARY_VECZ__LOADVECTOR_MEMORY_:    return NULL;
  case _MULADDVS2VI_VECD_VECD:    return NULL;
  case _MULADDVS2VI_VECX_VECX:    return NULL;
  case _MULADDVS2VI_VECY_VECY:    return NULL;
  case _MULADDVS2VI_VECZ_VECZ:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode){
  switch(opcode) {
  case bytes_reverse_int_rule: {
      bytes_reverse_intNode *node = new bytes_reverse_intNode();
      return node;
    }
  case bytes_reverse_long_rule: {
      bytes_reverse_longNode *node = new bytes_reverse_longNode();
      return node;
    }
  case bytes_reverse_unsigned_short_rule: {
      bytes_reverse_unsigned_shortNode *node = new bytes_reverse_unsigned_shortNode();
      return node;
    }
  case bytes_reverse_short_rule: {
      bytes_reverse_shortNode *node = new bytes_reverse_shortNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosI_bsr_rule: {
      countLeadingZerosI_bsrNode *node = new countLeadingZerosI_bsrNode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new countLeadingZerosLNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      return node;
    }
  case countLeadingZerosL_bsr_rule: {
      countLeadingZerosL_bsrNode *node = new countLeadingZerosL_bsrNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      return node;
    }
  case countTrailingZerosI_rule: {
      countTrailingZerosINode *node = new countTrailingZerosINode();
      return node;
    }
  case countTrailingZerosI_bsf_rule: {
      countTrailingZerosI_bsfNode *node = new countTrailingZerosI_bsfNode();
      return node;
    }
  case countTrailingZerosL_rule: {
      countTrailingZerosLNode *node = new countTrailingZerosLNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      return node;
    }
  case countTrailingZerosL_bsf_rule: {
      countTrailingZerosL_bsfNode *node = new countTrailingZerosL_bsfNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      return node;
    }
  case popCountI_rule: {
      popCountINode *node = new popCountINode();
      return node;
    }
  case popCountI_mem_rule: {
      popCountI_memNode *node = new popCountI_memNode();
      return node;
    }
  case popCountL_rule: {
      popCountLNode *node = new popCountLNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case popCountL_mem_rule: {
      popCountL_memNode *node = new popCountL_memNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case loadB_rule: {
      loadBNode *node = new loadBNode();
      return node;
    }
  case loadB2L_rule: {
      loadB2LNode *node = new loadB2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new loadUBNode();
      return node;
    }
  case loadUB2L_rule: {
      loadUB2LNode *node = new loadUB2LNode();
      return node;
    }
  case loadUB2L_immI_rule: {
      loadUB2L_immINode *node = new loadUB2L_immINode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new loadSNode();
      return node;
    }
  case loadS2B_rule: {
      loadS2BNode *node = new loadS2BNode();
      return node;
    }
  case loadS2L_rule: {
      loadS2LNode *node = new loadS2LNode();
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new loadUSNode();
      return node;
    }
  case loadUS2B_rule: {
      loadUS2BNode *node = new loadUS2BNode();
      return node;
    }
  case loadUS2L_rule: {
      loadUS2LNode *node = new loadUS2LNode();
      return node;
    }
  case loadUS2L_immI_255_rule: {
      loadUS2L_immI_255Node *node = new loadUS2L_immI_255Node();
      return node;
    }
  case loadUS2L_immI_rule: {
      loadUS2L_immINode *node = new loadUS2L_immINode();
      return node;
    }
  case loadI_rule: {
      loadINode *node = new loadINode();
      return node;
    }
  case loadI2B_rule: {
      loadI2BNode *node = new loadI2BNode();
      return node;
    }
  case loadI2UB_rule: {
      loadI2UBNode *node = new loadI2UBNode();
      return node;
    }
  case loadI2S_rule: {
      loadI2SNode *node = new loadI2SNode();
      return node;
    }
  case loadI2US_rule: {
      loadI2USNode *node = new loadI2USNode();
      return node;
    }
  case loadI2L_rule: {
      loadI2LNode *node = new loadI2LNode();
      return node;
    }
  case loadI2L_immI_255_rule: {
      loadI2L_immI_255Node *node = new loadI2L_immI_255Node();
      return node;
    }
  case loadI2L_immI_65535_rule: {
      loadI2L_immI_65535Node *node = new loadI2L_immI_65535Node();
      return node;
    }
  case loadI2L_immU31_rule: {
      loadI2L_immU31Node *node = new loadI2L_immU31Node();
      return node;
    }
  case loadUI2L_rule: {
      loadUI2LNode *node = new loadUI2LNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new loadLNode();
      return node;
    }
  case loadL_volatile_rule: {
      loadL_volatileNode *node = new loadL_volatileNode();
      return node;
    }
  case loadLX_volatile_rule: {
      loadLX_volatileNode *node = new loadLX_volatileNode();
      node->set_opnd_array(2, MachOperGenerator(REGD));
      return node;
    }
  case loadLX_reg_volatile_rule: {
      loadLX_reg_volatileNode *node = new loadLX_reg_volatileNode();
      node->set_opnd_array(2, MachOperGenerator(REGD));
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new loadRangeNode();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadDPR_rule: {
      loadDPRNode *node = new loadDPRNode();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new loadDNode();
      return node;
    }
  case loadD_partial_rule: {
      loadD_partialNode *node = new loadD_partialNode();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new loadFNode();
      return node;
    }
  case loadFPR_rule: {
      loadFPRNode *node = new loadFPRNode();
      return node;
    }
  case leaP8_rule: {
      leaP8Node *node = new leaP8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaP32_rule: {
      leaP32Node *node = new leaP32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxOff_rule: {
      leaPIdxOffNode *node = new leaPIdxOffNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxScale_rule: {
      leaPIdxScaleNode *node = new leaPIdxScaleNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxScaleOff_rule: {
      leaPIdxScaleOffNode *node = new leaPIdxScaleOffNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new loadConINode();
      node->_opnd_array[1] = new immIOper(_leaf->get_int() );
      return node;
    }
  case loadConI0_rule: {
      loadConI0Node *node = new loadConI0Node();
      return node;
    }
  case loadConP_rule: {
      loadConPNode *node = new loadConPNode();
      node->_opnd_array[1] = new immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConL_rule: {
      loadConLNode *node = new loadConLNode();
      return node;
    }
  case loadConL0_rule: {
      loadConL0Node *node = new loadConL0Node();
      return node;
    }
  case loadConFPR_rule: {
      loadConFPRNode *node = new loadConFPRNode();
      node->_opnd_array[1] = new immFPROper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConFPR0_rule: {
      loadConFPR0Node *node = new loadConFPR0Node();
      node->_opnd_array[1] = new immFPR0Oper(_leaf->getf() );
      return node;
    }
  case loadConFPR1_rule: {
      loadConFPR1Node *node = new loadConFPR1Node();
      node->_opnd_array[1] = new immFPR1Oper(_leaf->getf() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new loadConFNode();
      node->_opnd_array[1] = new immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConF0_rule: {
      loadConF0Node *node = new loadConF0Node();
      node->_opnd_array[1] = new immF0Oper(_leaf->getf() );
      return node;
    }
  case loadConDPR_rule: {
      loadConDPRNode *node = new loadConDPRNode();
      node->_opnd_array[1] = new immDPROper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConDPR0_rule: {
      loadConDPR0Node *node = new loadConDPR0Node();
      node->_opnd_array[1] = new immDPR0Oper(_leaf->getd() );
      return node;
    }
  case loadConDPR1_rule: {
      loadConDPR1Node *node = new loadConDPR1Node();
      node->_opnd_array[1] = new immDPR1Oper(_leaf->getd() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new loadConDNode();
      node->_opnd_array[1] = new immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD0_rule: {
      loadConD0Node *node = new loadConD0Node();
      node->_opnd_array[1] = new immD0Oper(_leaf->getd() );
      return node;
    }
  case loadSSI_rule: {
      loadSSINode *node = new loadSSINode();
      return node;
    }
  case loadSSL_rule: {
      loadSSLNode *node = new loadSSLNode();
      return node;
    }
  case loadSSP_rule: {
      loadSSPNode *node = new loadSSPNode();
      return node;
    }
  case loadSSF_rule: {
      loadSSFNode *node = new loadSSFNode();
      return node;
    }
  case loadSSD_rule: {
      loadSSDNode *node = new loadSSDNode();
      return node;
    }
  case prefetchAlloc0_rule: {
      prefetchAlloc0Node *node = new prefetchAlloc0Node();
      return node;
    }
  case prefetchAlloc_rule: {
      prefetchAllocNode *node = new prefetchAllocNode();
      return node;
    }
  case prefetchAllocNTA_rule: {
      prefetchAllocNTANode *node = new prefetchAllocNTANode();
      return node;
    }
  case prefetchAllocT0_rule: {
      prefetchAllocT0Node *node = new prefetchAllocT0Node();
      return node;
    }
  case prefetchAllocT2_rule: {
      prefetchAllocT2Node *node = new prefetchAllocT2Node();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_rule: {
      storeLNode *node = new storeLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL2I_rule: {
      storeL2INode *node = new storeL2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_volatile_rule: {
      storeL_volatileNode *node = new storeL_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeLX_volatile_rule: {
      storeLX_volatileNode *node = new storeLX_volatileNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeLX_reg_volatile_rule: {
      storeLX_reg_volatileNode *node = new storeLX_reg_volatileNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(REGD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmI_rule: {
      storeImmINode *node = new storeImmINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmI16_rule: {
      storeImmI16Node *node = new storeImmI16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmP_rule: {
      storeImmPNode *node = new storeImmPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmB_rule: {
      storeImmBNode *node = new storeImmBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmCM_rule: {
      storeImmCMNode *node = new storeImmCMNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeDPR_rule: {
      storeDPRNode *node = new storeDPRNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeDPR_rounded_rule: {
      storeDPR_roundedNode *node = new storeDPR_roundedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_rule: {
      storeDNode *node = new storeDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveD2VL_rule: {
      MoveD2VLNode *node = new MoveD2VLNode();
      return node;
    }
  case MoveVL2D_rule: {
      MoveVL2DNode *node = new MoveVL2DNode();
      return node;
    }
  case storeF_rule: {
      storeFNode *node = new storeFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveF2VL_rule: {
      MoveF2VLNode *node = new MoveF2VLNode();
      return node;
    }
  case MoveVL2F_rule: {
      MoveVL2FNode *node = new MoveVL2FNode();
      return node;
    }
  case storeFPR_rule: {
      storeFPRNode *node = new storeFPRNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_rounded_rule: {
      storeFPR_roundedNode *node = new storeFPR_roundedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_Drounded_rule: {
      storeFPR_DroundedNode *node = new storeFPR_DroundedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_imm_rule: {
      storeFPR_immNode *node = new storeFPR_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_imm_rule: {
      storeF_immNode *node = new storeF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeSSI_rule: {
      storeSSINode *node = new storeSSINode();
      return node;
    }
  case storeSSP_rule: {
      storeSSPNode *node = new storeSSPNode();
      return node;
    }
  case storeSSL_rule: {
      storeSSLNode *node = new storeSSLNode();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new membar_acquireNode();
      return node;
    }
  case membar_acquire_0_rule: {
      membar_acquire_0Node *node = new membar_acquire_0Node();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new membar_acquire_lockNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new membar_releaseNode();
      return node;
    }
  case membar_release_0_rule: {
      membar_release_0Node *node = new membar_release_0Node();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new membar_release_lockNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new membar_volatileNode();
      node->set_opnd_array(1, MachOperGenerator(EFLAGSREG));
      return node;
    }
  case unnecessary_membar_volatile_rule: {
      unnecessary_membar_volatileNode *node = new unnecessary_membar_volatileNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new membar_storestoreNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new castP2XNode();
      return node;
    }
  case jmovI_reg_rule: {
      jmovI_regNode *node = new jmovI_regNode();
      return node;
    }
  case jmovI_regU_rule: {
      jmovI_regUNode *node = new jmovI_regUNode();
      return node;
    }
  case cmovI_reg_rule: {
      cmovI_regNode *node = new cmovI_regNode();
      return node;
    }
  case cmovI_regU_rule: {
      cmovI_regUNode *node = new cmovI_regUNode();
      return node;
    }
  case cmovI_regUCF_rule: {
      cmovI_regUCFNode *node = new cmovI_regUCFNode();
      return node;
    }
  case cmovI_mem_rule: {
      cmovI_memNode *node = new cmovI_memNode();
      return node;
    }
  case cmovI_memU_rule: {
      cmovI_memUNode *node = new cmovI_memUNode();
      return node;
    }
  case cmovI_memUCF_rule: {
      cmovI_memUCFNode *node = new cmovI_memUCFNode();
      return node;
    }
  case cmovP_reg_rule: {
      cmovP_regNode *node = new cmovP_regNode();
      return node;
    }
  case cmovP_reg_nonP6_rule: {
      cmovP_reg_nonP6Node *node = new cmovP_reg_nonP6Node();
      return node;
    }
  case cmovP_regU_rule: {
      cmovP_regUNode *node = new cmovP_regUNode();
      return node;
    }
  case cmovP_regUCF_rule: {
      cmovP_regUCFNode *node = new cmovP_regUCFNode();
      return node;
    }
  case fcmovDPR_regU_rule: {
      fcmovDPR_regUNode *node = new fcmovDPR_regUNode();
      return node;
    }
  case fcmovFPR_regU_rule: {
      fcmovFPR_regUNode *node = new fcmovFPR_regUNode();
      return node;
    }
  case fcmovDPR_regS_rule: {
      fcmovDPR_regSNode *node = new fcmovDPR_regSNode();
      return node;
    }
  case fcmovFPR_regS_rule: {
      fcmovFPR_regSNode *node = new fcmovFPR_regSNode();
      return node;
    }
  case fcmovF_regS_rule: {
      fcmovF_regSNode *node = new fcmovF_regSNode();
      return node;
    }
  case fcmovD_regS_rule: {
      fcmovD_regSNode *node = new fcmovD_regSNode();
      return node;
    }
  case fcmovF_regU_rule: {
      fcmovF_regUNode *node = new fcmovF_regUNode();
      return node;
    }
  case fcmovF_regUCF_rule: {
      fcmovF_regUCFNode *node = new fcmovF_regUCFNode();
      return node;
    }
  case fcmovD_regU_rule: {
      fcmovD_regUNode *node = new fcmovD_regUNode();
      return node;
    }
  case fcmovD_regUCF_rule: {
      fcmovD_regUCFNode *node = new fcmovD_regUCFNode();
      return node;
    }
  case cmovL_reg_rule: {
      cmovL_regNode *node = new cmovL_regNode();
      return node;
    }
  case cmovL_regU_rule: {
      cmovL_regUNode *node = new cmovL_regUNode();
      return node;
    }
  case cmovL_regUCF_rule: {
      cmovL_regUCFNode *node = new cmovL_regUCFNode();
      return node;
    }
  case addI_eReg_rule: {
      addI_eRegNode *node = new addI_eRegNode();
      return node;
    }
  case addI_eReg_imm_rule: {
      addI_eReg_immNode *node = new addI_eReg_immNode();
      return node;
    }
  case incI_eReg_rule: {
      incI_eRegNode *node = new incI_eRegNode();
      return node;
    }
  case leaI_eReg_immI_rule: {
      leaI_eReg_immINode *node = new leaI_eReg_immINode();
      return node;
    }
  case leaP_eReg_immI_rule: {
      leaP_eReg_immINode *node = new leaP_eReg_immINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decI_eReg_rule: {
      decI_eRegNode *node = new decI_eRegNode();
      return node;
    }
  case addP_eReg_rule: {
      addP_eRegNode *node = new addP_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_eReg_imm_rule: {
      addP_eReg_immNode *node = new addP_eReg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_eReg_mem_rule: {
      addI_eReg_memNode *node = new addI_eReg_memNode();
      return node;
    }
  case addI_eReg_mem_0_rule: {
      addI_eReg_mem_0Node *node = new addI_eReg_mem_0Node();
      return node;
    }
  case addI_mem_eReg_rule: {
      addI_mem_eRegNode *node = new addI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_mem_eReg_0_rule: {
      addI_mem_eReg_0Node *node = new addI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_mem_imm_rule: {
      addI_mem_immNode *node = new addI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case incI_mem_rule: {
      incI_memNode *node = new incI_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decI_mem_rule: {
      decI_memNode *node = new decI_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new castIINode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new storePConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new storeIConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new storeLConditionalNode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new compareAndSwapLNode();
      return node;
    }
  case compareAndSwapL_0_rule: {
      compareAndSwapL_0Node *node = new compareAndSwapL_0Node();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new compareAndSwapPNode();
      return node;
    }
  case compareAndSwapP_0_rule: {
      compareAndSwapP_0Node *node = new compareAndSwapP_0Node();
      return node;
    }
  case compareAndSwapB_rule: {
      compareAndSwapBNode *node = new compareAndSwapBNode();
      return node;
    }
  case compareAndSwapB_0_rule: {
      compareAndSwapB_0Node *node = new compareAndSwapB_0Node();
      return node;
    }
  case compareAndSwapS_rule: {
      compareAndSwapSNode *node = new compareAndSwapSNode();
      return node;
    }
  case compareAndSwapS_0_rule: {
      compareAndSwapS_0Node *node = new compareAndSwapS_0Node();
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new compareAndSwapINode();
      return node;
    }
  case compareAndSwapI_0_rule: {
      compareAndSwapI_0Node *node = new compareAndSwapI_0Node();
      return node;
    }
  case compareAndExchangeL_rule: {
      compareAndExchangeLNode *node = new compareAndExchangeLNode();
      return node;
    }
  case compareAndExchangeP_rule: {
      compareAndExchangePNode *node = new compareAndExchangePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeB_rule: {
      compareAndExchangeBNode *node = new compareAndExchangeBNode();
      return node;
    }
  case compareAndExchangeS_rule: {
      compareAndExchangeSNode *node = new compareAndExchangeSNode();
      return node;
    }
  case compareAndExchangeI_rule: {
      compareAndExchangeINode *node = new compareAndExchangeINode();
      return node;
    }
  case xaddB_no_res_rule: {
      xaddB_no_resNode *node = new xaddB_no_resNode();
      return node;
    }
  case xaddB_rule: {
      xaddBNode *node = new xaddBNode();
      return node;
    }
  case xaddS_no_res_rule: {
      xaddS_no_resNode *node = new xaddS_no_resNode();
      return node;
    }
  case xaddS_rule: {
      xaddSNode *node = new xaddSNode();
      return node;
    }
  case xaddI_no_res_rule: {
      xaddI_no_resNode *node = new xaddI_no_resNode();
      return node;
    }
  case xaddI_rule: {
      xaddINode *node = new xaddINode();
      return node;
    }
  case xchgB_rule: {
      xchgBNode *node = new xchgBNode();
      return node;
    }
  case xchgS_rule: {
      xchgSNode *node = new xchgSNode();
      return node;
    }
  case xchgI_rule: {
      xchgINode *node = new xchgINode();
      return node;
    }
  case xchgP_rule: {
      xchgPNode *node = new xchgPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subI_eReg_rule: {
      subI_eRegNode *node = new subI_eRegNode();
      return node;
    }
  case subI_eReg_imm_rule: {
      subI_eReg_immNode *node = new subI_eReg_immNode();
      return node;
    }
  case subI_eReg_mem_rule: {
      subI_eReg_memNode *node = new subI_eReg_memNode();
      return node;
    }
  case subI_mem_eReg_rule: {
      subI_mem_eRegNode *node = new subI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subP_eReg_rule: {
      subP_eRegNode *node = new subP_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case negI_eReg_rule: {
      negI_eRegNode *node = new negI_eRegNode();
      return node;
    }
  case mulI_eReg_rule: {
      mulI_eRegNode *node = new mulI_eRegNode();
      return node;
    }
  case mulI_eReg_imm_rule: {
      mulI_eReg_immNode *node = new mulI_eReg_immNode();
      return node;
    }
  case loadConL_low_only_rule: {
      loadConL_low_onlyNode *node = new loadConL_low_onlyNode();
      return node;
    }
  case mulI_imm_high_rule: {
      mulI_imm_highNode *node = new mulI_imm_highNode();
      return node;
    }
  case mulI_imm_high_0_rule: {
      mulI_imm_high_0Node *node = new mulI_imm_high_0Node();
      return node;
    }
  case mulI_imm_RShift_high_rule: {
      mulI_imm_RShift_highNode *node = new mulI_imm_RShift_highNode();
      return node;
    }
  case mulI_imm_RShift_high_0_rule: {
      mulI_imm_RShift_high_0Node *node = new mulI_imm_RShift_high_0Node();
      return node;
    }
  case mulI_mem_imm_rule: {
      mulI_mem_immNode *node = new mulI_mem_immNode();
      return node;
    }
  case mulI_rule: {
      mulINode *node = new mulINode();
      return node;
    }
  case mulI_0_rule: {
      mulI_0Node *node = new mulI_0Node();
      return node;
    }
  case mulAddS2I_rReg_rule: {
      mulAddS2I_rRegNode *node = new mulAddS2I_rRegNode();
      return node;
    }
  case mulI2L_rule: {
      mulI2LNode *node = new mulI2LNode();
      return node;
    }
  case mulI2L_0_rule: {
      mulI2L_0Node *node = new mulI2L_0Node();
      return node;
    }
  case mulIS_eReg_rule: {
      mulIS_eRegNode *node = new mulIS_eRegNode();
      return node;
    }
  case mulIS_eReg_0_rule: {
      mulIS_eReg_0Node *node = new mulIS_eReg_0Node();
      return node;
    }
  case mulL_eReg_rule: {
      mulL_eRegNode *node = new mulL_eRegNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case mulL_eReg_lhi0_rule: {
      mulL_eReg_lhi0Node *node = new mulL_eReg_lhi0Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case mulL_eReg_rhi0_rule: {
      mulL_eReg_rhi0Node *node = new mulL_eReg_rhi0Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case mulL_eReg_hi0_rule: {
      mulL_eReg_hi0Node *node = new mulL_eReg_hi0Node();
      return node;
    }
  case mulL_eReg_con_rule: {
      mulL_eReg_conNode *node = new mulL_eReg_conNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case divI_eReg_rule: {
      divI_eRegNode *node = new divI_eRegNode();
      return node;
    }
  case divL_eReg_rule: {
      divL_eRegNode *node = new divL_eRegNode();
      return node;
    }
  case divModI_eReg_divmod_rule: {
      divModI_eReg_divmodNode *node = new divModI_eReg_divmodNode();
      return node;
    }
  case modI_eReg_rule: {
      modI_eRegNode *node = new modI_eRegNode();
      return node;
    }
  case modL_eReg_rule: {
      modL_eRegNode *node = new modL_eRegNode();
      return node;
    }
  case divL_eReg_imm32_rule: {
      divL_eReg_imm32Node *node = new divL_eReg_imm32Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      node->set_opnd_array(4, MachOperGenerator(RREGI));
      return node;
    }
  case modL_eReg_imm32_rule: {
      modL_eReg_imm32Node *node = new modL_eReg_imm32Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      node->set_opnd_array(4, MachOperGenerator(RREGI));
      return node;
    }
  case shlI_eReg_1_rule: {
      shlI_eReg_1Node *node = new shlI_eReg_1Node();
      return node;
    }
  case salI_eReg_imm_rule: {
      salI_eReg_immNode *node = new salI_eReg_immNode();
      return node;
    }
  case salI_eReg_CL_rule: {
      salI_eReg_CLNode *node = new salI_eReg_CLNode();
      return node;
    }
  case sarI_eReg_1_rule: {
      sarI_eReg_1Node *node = new sarI_eReg_1Node();
      return node;
    }
  case sarI_mem_1_rule: {
      sarI_mem_1Node *node = new sarI_mem_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sarI_eReg_imm_rule: {
      sarI_eReg_immNode *node = new sarI_eReg_immNode();
      return node;
    }
  case sarI_mem_imm_rule: {
      sarI_mem_immNode *node = new sarI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sarI_eReg_CL_rule: {
      sarI_eReg_CLNode *node = new sarI_eReg_CLNode();
      return node;
    }
  case shrI_eReg_1_rule: {
      shrI_eReg_1Node *node = new shrI_eReg_1Node();
      return node;
    }
  case shrI_eReg_imm_rule: {
      shrI_eReg_immNode *node = new shrI_eReg_immNode();
      return node;
    }
  case i2b_rule: {
      i2bNode *node = new i2bNode();
      return node;
    }
  case i2s_rule: {
      i2sNode *node = new i2sNode();
      return node;
    }
  case shrI_eReg_CL_rule: {
      shrI_eReg_CLNode *node = new shrI_eReg_CLNode();
      return node;
    }
  case andI_eReg_rule: {
      andI_eRegNode *node = new andI_eRegNode();
      return node;
    }
  case andI_eReg_imm_rule: {
      andI_eReg_immNode *node = new andI_eReg_immNode();
      return node;
    }
  case andI_eReg_mem_rule: {
      andI_eReg_memNode *node = new andI_eReg_memNode();
      return node;
    }
  case andI_eReg_mem_0_rule: {
      andI_eReg_mem_0Node *node = new andI_eReg_mem_0Node();
      return node;
    }
  case andI_mem_eReg_rule: {
      andI_mem_eRegNode *node = new andI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andI_mem_eReg_0_rule: {
      andI_mem_eReg_0Node *node = new andI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andI_mem_imm_rule: {
      andI_mem_immNode *node = new andI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnI_rReg_rReg_rReg_rule: {
      andnI_rReg_rReg_rRegNode *node = new andnI_rReg_rReg_rRegNode();
      return node;
    }
  case andnI_rReg_rReg_rReg_0_rule: {
      andnI_rReg_rReg_rReg_0Node *node = new andnI_rReg_rReg_rReg_0Node();
      return node;
    }
  case andnI_rReg_rReg_mem_rule: {
      andnI_rReg_rReg_memNode *node = new andnI_rReg_rReg_memNode();
      return node;
    }
  case andnI_rReg_rReg_mem_0_rule: {
      andnI_rReg_rReg_mem_0Node *node = new andnI_rReg_rReg_mem_0Node();
      return node;
    }
  case blsiI_rReg_rReg_rule: {
      blsiI_rReg_rRegNode *node = new blsiI_rReg_rRegNode();
      return node;
    }
  case blsiI_rReg_rReg_0_rule: {
      blsiI_rReg_rReg_0Node *node = new blsiI_rReg_rReg_0Node();
      return node;
    }
  case blsiI_rReg_mem_rule: {
      blsiI_rReg_memNode *node = new blsiI_rReg_memNode();
      return node;
    }
  case blsiI_rReg_mem_0_rule: {
      blsiI_rReg_mem_0Node *node = new blsiI_rReg_mem_0Node();
      return node;
    }
  case blsmskI_rReg_rReg_rule: {
      blsmskI_rReg_rRegNode *node = new blsmskI_rReg_rRegNode();
      return node;
    }
  case blsmskI_rReg_rReg_0_rule: {
      blsmskI_rReg_rReg_0Node *node = new blsmskI_rReg_rReg_0Node();
      return node;
    }
  case blsmskI_rReg_mem_rule: {
      blsmskI_rReg_memNode *node = new blsmskI_rReg_memNode();
      return node;
    }
  case blsmskI_rReg_mem_0_rule: {
      blsmskI_rReg_mem_0Node *node = new blsmskI_rReg_mem_0Node();
      return node;
    }
  case blsrI_rReg_rReg_rule: {
      blsrI_rReg_rRegNode *node = new blsrI_rReg_rRegNode();
      return node;
    }
  case blsrI_rReg_rReg_0_rule: {
      blsrI_rReg_rReg_0Node *node = new blsrI_rReg_rReg_0Node();
      return node;
    }
  case blsrI_rReg_mem_rule: {
      blsrI_rReg_memNode *node = new blsrI_rReg_memNode();
      return node;
    }
  case blsrI_rReg_mem_0_rule: {
      blsrI_rReg_mem_0Node *node = new blsrI_rReg_mem_0Node();
      return node;
    }
  case orI_eReg_rule: {
      orI_eRegNode *node = new orI_eRegNode();
      return node;
    }
  case orI_eReg_castP2X_rule: {
      orI_eReg_castP2XNode *node = new orI_eReg_castP2XNode();
      return node;
    }
  case orI_eReg_castP2X_0_rule: {
      orI_eReg_castP2X_0Node *node = new orI_eReg_castP2X_0Node();
      return node;
    }
  case orI_eReg_imm_rule: {
      orI_eReg_immNode *node = new orI_eReg_immNode();
      return node;
    }
  case orI_eReg_mem_rule: {
      orI_eReg_memNode *node = new orI_eReg_memNode();
      return node;
    }
  case orI_eReg_mem_0_rule: {
      orI_eReg_mem_0Node *node = new orI_eReg_mem_0Node();
      return node;
    }
  case orI_mem_eReg_rule: {
      orI_mem_eRegNode *node = new orI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case orI_mem_eReg_0_rule: {
      orI_mem_eReg_0Node *node = new orI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case orI_mem_imm_rule: {
      orI_mem_immNode *node = new orI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rolI_eReg_i1_rule: {
      rolI_eReg_i1Node *node = new rolI_eReg_i1Node();
      return node;
    }
  case rolI_eReg_i1_0_rule: {
      rolI_eReg_i1_0Node *node = new rolI_eReg_i1_0Node();
      return node;
    }
  case rolI_eReg_i8_rule: {
      rolI_eReg_i8Node *node = new rolI_eReg_i8Node();
      return node;
    }
  case rolI_eReg_i8_0_rule: {
      rolI_eReg_i8_0Node *node = new rolI_eReg_i8_0Node();
      return node;
    }
  case rolI_eReg_Var_C0_rule: {
      rolI_eReg_Var_C0Node *node = new rolI_eReg_Var_C0Node();
      return node;
    }
  case rolI_eReg_Var_C0_0_rule: {
      rolI_eReg_Var_C0_0Node *node = new rolI_eReg_Var_C0_0Node();
      return node;
    }
  case rolI_eReg_Var_C32_rule: {
      rolI_eReg_Var_C32Node *node = new rolI_eReg_Var_C32Node();
      return node;
    }
  case rolI_eReg_Var_C32_0_rule: {
      rolI_eReg_Var_C32_0Node *node = new rolI_eReg_Var_C32_0Node();
      return node;
    }
  case rorI_eReg_i1_rule: {
      rorI_eReg_i1Node *node = new rorI_eReg_i1Node();
      return node;
    }
  case rorI_eReg_i1_0_rule: {
      rorI_eReg_i1_0Node *node = new rorI_eReg_i1_0Node();
      return node;
    }
  case rorI_eReg_i8_rule: {
      rorI_eReg_i8Node *node = new rorI_eReg_i8Node();
      return node;
    }
  case rorI_eReg_i8_0_rule: {
      rorI_eReg_i8_0Node *node = new rorI_eReg_i8_0Node();
      return node;
    }
  case rorI_eReg_Var_C0_rule: {
      rorI_eReg_Var_C0Node *node = new rorI_eReg_Var_C0Node();
      return node;
    }
  case rorI_eReg_Var_C0_0_rule: {
      rorI_eReg_Var_C0_0Node *node = new rorI_eReg_Var_C0_0Node();
      return node;
    }
  case rorI_eReg_Var_C32_rule: {
      rorI_eReg_Var_C32Node *node = new rorI_eReg_Var_C32Node();
      return node;
    }
  case rorI_eReg_Var_C32_0_rule: {
      rorI_eReg_Var_C32_0Node *node = new rorI_eReg_Var_C32_0Node();
      return node;
    }
  case xorI_eReg_rule: {
      xorI_eRegNode *node = new xorI_eRegNode();
      return node;
    }
  case xorI_eReg_im1_rule: {
      xorI_eReg_im1Node *node = new xorI_eReg_im1Node();
      return node;
    }
  case xorI_eReg_imm_rule: {
      xorI_eReg_immNode *node = new xorI_eReg_immNode();
      return node;
    }
  case xorI_eReg_mem_rule: {
      xorI_eReg_memNode *node = new xorI_eReg_memNode();
      return node;
    }
  case xorI_eReg_mem_0_rule: {
      xorI_eReg_mem_0Node *node = new xorI_eReg_mem_0Node();
      return node;
    }
  case xorI_mem_eReg_rule: {
      xorI_mem_eRegNode *node = new xorI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xorI_mem_eReg_0_rule: {
      xorI_mem_eReg_0Node *node = new xorI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xorI_mem_imm_rule: {
      xorI_mem_immNode *node = new xorI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case convI2B_rule: {
      convI2BNode *node = new convI2BNode();
      return node;
    }
  case convP2B_rule: {
      convP2BNode *node = new convP2BNode();
      return node;
    }
  case cmpLTMask_rule: {
      cmpLTMaskNode *node = new cmpLTMaskNode();
      return node;
    }
  case cmpLTMask0_rule: {
      cmpLTMask0Node *node = new cmpLTMask0Node();
      return node;
    }
  case cadd_cmpLTMask_rule: {
      cadd_cmpLTMaskNode *node = new cadd_cmpLTMaskNode();
      return node;
    }
  case cadd_cmpLTMask_1_rule: {
      cadd_cmpLTMask_1Node *node = new cadd_cmpLTMask_1Node();
      return node;
    }
  case cadd_cmpLTMask_0_rule: {
      cadd_cmpLTMask_0Node *node = new cadd_cmpLTMask_0Node();
      return node;
    }
  case cadd_cmpLTMask_2_rule: {
      cadd_cmpLTMask_2Node *node = new cadd_cmpLTMask_2Node();
      return node;
    }
  case and_cmpLTMask_rule: {
      and_cmpLTMaskNode *node = new and_cmpLTMaskNode();
      return node;
    }
  case and_cmpLTMask_0_rule: {
      and_cmpLTMask_0Node *node = new and_cmpLTMask_0Node();
      return node;
    }
  case overflowAddI_eReg_rule: {
      overflowAddI_eRegNode *node = new overflowAddI_eRegNode();
      return node;
    }
  case overflowAddI_rReg_imm_rule: {
      overflowAddI_rReg_immNode *node = new overflowAddI_rReg_immNode();
      return node;
    }
  case overflowSubI_rReg_rule: {
      overflowSubI_rRegNode *node = new overflowSubI_rRegNode();
      return node;
    }
  case overflowSubI_rReg_imm_rule: {
      overflowSubI_rReg_immNode *node = new overflowSubI_rReg_immNode();
      return node;
    }
  case overflowNegI_rReg_rule: {
      overflowNegI_rRegNode *node = new overflowNegI_rRegNode();
      return node;
    }
  case overflowMulI_rReg_rule: {
      overflowMulI_rRegNode *node = new overflowMulI_rRegNode();
      return node;
    }
  case overflowMulI_rReg_imm_rule: {
      overflowMulI_rReg_immNode *node = new overflowMulI_rReg_immNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case addL_eReg_rule: {
      addL_eRegNode *node = new addL_eRegNode();
      return node;
    }
  case addL_eReg_imm_rule: {
      addL_eReg_immNode *node = new addL_eReg_immNode();
      return node;
    }
  case addL_eReg_mem_rule: {
      addL_eReg_memNode *node = new addL_eReg_memNode();
      return node;
    }
  case addL_eReg_mem_0_rule: {
      addL_eReg_mem_0Node *node = new addL_eReg_mem_0Node();
      return node;
    }
  case subL_eReg_rule: {
      subL_eRegNode *node = new subL_eRegNode();
      return node;
    }
  case subL_eReg_imm_rule: {
      subL_eReg_immNode *node = new subL_eReg_immNode();
      return node;
    }
  case subL_eReg_mem_rule: {
      subL_eReg_memNode *node = new subL_eReg_memNode();
      return node;
    }
  case negL_eReg_rule: {
      negL_eRegNode *node = new negL_eRegNode();
      return node;
    }
  case andL_eReg_rule: {
      andL_eRegNode *node = new andL_eRegNode();
      return node;
    }
  case andL_eReg_imm_rule: {
      andL_eReg_immNode *node = new andL_eReg_immNode();
      return node;
    }
  case andL_eReg_mem_rule: {
      andL_eReg_memNode *node = new andL_eReg_memNode();
      return node;
    }
  case andL_eReg_mem_0_rule: {
      andL_eReg_mem_0Node *node = new andL_eReg_mem_0Node();
      return node;
    }
  case andnL_eReg_eReg_eReg_rule: {
      andnL_eReg_eReg_eRegNode *node = new andnL_eReg_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case andnL_eReg_eReg_eReg_0_rule: {
      andnL_eReg_eReg_eReg_0Node *node = new andnL_eReg_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case andnL_eReg_eReg_mem_rule: {
      andnL_eReg_eReg_memNode *node = new andnL_eReg_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case andnL_eReg_eReg_mem_0_rule: {
      andnL_eReg_eReg_mem_0Node *node = new andnL_eReg_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsiL_eReg_eReg_rule: {
      blsiL_eReg_eRegNode *node = new blsiL_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsiL_eReg_eReg_0_rule: {
      blsiL_eReg_eReg_0Node *node = new blsiL_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsiL_eReg_mem_rule: {
      blsiL_eReg_memNode *node = new blsiL_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsiL_eReg_mem_0_rule: {
      blsiL_eReg_mem_0Node *node = new blsiL_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsmskL_eReg_eReg_rule: {
      blsmskL_eReg_eRegNode *node = new blsmskL_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsmskL_eReg_eReg_0_rule: {
      blsmskL_eReg_eReg_0Node *node = new blsmskL_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsmskL_eReg_mem_rule: {
      blsmskL_eReg_memNode *node = new blsmskL_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsmskL_eReg_mem_0_rule: {
      blsmskL_eReg_mem_0Node *node = new blsmskL_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsrL_eReg_eReg_rule: {
      blsrL_eReg_eRegNode *node = new blsrL_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsrL_eReg_eReg_0_rule: {
      blsrL_eReg_eReg_0Node *node = new blsrL_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsrL_eReg_mem_rule: {
      blsrL_eReg_memNode *node = new blsrL_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case blsrL_eReg_mem_0_rule: {
      blsrL_eReg_mem_0Node *node = new blsrL_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL));
      return node;
    }
  case orl_eReg_rule: {
      orl_eRegNode *node = new orl_eRegNode();
      return node;
    }
  case orl_eReg_imm_rule: {
      orl_eReg_immNode *node = new orl_eReg_immNode();
      return node;
    }
  case orl_eReg_mem_rule: {
      orl_eReg_memNode *node = new orl_eReg_memNode();
      return node;
    }
  case orl_eReg_mem_0_rule: {
      orl_eReg_mem_0Node *node = new orl_eReg_mem_0Node();
      return node;
    }
  case xorl_eReg_rule: {
      xorl_eRegNode *node = new xorl_eRegNode();
      return node;
    }
  case xorl_eReg_im1_rule: {
      xorl_eReg_im1Node *node = new xorl_eReg_im1Node();
      return node;
    }
  case xorl_eReg_imm_rule: {
      xorl_eReg_immNode *node = new xorl_eReg_immNode();
      return node;
    }
  case xorl_eReg_mem_rule: {
      xorl_eReg_memNode *node = new xorl_eReg_memNode();
      return node;
    }
  case xorl_eReg_mem_0_rule: {
      xorl_eReg_mem_0Node *node = new xorl_eReg_mem_0Node();
      return node;
    }
  case shlL_eReg_1_rule: {
      shlL_eReg_1Node *node = new shlL_eReg_1Node();
      return node;
    }
  case shlL_eReg_2_rule: {
      shlL_eReg_2Node *node = new shlL_eReg_2Node();
      return node;
    }
  case shlL_eReg_3_rule: {
      shlL_eReg_3Node *node = new shlL_eReg_3Node();
      return node;
    }
  case shlL_eReg_1_31_rule: {
      shlL_eReg_1_31Node *node = new shlL_eReg_1_31Node();
      return node;
    }
  case shlL_eReg_32_63_rule: {
      shlL_eReg_32_63Node *node = new shlL_eReg_32_63Node();
      return node;
    }
  case salL_eReg_CL_rule: {
      salL_eReg_CLNode *node = new salL_eReg_CLNode();
      return node;
    }
  case shrL_eReg_1_31_rule: {
      shrL_eReg_1_31Node *node = new shrL_eReg_1_31Node();
      return node;
    }
  case shrL_eReg_32_63_rule: {
      shrL_eReg_32_63Node *node = new shrL_eReg_32_63Node();
      return node;
    }
  case shrL_eReg_CL_rule: {
      shrL_eReg_CLNode *node = new shrL_eReg_CLNode();
      return node;
    }
  case sarL_eReg_1_31_rule: {
      sarL_eReg_1_31Node *node = new sarL_eReg_1_31Node();
      return node;
    }
  case sarL_eReg_32_63_rule: {
      sarL_eReg_32_63Node *node = new sarL_eReg_32_63Node();
      return node;
    }
  case sarL_eReg_CL_rule: {
      sarL_eReg_CLNode *node = new sarL_eReg_CLNode();
      return node;
    }
  case cmpDPR_cc_P6_rule: {
      cmpDPR_cc_P6Node *node = new cmpDPR_cc_P6Node();
      return node;
    }
  case cmpDPR_cc_P6CF_rule: {
      cmpDPR_cc_P6CFNode *node = new cmpDPR_cc_P6CFNode();
      return node;
    }
  case cmpDPR_cc_rule: {
      cmpDPR_ccNode *node = new cmpDPR_ccNode();
      return node;
    }
  case cmpDPR_0_rule: {
      cmpDPR_0Node *node = new cmpDPR_0Node();
      return node;
    }
  case cmpDPR_reg_rule: {
      cmpDPR_regNode *node = new cmpDPR_regNode();
      return node;
    }
  case cmpD_cc_rule: {
      cmpD_ccNode *node = new cmpD_ccNode();
      return node;
    }
  case cmpD_ccCF_rule: {
      cmpD_ccCFNode *node = new cmpD_ccCFNode();
      return node;
    }
  case cmpD_ccmem_rule: {
      cmpD_ccmemNode *node = new cmpD_ccmemNode();
      return node;
    }
  case cmpD_ccmemCF_rule: {
      cmpD_ccmemCFNode *node = new cmpD_ccmemCFNode();
      return node;
    }
  case cmpD_reg_rule: {
      cmpD_regNode *node = new cmpD_regNode();
      return node;
    }
  case cmpD_regmem_rule: {
      cmpD_regmemNode *node = new cmpD_regmemNode();
      return node;
    }
  case subDPR_reg_rule: {
      subDPR_regNode *node = new subDPR_regNode();
      return node;
    }
  case subDPR_reg_round_rule: {
      subDPR_reg_roundNode *node = new subDPR_reg_roundNode();
      return node;
    }
  case subDPR_reg_mem_rule: {
      subDPR_reg_memNode *node = new subDPR_reg_memNode();
      return node;
    }
  case absDPR_reg_rule: {
      absDPR_regNode *node = new absDPR_regNode();
      return node;
    }
  case negDPR_reg_rule: {
      negDPR_regNode *node = new negDPR_regNode();
      return node;
    }
  case addDPR_reg_rule: {
      addDPR_regNode *node = new addDPR_regNode();
      return node;
    }
  case addDPR_reg_round_rule: {
      addDPR_reg_roundNode *node = new addDPR_reg_roundNode();
      return node;
    }
  case addDPR_reg_mem_rule: {
      addDPR_reg_memNode *node = new addDPR_reg_memNode();
      return node;
    }
  case addDPR_reg_mem_0_rule: {
      addDPR_reg_mem_0Node *node = new addDPR_reg_mem_0Node();
      return node;
    }
  case addDPR_mem_reg_rule: {
      addDPR_mem_regNode *node = new addDPR_mem_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addDPR_mem_reg_0_rule: {
      addDPR_mem_reg_0Node *node = new addDPR_mem_reg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addDPR_reg_imm1_rule: {
      addDPR_reg_imm1Node *node = new addDPR_reg_imm1Node();
      return node;
    }
  case addDPR_reg_imm_rule: {
      addDPR_reg_immNode *node = new addDPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addDPR_reg_imm_round_rule: {
      addDPR_reg_imm_roundNode *node = new addDPR_reg_imm_roundNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulDPR_reg_rule: {
      mulDPR_regNode *node = new mulDPR_regNode();
      return node;
    }
  case strictfp_mulDPR_reg_rule: {
      strictfp_mulDPR_regNode *node = new strictfp_mulDPR_regNode();
      return node;
    }
  case mulDPR_reg_imm_rule: {
      mulDPR_reg_immNode *node = new mulDPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulDPR_reg_mem_rule: {
      mulDPR_reg_memNode *node = new mulDPR_reg_memNode();
      return node;
    }
  case mulDPR_reg_mem_0_rule: {
      mulDPR_reg_mem_0Node *node = new mulDPR_reg_mem_0Node();
      return node;
    }
  case mulDPR_reg_mem_cisc_rule: {
      mulDPR_reg_mem_ciscNode *node = new mulDPR_reg_mem_ciscNode();
      return node;
    }
  case mulDPR_reg_mem_cisc_0_rule: {
      mulDPR_reg_mem_cisc_0Node *node = new mulDPR_reg_mem_cisc_0Node();
      return node;
    }
  case addDPR_mulDPR_reg_rule: {
      addDPR_mulDPR_regNode *node = new addDPR_mulDPR_regNode();
      return node;
    }
  case addDPR_mulDPR_reg_0_rule: {
      addDPR_mulDPR_reg_0Node *node = new addDPR_mulDPR_reg_0Node();
      return node;
    }
  case subDPR_mulDPR_reg_rule: {
      subDPR_mulDPR_regNode *node = new subDPR_mulDPR_regNode();
      return node;
    }
  case divDPR_reg_rule: {
      divDPR_regNode *node = new divDPR_regNode();
      return node;
    }
  case strictfp_divDPR_reg_rule: {
      strictfp_divDPR_regNode *node = new strictfp_divDPR_regNode();
      return node;
    }
  case divDPR_reg_round_rule: {
      divDPR_reg_roundNode *node = new divDPR_reg_roundNode();
      return node;
    }
  case modDPR_reg_rule: {
      modDPR_regNode *node = new modDPR_regNode();
      return node;
    }
  case modD_reg_rule: {
      modD_regNode *node = new modD_regNode();
      return node;
    }
  case atanDPR_reg_rule: {
      atanDPR_regNode *node = new atanDPR_regNode();
      return node;
    }
  case atanD_reg_rule: {
      atanD_regNode *node = new atanD_regNode();
      return node;
    }
  case sqrtDPR_reg_rule: {
      sqrtDPR_regNode *node = new sqrtDPR_regNode();
      return node;
    }
  case cmpFPR_cc_P6_rule: {
      cmpFPR_cc_P6Node *node = new cmpFPR_cc_P6Node();
      return node;
    }
  case cmpFPR_cc_P6CF_rule: {
      cmpFPR_cc_P6CFNode *node = new cmpFPR_cc_P6CFNode();
      return node;
    }
  case cmpFPR_cc_rule: {
      cmpFPR_ccNode *node = new cmpFPR_ccNode();
      return node;
    }
  case cmpFPR_0_rule: {
      cmpFPR_0Node *node = new cmpFPR_0Node();
      return node;
    }
  case cmpFPR_reg_rule: {
      cmpFPR_regNode *node = new cmpFPR_regNode();
      return node;
    }
  case cmpF_cc_rule: {
      cmpF_ccNode *node = new cmpF_ccNode();
      return node;
    }
  case cmpF_ccCF_rule: {
      cmpF_ccCFNode *node = new cmpF_ccCFNode();
      return node;
    }
  case cmpF_ccmem_rule: {
      cmpF_ccmemNode *node = new cmpF_ccmemNode();
      return node;
    }
  case cmpF_ccmemCF_rule: {
      cmpF_ccmemCFNode *node = new cmpF_ccmemCFNode();
      return node;
    }
  case cmpF_reg_rule: {
      cmpF_regNode *node = new cmpF_regNode();
      return node;
    }
  case cmpF_regmem_rule: {
      cmpF_regmemNode *node = new cmpF_regmemNode();
      return node;
    }
  case subFPR24_reg_rule: {
      subFPR24_regNode *node = new subFPR24_regNode();
      return node;
    }
  case subFPR_reg_rule: {
      subFPR_regNode *node = new subFPR_regNode();
      return node;
    }
  case addFPR24_reg_rule: {
      addFPR24_regNode *node = new addFPR24_regNode();
      return node;
    }
  case addFPR_reg_rule: {
      addFPR_regNode *node = new addFPR_regNode();
      return node;
    }
  case absFPR_reg_rule: {
      absFPR_regNode *node = new absFPR_regNode();
      return node;
    }
  case negFPR_reg_rule: {
      negFPR_regNode *node = new negFPR_regNode();
      return node;
    }
  case addFPR24_reg_mem_rule: {
      addFPR24_reg_memNode *node = new addFPR24_reg_memNode();
      return node;
    }
  case addFPR24_reg_mem_0_rule: {
      addFPR24_reg_mem_0Node *node = new addFPR24_reg_mem_0Node();
      return node;
    }
  case addFPR_reg_mem_rule: {
      addFPR_reg_memNode *node = new addFPR_reg_memNode();
      return node;
    }
  case addFPR_reg_mem_0_rule: {
      addFPR_reg_mem_0Node *node = new addFPR_reg_mem_0Node();
      return node;
    }
  case addFPR24_mem_reg_rule: {
      addFPR24_mem_regNode *node = new addFPR24_mem_regNode();
      return node;
    }
  case addFPR24_mem_cisc_rule: {
      addFPR24_mem_ciscNode *node = new addFPR24_mem_ciscNode();
      return node;
    }
  case addFPR24_mem_cisc_0_rule: {
      addFPR24_mem_cisc_0Node *node = new addFPR24_mem_cisc_0Node();
      return node;
    }
  case addFPR24_mem_mem_rule: {
      addFPR24_mem_memNode *node = new addFPR24_mem_memNode();
      return node;
    }
  case addFPR24_reg_imm_rule: {
      addFPR24_reg_immNode *node = new addFPR24_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addFPR_reg_imm_rule: {
      addFPR_reg_immNode *node = new addFPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulFPR24_reg_rule: {
      mulFPR24_regNode *node = new mulFPR24_regNode();
      return node;
    }
  case mulFPR_reg_rule: {
      mulFPR_regNode *node = new mulFPR_regNode();
      return node;
    }
  case mulFPR24_reg_mem_rule: {
      mulFPR24_reg_memNode *node = new mulFPR24_reg_memNode();
      return node;
    }
  case mulFPR24_reg_mem_0_rule: {
      mulFPR24_reg_mem_0Node *node = new mulFPR24_reg_mem_0Node();
      return node;
    }
  case mulFPR_reg_mem_rule: {
      mulFPR_reg_memNode *node = new mulFPR_reg_memNode();
      return node;
    }
  case mulFPR_reg_mem_0_rule: {
      mulFPR_reg_mem_0Node *node = new mulFPR_reg_mem_0Node();
      return node;
    }
  case mulFPR24_mem_mem_rule: {
      mulFPR24_mem_memNode *node = new mulFPR24_mem_memNode();
      return node;
    }
  case mulFPR24_reg_imm_rule: {
      mulFPR24_reg_immNode *node = new mulFPR24_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulFPR_reg_imm_rule: {
      mulFPR_reg_immNode *node = new mulFPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulFPR_reg_load1_rule: {
      mulFPR_reg_load1Node *node = new mulFPR_reg_load1Node();
      return node;
    }
  case mulFPR_reg_load1_0_rule: {
      mulFPR_reg_load1_0Node *node = new mulFPR_reg_load1_0Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_rule: {
      addFPR_mulFPR_reg_load1Node *node = new addFPR_mulFPR_reg_load1Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_1_rule: {
      addFPR_mulFPR_reg_load1_1Node *node = new addFPR_mulFPR_reg_load1_1Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_0_rule: {
      addFPR_mulFPR_reg_load1_0Node *node = new addFPR_mulFPR_reg_load1_0Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_2_rule: {
      addFPR_mulFPR_reg_load1_2Node *node = new addFPR_mulFPR_reg_load1_2Node();
      return node;
    }
  case addFPR_mulFPR_reg_rule: {
      addFPR_mulFPR_regNode *node = new addFPR_mulFPR_regNode();
      return node;
    }
  case addFPR_mulFPR_reg_0_rule: {
      addFPR_mulFPR_reg_0Node *node = new addFPR_mulFPR_reg_0Node();
      return node;
    }
  case subFPR_divFPR_reg_rule: {
      subFPR_divFPR_regNode *node = new subFPR_divFPR_regNode();
      return node;
    }
  case divFPR24_reg_rule: {
      divFPR24_regNode *node = new divFPR24_regNode();
      return node;
    }
  case divFPR_reg_rule: {
      divFPR_regNode *node = new divFPR_regNode();
      return node;
    }
  case modFPR24_reg_rule: {
      modFPR24_regNode *node = new modFPR24_regNode();
      return node;
    }
  case modFPR_reg_rule: {
      modFPR_regNode *node = new modFPR_regNode();
      return node;
    }
  case modF_reg_rule: {
      modF_regNode *node = new modF_regNode();
      return node;
    }
  case roundFloat_mem_reg_rule: {
      roundFloat_mem_regNode *node = new roundFloat_mem_regNode();
      return node;
    }
  case roundDouble_mem_reg_rule: {
      roundDouble_mem_regNode *node = new roundDouble_mem_regNode();
      return node;
    }
  case convDPR2FPR_reg_rule: {
      convDPR2FPR_regNode *node = new convDPR2FPR_regNode();
      return node;
    }
  case convDPR2F_reg_rule: {
      convDPR2F_regNode *node = new convDPR2F_regNode();
      return node;
    }
  case convD2F_reg_rule: {
      convD2F_regNode *node = new convD2F_regNode();
      return node;
    }
  case convFPR2DPR_reg_reg_rule: {
      convFPR2DPR_reg_regNode *node = new convFPR2DPR_reg_regNode();
      return node;
    }
  case convFPR2D_reg_rule: {
      convFPR2D_regNode *node = new convFPR2D_regNode();
      return node;
    }
  case convF2DPR_reg_rule: {
      convF2DPR_regNode *node = new convF2DPR_regNode();
      return node;
    }
  case convF2D_reg_rule: {
      convF2D_regNode *node = new convF2D_regNode();
      return node;
    }
  case convDPR2I_reg_reg_rule: {
      convDPR2I_reg_regNode *node = new convDPR2I_reg_regNode();
      return node;
    }
  case convD2I_reg_reg_rule: {
      convD2I_reg_regNode *node = new convD2I_reg_regNode();
      return node;
    }
  case convDPR2L_reg_reg_rule: {
      convDPR2L_reg_regNode *node = new convDPR2L_reg_regNode();
      return node;
    }
  case convD2L_reg_reg_rule: {
      convD2L_reg_regNode *node = new convD2L_reg_regNode();
      return node;
    }
  case convFPR2I_reg_reg_rule: {
      convFPR2I_reg_regNode *node = new convFPR2I_reg_regNode();
      return node;
    }
  case convF2I_reg_rule: {
      convF2I_regNode *node = new convF2I_regNode();
      return node;
    }
  case convFPR2L_reg_reg_rule: {
      convFPR2L_reg_regNode *node = new convFPR2L_reg_regNode();
      return node;
    }
  case convF2L_reg_reg_rule: {
      convF2L_reg_regNode *node = new convF2L_reg_regNode();
      return node;
    }
  case convI2DPR_reg_rule: {
      convI2DPR_regNode *node = new convI2DPR_regNode();
      return node;
    }
  case convI2D_reg_rule: {
      convI2D_regNode *node = new convI2D_regNode();
      return node;
    }
  case convI2D_mem_rule: {
      convI2D_memNode *node = new convI2D_memNode();
      return node;
    }
  case convXI2D_reg_rule: {
      convXI2D_regNode *node = new convXI2D_regNode();
      return node;
    }
  case convI2DPR_mem_rule: {
      convI2DPR_memNode *node = new convI2DPR_memNode();
      return node;
    }
  case conv24I2FPR_reg_rule: {
      conv24I2FPR_regNode *node = new conv24I2FPR_regNode();
      return node;
    }
  case convI2FPR_SSF_rule: {
      convI2FPR_SSFNode *node = new convI2FPR_SSFNode();
      return node;
    }
  case convI2FPR_SSF_mem_rule: {
      convI2FPR_SSF_memNode *node = new convI2FPR_SSF_memNode();
      return node;
    }
  case convI2FPR_reg_rule: {
      convI2FPR_regNode *node = new convI2FPR_regNode();
      return node;
    }
  case convI2FPR_mem_rule: {
      convI2FPR_memNode *node = new convI2FPR_memNode();
      return node;
    }
  case convI2F_reg_rule: {
      convI2F_regNode *node = new convI2F_regNode();
      return node;
    }
  case convXI2F_reg_rule: {
      convXI2F_regNode *node = new convXI2F_regNode();
      return node;
    }
  case convI2L_reg_rule: {
      convI2L_regNode *node = new convI2L_regNode();
      return node;
    }
  case convI2L_reg_zex_rule: {
      convI2L_reg_zexNode *node = new convI2L_reg_zexNode();
      return node;
    }
  case zerox_long_rule: {
      zerox_longNode *node = new zerox_longNode();
      return node;
    }
  case convL2DPR_reg_rule: {
      convL2DPR_regNode *node = new convL2DPR_regNode();
      return node;
    }
  case convL2D_reg_rule: {
      convL2D_regNode *node = new convL2D_regNode();
      return node;
    }
  case convL2F_reg_rule: {
      convL2F_regNode *node = new convL2F_regNode();
      return node;
    }
  case convL2FPR_reg_rule: {
      convL2FPR_regNode *node = new convL2FPR_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new convL2I_regNode();
      return node;
    }
  case MoveF2I_stack_reg_rule: {
      MoveF2I_stack_regNode *node = new MoveF2I_stack_regNode();
      return node;
    }
  case MoveFPR2I_reg_stack_rule: {
      MoveFPR2I_reg_stackNode *node = new MoveFPR2I_reg_stackNode();
      return node;
    }
  case MoveF2I_reg_stack_sse_rule: {
      MoveF2I_reg_stack_sseNode *node = new MoveF2I_reg_stack_sseNode();
      return node;
    }
  case MoveF2I_reg_reg_sse_rule: {
      MoveF2I_reg_reg_sseNode *node = new MoveF2I_reg_reg_sseNode();
      return node;
    }
  case MoveI2F_reg_stack_rule: {
      MoveI2F_reg_stackNode *node = new MoveI2F_reg_stackNode();
      return node;
    }
  case MoveI2FPR_stack_reg_rule: {
      MoveI2FPR_stack_regNode *node = new MoveI2FPR_stack_regNode();
      return node;
    }
  case MoveI2F_stack_reg_sse_rule: {
      MoveI2F_stack_reg_sseNode *node = new MoveI2F_stack_reg_sseNode();
      return node;
    }
  case MoveI2F_reg_reg_sse_rule: {
      MoveI2F_reg_reg_sseNode *node = new MoveI2F_reg_reg_sseNode();
      return node;
    }
  case MoveD2L_stack_reg_rule: {
      MoveD2L_stack_regNode *node = new MoveD2L_stack_regNode();
      return node;
    }
  case MoveDPR2L_reg_stack_rule: {
      MoveDPR2L_reg_stackNode *node = new MoveDPR2L_reg_stackNode();
      return node;
    }
  case MoveD2L_reg_stack_sse_rule: {
      MoveD2L_reg_stack_sseNode *node = new MoveD2L_reg_stack_sseNode();
      return node;
    }
  case MoveD2L_reg_reg_sse_rule: {
      MoveD2L_reg_reg_sseNode *node = new MoveD2L_reg_reg_sseNode();
      node->set_opnd_array(2, MachOperGenerator(REGD));
      return node;
    }
  case MoveL2D_reg_stack_rule: {
      MoveL2D_reg_stackNode *node = new MoveL2D_reg_stackNode();
      return node;
    }
  case MoveL2DPR_stack_reg_rule: {
      MoveL2DPR_stack_regNode *node = new MoveL2DPR_stack_regNode();
      return node;
    }
  case MoveL2D_stack_reg_sse_rule: {
      MoveL2D_stack_reg_sseNode *node = new MoveL2D_stack_reg_sseNode();
      return node;
    }
  case MoveL2D_stack_reg_sse_partial_rule: {
      MoveL2D_stack_reg_sse_partialNode *node = new MoveL2D_stack_reg_sse_partialNode();
      return node;
    }
  case MoveL2D_reg_reg_sse_rule: {
      MoveL2D_reg_reg_sseNode *node = new MoveL2D_reg_reg_sseNode();
      node->set_opnd_array(2, MachOperGenerator(REGD));
      node->set_opnd_array(3, MachOperGenerator(REGD));
      return node;
    }
  case rep_stos_rule: {
      rep_stosNode *node = new rep_stosNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      return node;
    }
  case rep_stos_large_rule: {
      rep_stos_largeNode *node = new rep_stos_largeNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      return node;
    }
  case string_compareL_rule: {
      string_compareLNode *node = new string_compareLNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_compareU_rule: {
      string_compareUNode *node = new string_compareUNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_compareLU_rule: {
      string_compareLUNode *node = new string_compareLUNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_compareUL_rule: {
      string_compareULNode *node = new string_compareULNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_equals_rule: {
      string_equalsNode *node = new string_equalsNode();
      node->set_opnd_array(4, MachOperGenerator(REGD));
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexof_conL_rule: {
      string_indexof_conLNode *node = new string_indexof_conLNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexof_conU_rule: {
      string_indexof_conUNode *node = new string_indexof_conUNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexof_conUL_rule: {
      string_indexof_conULNode *node = new string_indexof_conULNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexofL_rule: {
      string_indexofLNode *node = new string_indexofLNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexofU_rule: {
      string_indexofUNode *node = new string_indexofUNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexofUL_rule: {
      string_indexofULNode *node = new string_indexofULNode();
      node->set_opnd_array(5, MachOperGenerator(REGD));
      return node;
    }
  case string_indexofU_char_rule: {
      string_indexofU_charNode *node = new string_indexofU_charNode();
      node->set_opnd_array(4, MachOperGenerator(REGD));
      node->set_opnd_array(5, MachOperGenerator(REGD));
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(ECXREGI));
      return node;
    }
  case array_equalsB_rule: {
      array_equalsBNode *node = new array_equalsBNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(REGD));
      return node;
    }
  case array_equalsC_rule: {
      array_equalsCNode *node = new array_equalsCNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(REGD));
      return node;
    }
  case has_negatives_rule: {
      has_negativesNode *node = new has_negativesNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(REGD));
      return node;
    }
  case string_compress_rule: {
      string_compressNode *node = new string_compressNode();
      node->set_opnd_array(4, MachOperGenerator(REGD));
      node->set_opnd_array(5, MachOperGenerator(REGD));
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case string_inflate_rule: {
      string_inflateNode *node = new string_inflateNode();
      node->set_opnd_array(4, MachOperGenerator(REGD));
      node->set_opnd_array(5, MachOperGenerator(ECXREGI));
      return node;
    }
  case encode_iso_array_rule: {
      encode_iso_arrayNode *node = new encode_iso_arrayNode();
      node->set_opnd_array(4, MachOperGenerator(REGD));
      node->set_opnd_array(5, MachOperGenerator(REGD));
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case compI_eReg_rule: {
      compI_eRegNode *node = new compI_eRegNode();
      return node;
    }
  case compI_eReg_imm_rule: {
      compI_eReg_immNode *node = new compI_eReg_immNode();
      return node;
    }
  case compI_eReg_mem_rule: {
      compI_eReg_memNode *node = new compI_eReg_memNode();
      return node;
    }
  case testI_reg_rule: {
      testI_regNode *node = new testI_regNode();
      return node;
    }
  case testI_reg_imm_rule: {
      testI_reg_immNode *node = new testI_reg_immNode();
      return node;
    }
  case testI_reg_mem_rule: {
      testI_reg_memNode *node = new testI_reg_memNode();
      return node;
    }
  case compU_eReg_rule: {
      compU_eRegNode *node = new compU_eRegNode();
      return node;
    }
  case compU_eReg_imm_rule: {
      compU_eReg_immNode *node = new compU_eReg_immNode();
      return node;
    }
  case compU_eReg_mem_rule: {
      compU_eReg_memNode *node = new compU_eReg_memNode();
      return node;
    }
  case testU_reg_rule: {
      testU_regNode *node = new testU_regNode();
      return node;
    }
  case compP_eReg_rule: {
      compP_eRegNode *node = new compP_eRegNode();
      return node;
    }
  case compP_eReg_imm_rule: {
      compP_eReg_immNode *node = new compP_eReg_immNode();
      return node;
    }
  case compP_eReg_mem_rule: {
      compP_eReg_memNode *node = new compP_eReg_memNode();
      return node;
    }
  case compP_mem_eReg_rule: {
      compP_mem_eRegNode *node = new compP_mem_eRegNode();
      return node;
    }
  case testP_reg_rule: {
      testP_regNode *node = new testP_regNode();
      return node;
    }
  case testP_Reg_mem_rule: {
      testP_Reg_memNode *node = new testP_Reg_memNode();
      return node;
    }
  case minI_eReg_rule: {
      minI_eRegNode *node = new minI_eRegNode();
      return node;
    }
  case maxI_eReg_rule: {
      maxI_eRegNode *node = new maxI_eRegNode();
      return node;
    }
  case loopLimit_eReg_rule: {
      loopLimit_eRegNode *node = new loopLimit_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EDXREGI));
      node->set_opnd_array(5, MachOperGenerator(NADXREGI));
      return node;
    }
  case jumpXtnd_rule: {
      jumpXtndNode *node = new jumpXtndNode();
      node->_bottom_type = _leaf->bottom_type();
      node->_probs = _leaf->as_Jump()->_probs;
      return node;
    }
  case jmpDir_rule: {
      jmpDirNode *node = new jmpDirNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL));
      return node;
    }
  case jmpCon_rule: {
      jmpConNode *node = new jmpConNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_rule: {
      jmpLoopEndNode *node = new jmpLoopEndNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndU_rule: {
      jmpLoopEndUNode *node = new jmpLoopEndUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndUCF_rule: {
      jmpLoopEndUCFNode *node = new jmpLoopEndUCFNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_and_restoreMask_rule: {
      jmpLoopEnd_and_restoreMaskNode *node = new jmpLoopEnd_and_restoreMaskNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndU_and_restoreMask_rule: {
      jmpLoopEndU_and_restoreMaskNode *node = new jmpLoopEndU_and_restoreMaskNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndUCF_and_restoreMask_rule: {
      jmpLoopEndUCF_and_restoreMaskNode *node = new jmpLoopEndUCF_and_restoreMaskNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConU_rule: {
      jmpConUNode *node = new jmpConUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF_rule: {
      jmpConUCFNode *node = new jmpConUCFNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF2_rule: {
      jmpConUCF2Node *node = new jmpConUCF2Node();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new partialSubtypeCheckNode();
      return node;
    }
  case partialSubtypeCheck_vs_Zero_rule: {
      partialSubtypeCheck_vs_ZeroNode *node = new partialSubtypeCheck_vs_ZeroNode();
      return node;
    }
  case jmpDir_short_rule: {
      jmpDir_shortNode *node = new jmpDir_shortNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL));
      return node;
    }
  case jmpCon_short_rule: {
      jmpCon_shortNode *node = new jmpCon_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_short_rule: {
      jmpLoopEnd_shortNode *node = new jmpLoopEnd_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndU_short_rule: {
      jmpLoopEndU_shortNode *node = new jmpLoopEndU_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndUCF_short_rule: {
      jmpLoopEndUCF_shortNode *node = new jmpLoopEndUCF_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConU_short_rule: {
      jmpConU_shortNode *node = new jmpConU_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF_short_rule: {
      jmpConUCF_shortNode *node = new jmpConUCF_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF2_short_rule: {
      jmpConUCF2_shortNode *node = new jmpConUCF2_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new cmpL3_reg_regNode();
      return node;
    }
  case cmpL_zero_flags_LTGE_rule: {
      cmpL_zero_flags_LTGENode *node = new cmpL_zero_flags_LTGENode();
      return node;
    }
  case cmpL_reg_flags_LTGE_rule: {
      cmpL_reg_flags_LTGENode *node = new cmpL_reg_flags_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpL_LTGE_rule: {
      cmpL_LTGENode *node = new cmpL_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_zero_flags_LTGE_rule: {
      cmpUL_zero_flags_LTGENode *node = new cmpUL_zero_flags_LTGENode();
      return node;
    }
  case cmpUL_reg_flags_LTGE_rule: {
      cmpUL_reg_flags_LTGENode *node = new cmpUL_reg_flags_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpUL_LTGE_rule: {
      cmpUL_LTGENode *node = new cmpUL_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovLL_reg_LTGE_rule: {
      cmovLL_reg_LTGENode *node = new cmovLL_reg_LTGENode();
      return node;
    }
  case cmovLL_mem_LTGE_rule: {
      cmovLL_mem_LTGENode *node = new cmovLL_mem_LTGENode();
      return node;
    }
  case cmovII_reg_LTGE_rule: {
      cmovII_reg_LTGENode *node = new cmovII_reg_LTGENode();
      return node;
    }
  case cmovII_mem_LTGE_rule: {
      cmovII_mem_LTGENode *node = new cmovII_mem_LTGENode();
      return node;
    }
  case cmovPP_reg_LTGE_rule: {
      cmovPP_reg_LTGENode *node = new cmovPP_reg_LTGENode();
      return node;
    }
  case cmovDDPR_reg_LTGE_rule: {
      cmovDDPR_reg_LTGENode *node = new cmovDDPR_reg_LTGENode();
      return node;
    }
  case cmovDD_reg_LTGE_rule: {
      cmovDD_reg_LTGENode *node = new cmovDD_reg_LTGENode();
      return node;
    }
  case cmovFFPR_reg_LTGE_rule: {
      cmovFFPR_reg_LTGENode *node = new cmovFFPR_reg_LTGENode();
      return node;
    }
  case cmovFF_reg_LTGE_rule: {
      cmovFF_reg_LTGENode *node = new cmovFF_reg_LTGENode();
      return node;
    }
  case cmpL_zero_flags_EQNE_rule: {
      cmpL_zero_flags_EQNENode *node = new cmpL_zero_flags_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpL_reg_flags_EQNE_rule: {
      cmpL_reg_flags_EQNENode *node = new cmpL_reg_flags_EQNENode();
      return node;
    }
  case cmpL_EQNE_rule: {
      cmpL_EQNENode *node = new cmpL_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_zero_flags_EQNE_rule: {
      cmpUL_zero_flags_EQNENode *node = new cmpUL_zero_flags_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpUL_reg_flags_EQNE_rule: {
      cmpUL_reg_flags_EQNENode *node = new cmpUL_reg_flags_EQNENode();
      return node;
    }
  case cmpUL_EQNE_rule: {
      cmpUL_EQNENode *node = new cmpUL_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovLL_reg_EQNE_rule: {
      cmovLL_reg_EQNENode *node = new cmovLL_reg_EQNENode();
      return node;
    }
  case cmovLL_mem_EQNE_rule: {
      cmovLL_mem_EQNENode *node = new cmovLL_mem_EQNENode();
      return node;
    }
  case cmovII_reg_EQNE_rule: {
      cmovII_reg_EQNENode *node = new cmovII_reg_EQNENode();
      return node;
    }
  case cmovII_mem_EQNE_rule: {
      cmovII_mem_EQNENode *node = new cmovII_mem_EQNENode();
      return node;
    }
  case cmovPP_reg_EQNE_rule: {
      cmovPP_reg_EQNENode *node = new cmovPP_reg_EQNENode();
      return node;
    }
  case cmovDDPR_reg_EQNE_rule: {
      cmovDDPR_reg_EQNENode *node = new cmovDDPR_reg_EQNENode();
      return node;
    }
  case cmovDD_reg_EQNE_rule: {
      cmovDD_reg_EQNENode *node = new cmovDD_reg_EQNENode();
      return node;
    }
  case cmovFFPR_reg_EQNE_rule: {
      cmovFFPR_reg_EQNENode *node = new cmovFFPR_reg_EQNENode();
      return node;
    }
  case cmovFF_reg_EQNE_rule: {
      cmovFF_reg_EQNENode *node = new cmovFF_reg_EQNENode();
      return node;
    }
  case cmpL_zero_flags_LEGT_rule: {
      cmpL_zero_flags_LEGTNode *node = new cmpL_zero_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpL_reg_flags_LEGT_rule: {
      cmpL_reg_flags_LEGTNode *node = new cmpL_reg_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpL_LEGT_rule: {
      cmpL_LEGTNode *node = new cmpL_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_zero_flags_LEGT_rule: {
      cmpUL_zero_flags_LEGTNode *node = new cmpUL_zero_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpUL_reg_flags_LEGT_rule: {
      cmpUL_reg_flags_LEGTNode *node = new cmpUL_reg_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI));
      return node;
    }
  case cmpUL_LEGT_rule: {
      cmpUL_LEGTNode *node = new cmpUL_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovLL_reg_LEGT_rule: {
      cmovLL_reg_LEGTNode *node = new cmovLL_reg_LEGTNode();
      return node;
    }
  case cmovLL_mem_LEGT_rule: {
      cmovLL_mem_LEGTNode *node = new cmovLL_mem_LEGTNode();
      return node;
    }
  case cmovII_reg_LEGT_rule: {
      cmovII_reg_LEGTNode *node = new cmovII_reg_LEGTNode();
      return node;
    }
  case cmovII_mem_LEGT_rule: {
      cmovII_mem_LEGTNode *node = new cmovII_mem_LEGTNode();
      return node;
    }
  case cmovPP_reg_LEGT_rule: {
      cmovPP_reg_LEGTNode *node = new cmovPP_reg_LEGTNode();
      return node;
    }
  case cmovDDPR_reg_LEGT_rule: {
      cmovDDPR_reg_LEGTNode *node = new cmovDDPR_reg_LEGTNode();
      return node;
    }
  case cmovDD_reg_LEGT_rule: {
      cmovDD_reg_LEGTNode *node = new cmovDD_reg_LEGTNode();
      return node;
    }
  case cmovFFPR_reg_LEGT_rule: {
      cmovFFPR_reg_LEGTNode *node = new cmovFFPR_reg_LEGTNode();
      return node;
    }
  case cmovFF_reg_LEGT_rule: {
      cmovFF_reg_LEGTNode *node = new cmovFF_reg_LEGTNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case Ret_rule: {
      RetNode *node = new RetNode();
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new TailCalljmpIndNode();
      return node;
    }
  case tailjmpInd_rule: {
      tailjmpIndNode *node = new tailjmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new RethrowExceptionNode();
      return node;
    }
  case cmpFastLockRTM_rule: {
      cmpFastLockRTMNode *node = new cmpFastLockRTMNode();
      node->set_opnd_array(3, MachOperGenerator(EAXREGI));
      node->set_opnd_array(4, MachOperGenerator(EDXREGI));
      node->set_opnd_array(5, MachOperGenerator(RREGI));
      node->set_opnd_array(6, MachOperGenerator(RREGI));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(EAXREGI));
      node->set_opnd_array(4, MachOperGenerator(EREGP));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(EREGP));
      return node;
    }
  case safePoint_poll_rule: {
      safePoint_pollNode *node = new safePoint_pollNode();
      node->set_opnd_array(1, MachOperGenerator(EFLAGSREG));
      return node;
    }
  case safePoint_poll_tls_rule: {
      safePoint_poll_tlsNode *node = new safePoint_poll_tlsNode();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new tlsLoadPNode();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new ShouldNotReachHereNode();
      return node;
    }
  case setMask_rule: {
      setMaskNode *node = new setMaskNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI));
      return node;
    }
  case addF_reg_rule: {
      addF_regNode *node = new addF_regNode();
      return node;
    }
  case addF_mem_rule: {
      addF_memNode *node = new addF_memNode();
      return node;
    }
  case addF_mem_0_rule: {
      addF_mem_0Node *node = new addF_mem_0Node();
      return node;
    }
  case addF_imm_rule: {
      addF_immNode *node = new addF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new addF_reg_regNode();
      return node;
    }
  case addF_reg_mem_rule: {
      addF_reg_memNode *node = new addF_reg_memNode();
      return node;
    }
  case addF_reg_mem_0_rule: {
      addF_reg_mem_0Node *node = new addF_reg_mem_0Node();
      return node;
    }
  case addF_reg_imm_rule: {
      addF_reg_immNode *node = new addF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addD_reg_rule: {
      addD_regNode *node = new addD_regNode();
      return node;
    }
  case addD_mem_rule: {
      addD_memNode *node = new addD_memNode();
      return node;
    }
  case addD_mem_0_rule: {
      addD_mem_0Node *node = new addD_mem_0Node();
      return node;
    }
  case addD_imm_rule: {
      addD_immNode *node = new addD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new addD_reg_regNode();
      return node;
    }
  case addD_reg_mem_rule: {
      addD_reg_memNode *node = new addD_reg_memNode();
      return node;
    }
  case addD_reg_mem_0_rule: {
      addD_reg_mem_0Node *node = new addD_reg_mem_0Node();
      return node;
    }
  case addD_reg_imm_rule: {
      addD_reg_immNode *node = new addD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subF_reg_rule: {
      subF_regNode *node = new subF_regNode();
      return node;
    }
  case subF_mem_rule: {
      subF_memNode *node = new subF_memNode();
      return node;
    }
  case subF_imm_rule: {
      subF_immNode *node = new subF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new subF_reg_regNode();
      return node;
    }
  case subF_reg_mem_rule: {
      subF_reg_memNode *node = new subF_reg_memNode();
      return node;
    }
  case subF_reg_imm_rule: {
      subF_reg_immNode *node = new subF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subD_reg_rule: {
      subD_regNode *node = new subD_regNode();
      return node;
    }
  case subD_mem_rule: {
      subD_memNode *node = new subD_memNode();
      return node;
    }
  case subD_imm_rule: {
      subD_immNode *node = new subD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new subD_reg_regNode();
      return node;
    }
  case subD_reg_mem_rule: {
      subD_reg_memNode *node = new subD_reg_memNode();
      return node;
    }
  case subD_reg_imm_rule: {
      subD_reg_immNode *node = new subD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulF_reg_rule: {
      mulF_regNode *node = new mulF_regNode();
      return node;
    }
  case mulF_mem_rule: {
      mulF_memNode *node = new mulF_memNode();
      return node;
    }
  case mulF_mem_0_rule: {
      mulF_mem_0Node *node = new mulF_mem_0Node();
      return node;
    }
  case mulF_imm_rule: {
      mulF_immNode *node = new mulF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new mulF_reg_regNode();
      return node;
    }
  case mulF_reg_mem_rule: {
      mulF_reg_memNode *node = new mulF_reg_memNode();
      return node;
    }
  case mulF_reg_mem_0_rule: {
      mulF_reg_mem_0Node *node = new mulF_reg_mem_0Node();
      return node;
    }
  case mulF_reg_imm_rule: {
      mulF_reg_immNode *node = new mulF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulD_reg_rule: {
      mulD_regNode *node = new mulD_regNode();
      return node;
    }
  case mulD_mem_rule: {
      mulD_memNode *node = new mulD_memNode();
      return node;
    }
  case mulD_mem_0_rule: {
      mulD_mem_0Node *node = new mulD_mem_0Node();
      return node;
    }
  case mulD_imm_rule: {
      mulD_immNode *node = new mulD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new mulD_reg_regNode();
      return node;
    }
  case mulD_reg_mem_rule: {
      mulD_reg_memNode *node = new mulD_reg_memNode();
      return node;
    }
  case mulD_reg_mem_0_rule: {
      mulD_reg_mem_0Node *node = new mulD_reg_mem_0Node();
      return node;
    }
  case mulD_reg_imm_rule: {
      mulD_reg_immNode *node = new mulD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divF_reg_rule: {
      divF_regNode *node = new divF_regNode();
      return node;
    }
  case divF_mem_rule: {
      divF_memNode *node = new divF_memNode();
      return node;
    }
  case divF_imm_rule: {
      divF_immNode *node = new divF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divF_reg_reg_rule: {
      divF_reg_regNode *node = new divF_reg_regNode();
      return node;
    }
  case divF_reg_mem_rule: {
      divF_reg_memNode *node = new divF_reg_memNode();
      return node;
    }
  case divF_reg_imm_rule: {
      divF_reg_immNode *node = new divF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divD_reg_rule: {
      divD_regNode *node = new divD_regNode();
      return node;
    }
  case divD_mem_rule: {
      divD_memNode *node = new divD_memNode();
      return node;
    }
  case divD_imm_rule: {
      divD_immNode *node = new divD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divD_reg_reg_rule: {
      divD_reg_regNode *node = new divD_reg_regNode();
      return node;
    }
  case divD_reg_mem_rule: {
      divD_reg_memNode *node = new divD_reg_memNode();
      return node;
    }
  case divD_reg_imm_rule: {
      divD_reg_immNode *node = new divD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new absF_regNode();
      return node;
    }
  case absF_reg_reg_rule: {
      absF_reg_regNode *node = new absF_reg_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new absD_regNode();
      return node;
    }
  case absD_reg_reg_rule: {
      absD_reg_regNode *node = new absD_reg_regNode();
      return node;
    }
  case negF_reg_rule: {
      negF_regNode *node = new negF_regNode();
      return node;
    }
  case negF_reg_reg_rule: {
      negF_reg_regNode *node = new negF_reg_regNode();
      return node;
    }
  case negD_reg_rule: {
      negD_regNode *node = new negD_regNode();
      return node;
    }
  case negD_reg_reg_rule: {
      negD_reg_regNode *node = new negD_reg_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new sqrtF_regNode();
      return node;
    }
  case sqrtF_mem_rule: {
      sqrtF_memNode *node = new sqrtF_memNode();
      return node;
    }
  case sqrtF_imm_rule: {
      sqrtF_immNode *node = new sqrtF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new sqrtD_regNode();
      return node;
    }
  case sqrtD_mem_rule: {
      sqrtD_memNode *node = new sqrtD_memNode();
      return node;
    }
  case sqrtD_imm_rule: {
      sqrtD_immNode *node = new sqrtD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case onspinwait_rule: {
      onspinwaitNode *node = new onspinwaitNode();
      return node;
    }
  case fmaD_reg_rule: {
      fmaD_regNode *node = new fmaD_regNode();
      return node;
    }
  case fmaF_reg_rule: {
      fmaF_regNode *node = new fmaF_regNode();
      return node;
    }
  case loadV4_rule: {
      loadV4Node *node = new loadV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveVecS2Leg_rule: {
      MoveVecS2LegNode *node = new MoveVecS2LegNode();
      return node;
    }
  case MoveLeg2VecS_rule: {
      MoveLeg2VecSNode *node = new MoveLeg2VecSNode();
      return node;
    }
  case loadV8_rule: {
      loadV8Node *node = new loadV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveVecD2Leg_rule: {
      MoveVecD2LegNode *node = new MoveVecD2LegNode();
      return node;
    }
  case MoveLeg2VecD_rule: {
      MoveLeg2VecDNode *node = new MoveLeg2VecDNode();
      return node;
    }
  case loadV16_rule: {
      loadV16Node *node = new loadV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveVecX2Leg_rule: {
      MoveVecX2LegNode *node = new MoveVecX2LegNode();
      return node;
    }
  case MoveLeg2VecX_rule: {
      MoveLeg2VecXNode *node = new MoveLeg2VecXNode();
      return node;
    }
  case loadV32_rule: {
      loadV32Node *node = new loadV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveVecY2Leg_rule: {
      MoveVecY2LegNode *node = new MoveVecY2LegNode();
      return node;
    }
  case MoveLeg2VecY_rule: {
      MoveLeg2VecYNode *node = new MoveLeg2VecYNode();
      return node;
    }
  case loadV64_dword_rule: {
      loadV64_dwordNode *node = new loadV64_dwordNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV64_qword_rule: {
      loadV64_qwordNode *node = new loadV64_qwordNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveVecZ2Leg_rule: {
      MoveVecZ2LegNode *node = new MoveVecZ2LegNode();
      return node;
    }
  case MoveLeg2VecZ_rule: {
      MoveLeg2VecZNode *node = new MoveLeg2VecZNode();
      return node;
    }
  case storeV4_rule: {
      storeV4Node *node = new storeV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV8_rule: {
      storeV8Node *node = new storeV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV16_rule: {
      storeV16Node *node = new storeV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV32_rule: {
      storeV32Node *node = new storeV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV64_dword_rule: {
      storeV64_dwordNode *node = new storeV64_dwordNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV64_qword_rule: {
      storeV64_qwordNode *node = new storeV64_qwordNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_mem_rule: {
      Repl4B_memNode *node = new Repl4B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_mem_rule: {
      Repl8B_memNode *node = new Repl8B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_rule: {
      Repl16BNode *node = new Repl16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_mem_rule: {
      Repl16B_memNode *node = new Repl16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_rule: {
      Repl32BNode *node = new Repl32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_mem_rule: {
      Repl32B_memNode *node = new Repl32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_rule: {
      Repl64BNode *node = new Repl64BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_mem_rule: {
      Repl64B_memNode *node = new Repl64B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_imm_rule: {
      Repl16B_immNode *node = new Repl16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_imm_rule: {
      Repl32B_immNode *node = new Repl32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_imm_rule: {
      Repl64B_immNode *node = new Repl64B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_rule: {
      Repl4SNode *node = new Repl4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_mem_rule: {
      Repl4S_memNode *node = new Repl4S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_rule: {
      Repl8SNode *node = new Repl8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_mem_rule: {
      Repl8S_memNode *node = new Repl8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_imm_rule: {
      Repl8S_immNode *node = new Repl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_rule: {
      Repl16SNode *node = new Repl16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_mem_rule: {
      Repl16S_memNode *node = new Repl16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_imm_rule: {
      Repl16S_immNode *node = new Repl16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_rule: {
      Repl32SNode *node = new Repl32SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_mem_rule: {
      Repl32S_memNode *node = new Repl32S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_imm_rule: {
      Repl32S_immNode *node = new Repl32S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_rule: {
      Repl4INode *node = new Repl4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_mem_rule: {
      Repl4I_memNode *node = new Repl4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_rule: {
      Repl8INode *node = new Repl8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_mem_rule: {
      Repl8I_memNode *node = new Repl8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_rule: {
      Repl16INode *node = new Repl16INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_mem_rule: {
      Repl16I_memNode *node = new Repl16I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_imm_rule: {
      Repl4I_immNode *node = new Repl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_imm_rule: {
      Repl8I_immNode *node = new Repl8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_imm_rule: {
      Repl16I_immNode *node = new Repl16I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_mem_rule: {
      Repl2L_memNode *node = new Repl2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_rule: {
      Repl4LNode *node = new Repl4LNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_rule: {
      Repl8LNode *node = new Repl8LNode();
      node->set_opnd_array(2, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(3, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_imm_rule: {
      Repl4L_immNode *node = new Repl4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_imm_rule: {
      Repl8L_immNode *node = new Repl8L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_mem_rule: {
      Repl4L_memNode *node = new Repl4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_mem_rule: {
      Repl8L_memNode *node = new Repl8L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_mem_rule: {
      Repl2F_memNode *node = new Repl2F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4F_mem_rule: {
      Repl4F_memNode *node = new Repl4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_rule: {
      Repl8FNode *node = new Repl8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_mem_rule: {
      Repl8F_memNode *node = new Repl8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16F_rule: {
      Repl16FNode *node = new Repl16FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16F_mem_rule: {
      Repl16F_memNode *node = new Repl16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_zero_rule: {
      Repl2F_zeroNode *node = new Repl2F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4F_zero_rule: {
      Repl4F_zeroNode *node = new Repl4F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_zero_rule: {
      Repl8F_zeroNode *node = new Repl8F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2D_mem_rule: {
      Repl2D_memNode *node = new Repl2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_rule: {
      Repl4DNode *node = new Repl4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_mem_rule: {
      Repl4D_memNode *node = new Repl4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8D_rule: {
      Repl8DNode *node = new Repl8DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8D_mem_rule: {
      Repl8D_memNode *node = new Repl8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2D_zero_rule: {
      Repl2D_zeroNode *node = new Repl2D_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_zero_rule: {
      Repl4D_zeroNode *node = new Repl4D_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_rule: {
      Repl4BNode *node = new Repl4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_rule: {
      Repl8BNode *node = new Repl8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_imm_rule: {
      Repl4B_immNode *node = new Repl4B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_imm_rule: {
      Repl8B_immNode *node = new Repl8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_zero_rule: {
      Repl4B_zeroNode *node = new Repl4B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_zero_rule: {
      Repl8B_zeroNode *node = new Repl8B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_zero_rule: {
      Repl16B_zeroNode *node = new Repl16B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_zero_rule: {
      Repl32B_zeroNode *node = new Repl32B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2S_rule: {
      Repl2SNode *node = new Repl2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2S_imm_rule: {
      Repl2S_immNode *node = new Repl2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_imm_rule: {
      Repl4S_immNode *node = new Repl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2S_zero_rule: {
      Repl2S_zeroNode *node = new Repl2S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_zero_rule: {
      Repl4S_zeroNode *node = new Repl4S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_zero_rule: {
      Repl8S_zeroNode *node = new Repl8S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_zero_rule: {
      Repl16S_zeroNode *node = new Repl16S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_rule: {
      Repl2INode *node = new Repl2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_mem_rule: {
      Repl2I_memNode *node = new Repl2I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_imm_rule: {
      Repl2I_immNode *node = new Repl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_zero_rule: {
      Repl2I_zeroNode *node = new Repl2I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_zero_rule: {
      Repl4I_zeroNode *node = new Repl4I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_zero_rule: {
      Repl8I_zeroNode *node = new Repl8I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_rule: {
      Repl2LNode *node = new Repl2LNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_imm_rule: {
      Repl2L_immNode *node = new Repl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_zero_rule: {
      Repl2L_zeroNode *node = new Repl2L_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_zero_rule: {
      Repl4L_zeroNode *node = new Repl4L_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_rule: {
      Repl2FNode *node = new Repl2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4F_rule: {
      Repl4FNode *node = new Repl4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2D_rule: {
      Repl2DNode *node = new Repl2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_mem_evex_rule: {
      Repl4B_mem_evexNode *node = new Repl4B_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_mem_evex_rule: {
      Repl8B_mem_evexNode *node = new Repl8B_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_evex_rule: {
      Repl16B_evexNode *node = new Repl16B_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_mem_evex_rule: {
      Repl16B_mem_evexNode *node = new Repl16B_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_evex_rule: {
      Repl32B_evexNode *node = new Repl32B_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_mem_evex_rule: {
      Repl32B_mem_evexNode *node = new Repl32B_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_evex_rule: {
      Repl64B_evexNode *node = new Repl64B_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_mem_evex_rule: {
      Repl64B_mem_evexNode *node = new Repl64B_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_imm_evex_rule: {
      Repl16B_imm_evexNode *node = new Repl16B_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_imm_evex_rule: {
      Repl32B_imm_evexNode *node = new Repl32B_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_imm_evex_rule: {
      Repl64B_imm_evexNode *node = new Repl64B_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl64B_zero_evex_rule: {
      Repl64B_zero_evexNode *node = new Repl64B_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_evex_rule: {
      Repl4S_evexNode *node = new Repl4S_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_mem_evex_rule: {
      Repl4S_mem_evexNode *node = new Repl4S_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_evex_rule: {
      Repl8S_evexNode *node = new Repl8S_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_mem_evex_rule: {
      Repl8S_mem_evexNode *node = new Repl8S_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_evex_rule: {
      Repl16S_evexNode *node = new Repl16S_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_mem_evex_rule: {
      Repl16S_mem_evexNode *node = new Repl16S_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_evex_rule: {
      Repl32S_evexNode *node = new Repl32S_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_mem_evex_rule: {
      Repl32S_mem_evexNode *node = new Repl32S_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_imm_evex_rule: {
      Repl8S_imm_evexNode *node = new Repl8S_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_imm_evex_rule: {
      Repl16S_imm_evexNode *node = new Repl16S_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_imm_evex_rule: {
      Repl32S_imm_evexNode *node = new Repl32S_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32S_zero_evex_rule: {
      Repl32S_zero_evexNode *node = new Repl32S_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_evex_rule: {
      Repl4I_evexNode *node = new Repl4I_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_mem_evex_rule: {
      Repl4I_mem_evexNode *node = new Repl4I_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_evex_rule: {
      Repl8I_evexNode *node = new Repl8I_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_mem_evex_rule: {
      Repl8I_mem_evexNode *node = new Repl8I_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_evex_rule: {
      Repl16I_evexNode *node = new Repl16I_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_mem_evex_rule: {
      Repl16I_mem_evexNode *node = new Repl16I_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_imm_evex_rule: {
      Repl4I_imm_evexNode *node = new Repl4I_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_imm_evex_rule: {
      Repl8I_imm_evexNode *node = new Repl8I_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_imm_evex_rule: {
      Repl16I_imm_evexNode *node = new Repl16I_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16I_zero_evex_rule: {
      Repl16I_zero_evexNode *node = new Repl16I_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_evex_rule: {
      Repl4L_evexNode *node = new Repl4L_evexNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_evex_rule: {
      Repl8L_evexNode *node = new Repl8L_evexNode();
      node->set_opnd_array(2, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(3, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_imm_evex_rule: {
      Repl4L_imm_evexNode *node = new Repl4L_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_imm_evex_rule: {
      Repl8L_imm_evexNode *node = new Repl8L_imm_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_mem_evex_rule: {
      Repl2L_mem_evexNode *node = new Repl2L_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_mem_evex_rule: {
      Repl4L_mem_evexNode *node = new Repl4L_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_mem_evex_rule: {
      Repl8L_mem_evexNode *node = new Repl8L_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8L_zero_evex_rule: {
      Repl8L_zero_evexNode *node = new Repl8L_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_evex_rule: {
      Repl8F_evexNode *node = new Repl8F_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_mem_evex_rule: {
      Repl8F_mem_evexNode *node = new Repl8F_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16F_evex_rule: {
      Repl16F_evexNode *node = new Repl16F_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16F_mem_evex_rule: {
      Repl16F_mem_evexNode *node = new Repl16F_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_zero_evex_rule: {
      Repl2F_zero_evexNode *node = new Repl2F_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4F_zero_evex_rule: {
      Repl4F_zero_evexNode *node = new Repl4F_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_zero_evex_rule: {
      Repl8F_zero_evexNode *node = new Repl8F_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16F_zero_evex_rule: {
      Repl16F_zero_evexNode *node = new Repl16F_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_evex_rule: {
      Repl4D_evexNode *node = new Repl4D_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_mem_evex_rule: {
      Repl4D_mem_evexNode *node = new Repl4D_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8D_evex_rule: {
      Repl8D_evexNode *node = new Repl8D_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8D_mem_evex_rule: {
      Repl8D_mem_evexNode *node = new Repl8D_mem_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2D_zero_evex_rule: {
      Repl2D_zero_evexNode *node = new Repl2D_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_zero_evex_rule: {
      Repl4D_zero_evexNode *node = new Repl4D_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8D_zero_evex_rule: {
      Repl8D_zero_evexNode *node = new Repl8D_zero_evexNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsadd2I_reduction_reg_rule: {
      rsadd2I_reduction_regNode *node = new rsadd2I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd2I_reduction_reg_rule: {
      rvadd2I_reduction_regNode *node = new rvadd2I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd2I_reduction_reg_evex_rule: {
      rvadd2I_reduction_reg_evexNode *node = new rvadd2I_reduction_reg_evexNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsadd4I_reduction_reg_rule: {
      rsadd4I_reduction_regNode *node = new rsadd4I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd4I_reduction_reg_rule: {
      rvadd4I_reduction_regNode *node = new rvadd4I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd4I_reduction_reg_evex_rule: {
      rvadd4I_reduction_reg_evexNode *node = new rvadd4I_reduction_reg_evexNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd8I_reduction_reg_rule: {
      rvadd8I_reduction_regNode *node = new rvadd8I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd8I_reduction_reg_evex_rule: {
      rvadd8I_reduction_reg_evexNode *node = new rvadd8I_reduction_reg_evexNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd16I_reduction_reg_evex_rule: {
      rvadd16I_reduction_reg_evexNode *node = new rvadd16I_reduction_reg_evexNode();
      node->set_opnd_array(3, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(4, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(5, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsadd2F_reduction_reg_rule: {
      rsadd2F_reduction_regNode *node = new rsadd2F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd2F_reduction_reg_rule: {
      rvadd2F_reduction_regNode *node = new rvadd2F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsadd4F_reduction_reg_rule: {
      rsadd4F_reduction_regNode *node = new rsadd4F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd4F_reduction_reg_rule: {
      rvadd4F_reduction_regNode *node = new rvadd4F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case radd8F_reduction_reg_rule: {
      radd8F_reduction_regNode *node = new radd8F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case radd16F_reduction_reg_rule: {
      radd16F_reduction_regNode *node = new radd16F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(5, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsadd2D_reduction_reg_rule: {
      rsadd2D_reduction_regNode *node = new rsadd2D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd2D_reduction_reg_rule: {
      rvadd2D_reduction_regNode *node = new rvadd2D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd4D_reduction_reg_rule: {
      rvadd4D_reduction_regNode *node = new rvadd4D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvadd8D_reduction_reg_rule: {
      rvadd8D_reduction_regNode *node = new rvadd8D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(5, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsmul2I_reduction_reg_rule: {
      rsmul2I_reduction_regNode *node = new rsmul2I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul2I_reduction_reg_rule: {
      rvmul2I_reduction_regNode *node = new rvmul2I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsmul4I_reduction_reg_rule: {
      rsmul4I_reduction_regNode *node = new rsmul4I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul4I_reduction_reg_rule: {
      rvmul4I_reduction_regNode *node = new rvmul4I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul8I_reduction_reg_rule: {
      rvmul8I_reduction_regNode *node = new rvmul8I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul16I_reduction_reg_rule: {
      rvmul16I_reduction_regNode *node = new rvmul16I_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(4, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(5, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsmul2F_reduction_rule: {
      rsmul2F_reductionNode *node = new rsmul2F_reductionNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul2F_reduction_reg_rule: {
      rvmul2F_reduction_regNode *node = new rvmul2F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsmul4F_reduction_reg_rule: {
      rsmul4F_reduction_regNode *node = new rsmul4F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul4F_reduction_reg_rule: {
      rvmul4F_reduction_regNode *node = new rvmul4F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul8F_reduction_reg_rule: {
      rvmul8F_reduction_regNode *node = new rvmul8F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul16F_reduction_reg_rule: {
      rvmul16F_reduction_regNode *node = new rvmul16F_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(5, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rsmul2D_reduction_reg_rule: {
      rsmul2D_reduction_regNode *node = new rsmul2D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul2D_reduction_reg_rule: {
      rvmul2D_reduction_regNode *node = new rvmul2D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul4D_reduction_reg_rule: {
      rvmul4D_reduction_regNode *node = new rvmul4D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rvmul8D_reduction_reg_rule: {
      rvmul8D_reduction_regNode *node = new rvmul8D_reduction_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(LEGVECZ));
      node->set_opnd_array(5, MachOperGenerator(LEGVECZ));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4B_rule: {
      vadd4BNode *node = new vadd4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4B_reg_rule: {
      vadd4B_regNode *node = new vadd4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4B_mem_rule: {
      vadd4B_memNode *node = new vadd4B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4B_mem_0_rule: {
      vadd4B_mem_0Node *node = new vadd4B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_rule: {
      vadd8BNode *node = new vadd8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_reg_rule: {
      vadd8B_regNode *node = new vadd8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_mem_rule: {
      vadd8B_memNode *node = new vadd8B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_mem_0_rule: {
      vadd8B_mem_0Node *node = new vadd8B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_rule: {
      vadd16BNode *node = new vadd16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_reg_rule: {
      vadd16B_regNode *node = new vadd16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_mem_rule: {
      vadd16B_memNode *node = new vadd16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_mem_0_rule: {
      vadd16B_mem_0Node *node = new vadd16B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32B_reg_rule: {
      vadd32B_regNode *node = new vadd32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32B_mem_rule: {
      vadd32B_memNode *node = new vadd32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32B_mem_0_rule: {
      vadd32B_mem_0Node *node = new vadd32B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd64B_reg_rule: {
      vadd64B_regNode *node = new vadd64B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd64B_mem_rule: {
      vadd64B_memNode *node = new vadd64B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd64B_mem_0_rule: {
      vadd64B_mem_0Node *node = new vadd64B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2S_rule: {
      vadd2SNode *node = new vadd2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2S_reg_rule: {
      vadd2S_regNode *node = new vadd2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2S_mem_rule: {
      vadd2S_memNode *node = new vadd2S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2S_mem_0_rule: {
      vadd2S_mem_0Node *node = new vadd2S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_rule: {
      vadd4SNode *node = new vadd4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_reg_rule: {
      vadd4S_regNode *node = new vadd4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_mem_rule: {
      vadd4S_memNode *node = new vadd4S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_mem_0_rule: {
      vadd4S_mem_0Node *node = new vadd4S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_rule: {
      vadd8SNode *node = new vadd8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_reg_rule: {
      vadd8S_regNode *node = new vadd8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_mem_rule: {
      vadd8S_memNode *node = new vadd8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_mem_0_rule: {
      vadd8S_mem_0Node *node = new vadd8S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16S_reg_rule: {
      vadd16S_regNode *node = new vadd16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16S_mem_rule: {
      vadd16S_memNode *node = new vadd16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16S_mem_0_rule: {
      vadd16S_mem_0Node *node = new vadd16S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32S_reg_rule: {
      vadd32S_regNode *node = new vadd32S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32S_mem_rule: {
      vadd32S_memNode *node = new vadd32S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32S_mem_0_rule: {
      vadd32S_mem_0Node *node = new vadd32S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_rule: {
      vadd2INode *node = new vadd2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_reg_rule: {
      vadd2I_regNode *node = new vadd2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_mem_rule: {
      vadd2I_memNode *node = new vadd2I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_mem_0_rule: {
      vadd2I_mem_0Node *node = new vadd2I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_rule: {
      vadd4INode *node = new vadd4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_reg_rule: {
      vadd4I_regNode *node = new vadd4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_mem_rule: {
      vadd4I_memNode *node = new vadd4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_mem_0_rule: {
      vadd4I_mem_0Node *node = new vadd4I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8I_reg_rule: {
      vadd8I_regNode *node = new vadd8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8I_mem_rule: {
      vadd8I_memNode *node = new vadd8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8I_mem_0_rule: {
      vadd8I_mem_0Node *node = new vadd8I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16I_reg_rule: {
      vadd16I_regNode *node = new vadd16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16I_mem_rule: {
      vadd16I_memNode *node = new vadd16I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16I_mem_0_rule: {
      vadd16I_mem_0Node *node = new vadd16I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_rule: {
      vadd2LNode *node = new vadd2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_reg_rule: {
      vadd2L_regNode *node = new vadd2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_mem_rule: {
      vadd2L_memNode *node = new vadd2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_mem_0_rule: {
      vadd2L_mem_0Node *node = new vadd2L_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4L_reg_rule: {
      vadd4L_regNode *node = new vadd4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4L_mem_rule: {
      vadd4L_memNode *node = new vadd4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4L_mem_0_rule: {
      vadd4L_mem_0Node *node = new vadd4L_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8L_reg_rule: {
      vadd8L_regNode *node = new vadd8L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8L_mem_rule: {
      vadd8L_memNode *node = new vadd8L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8L_mem_0_rule: {
      vadd8L_mem_0Node *node = new vadd8L_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_rule: {
      vadd2FNode *node = new vadd2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_reg_rule: {
      vadd2F_regNode *node = new vadd2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_mem_rule: {
      vadd2F_memNode *node = new vadd2F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_mem_0_rule: {
      vadd2F_mem_0Node *node = new vadd2F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_rule: {
      vadd4FNode *node = new vadd4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_reg_rule: {
      vadd4F_regNode *node = new vadd4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_mem_rule: {
      vadd4F_memNode *node = new vadd4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_mem_0_rule: {
      vadd4F_mem_0Node *node = new vadd4F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8F_reg_rule: {
      vadd8F_regNode *node = new vadd8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8F_mem_rule: {
      vadd8F_memNode *node = new vadd8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8F_mem_0_rule: {
      vadd8F_mem_0Node *node = new vadd8F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16F_reg_rule: {
      vadd16F_regNode *node = new vadd16F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16F_mem_rule: {
      vadd16F_memNode *node = new vadd16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16F_mem_0_rule: {
      vadd16F_mem_0Node *node = new vadd16F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_rule: {
      vadd2DNode *node = new vadd2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_reg_rule: {
      vadd2D_regNode *node = new vadd2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_mem_rule: {
      vadd2D_memNode *node = new vadd2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_mem_0_rule: {
      vadd2D_mem_0Node *node = new vadd2D_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4D_reg_rule: {
      vadd4D_regNode *node = new vadd4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4D_mem_rule: {
      vadd4D_memNode *node = new vadd4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4D_mem_0_rule: {
      vadd4D_mem_0Node *node = new vadd4D_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8D_reg_rule: {
      vadd8D_regNode *node = new vadd8D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8D_mem_rule: {
      vadd8D_memNode *node = new vadd8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8D_mem_0_rule: {
      vadd8D_mem_0Node *node = new vadd8D_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4B_rule: {
      vsub4BNode *node = new vsub4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4B_reg_rule: {
      vsub4B_regNode *node = new vsub4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4B_mem_rule: {
      vsub4B_memNode *node = new vsub4B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_rule: {
      vsub8BNode *node = new vsub8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_reg_rule: {
      vsub8B_regNode *node = new vsub8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_mem_rule: {
      vsub8B_memNode *node = new vsub8B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_rule: {
      vsub16BNode *node = new vsub16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_reg_rule: {
      vsub16B_regNode *node = new vsub16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_mem_rule: {
      vsub16B_memNode *node = new vsub16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub32B_reg_rule: {
      vsub32B_regNode *node = new vsub32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub32B_mem_rule: {
      vsub32B_memNode *node = new vsub32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub64B_reg_rule: {
      vsub64B_regNode *node = new vsub64B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub64B_mem_rule: {
      vsub64B_memNode *node = new vsub64B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2S_rule: {
      vsub2SNode *node = new vsub2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2S_reg_rule: {
      vsub2S_regNode *node = new vsub2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2S_mem_rule: {
      vsub2S_memNode *node = new vsub2S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_rule: {
      vsub4SNode *node = new vsub4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_reg_rule: {
      vsub4S_regNode *node = new vsub4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_mem_rule: {
      vsub4S_memNode *node = new vsub4S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_rule: {
      vsub8SNode *node = new vsub8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_reg_rule: {
      vsub8S_regNode *node = new vsub8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_mem_rule: {
      vsub8S_memNode *node = new vsub8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16S_reg_rule: {
      vsub16S_regNode *node = new vsub16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16S_mem_rule: {
      vsub16S_memNode *node = new vsub16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub32S_reg_rule: {
      vsub32S_regNode *node = new vsub32S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub32S_mem_rule: {
      vsub32S_memNode *node = new vsub32S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_rule: {
      vsub2INode *node = new vsub2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_reg_rule: {
      vsub2I_regNode *node = new vsub2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_mem_rule: {
      vsub2I_memNode *node = new vsub2I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_rule: {
      vsub4INode *node = new vsub4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_reg_rule: {
      vsub4I_regNode *node = new vsub4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_mem_rule: {
      vsub4I_memNode *node = new vsub4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8I_reg_rule: {
      vsub8I_regNode *node = new vsub8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8I_mem_rule: {
      vsub8I_memNode *node = new vsub8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16I_reg_rule: {
      vsub16I_regNode *node = new vsub16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16I_mem_rule: {
      vsub16I_memNode *node = new vsub16I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_rule: {
      vsub2LNode *node = new vsub2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_reg_rule: {
      vsub2L_regNode *node = new vsub2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_mem_rule: {
      vsub2L_memNode *node = new vsub2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4L_reg_rule: {
      vsub4L_regNode *node = new vsub4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4L_mem_rule: {
      vsub4L_memNode *node = new vsub4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8L_reg_rule: {
      vsub8L_regNode *node = new vsub8L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8L_mem_rule: {
      vsub8L_memNode *node = new vsub8L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_rule: {
      vsub2FNode *node = new vsub2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_reg_rule: {
      vsub2F_regNode *node = new vsub2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_mem_rule: {
      vsub2F_memNode *node = new vsub2F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_rule: {
      vsub4FNode *node = new vsub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_reg_rule: {
      vsub4F_regNode *node = new vsub4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_mem_rule: {
      vsub4F_memNode *node = new vsub4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8F_reg_rule: {
      vsub8F_regNode *node = new vsub8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8F_mem_rule: {
      vsub8F_memNode *node = new vsub8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16F_reg_rule: {
      vsub16F_regNode *node = new vsub16F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16F_mem_rule: {
      vsub16F_memNode *node = new vsub16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_rule: {
      vsub2DNode *node = new vsub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_reg_rule: {
      vsub2D_regNode *node = new vsub2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_mem_rule: {
      vsub2D_memNode *node = new vsub2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4D_reg_rule: {
      vsub4D_regNode *node = new vsub4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4D_mem_rule: {
      vsub4D_memNode *node = new vsub4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8D_reg_rule: {
      vsub8D_regNode *node = new vsub8D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8D_mem_rule: {
      vsub8D_memNode *node = new vsub8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2S_rule: {
      vmul2SNode *node = new vmul2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2S_reg_rule: {
      vmul2S_regNode *node = new vmul2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2S_mem_rule: {
      vmul2S_memNode *node = new vmul2S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2S_mem_0_rule: {
      vmul2S_mem_0Node *node = new vmul2S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_rule: {
      vmul4SNode *node = new vmul4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_reg_rule: {
      vmul4S_regNode *node = new vmul4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_mem_rule: {
      vmul4S_memNode *node = new vmul4S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_mem_0_rule: {
      vmul4S_mem_0Node *node = new vmul4S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_rule: {
      vmul8SNode *node = new vmul8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_reg_rule: {
      vmul8S_regNode *node = new vmul8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_mem_rule: {
      vmul8S_memNode *node = new vmul8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_mem_0_rule: {
      vmul8S_mem_0Node *node = new vmul8S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16S_reg_rule: {
      vmul16S_regNode *node = new vmul16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16S_mem_rule: {
      vmul16S_memNode *node = new vmul16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16S_mem_0_rule: {
      vmul16S_mem_0Node *node = new vmul16S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul32S_reg_rule: {
      vmul32S_regNode *node = new vmul32S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul32S_mem_rule: {
      vmul32S_memNode *node = new vmul32S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul32S_mem_0_rule: {
      vmul32S_mem_0Node *node = new vmul32S_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_rule: {
      vmul2INode *node = new vmul2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_reg_rule: {
      vmul2I_regNode *node = new vmul2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_mem_rule: {
      vmul2I_memNode *node = new vmul2I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_mem_0_rule: {
      vmul2I_mem_0Node *node = new vmul2I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_rule: {
      vmul4INode *node = new vmul4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_reg_rule: {
      vmul4I_regNode *node = new vmul4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_mem_rule: {
      vmul4I_memNode *node = new vmul4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_mem_0_rule: {
      vmul4I_mem_0Node *node = new vmul4I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2L_reg_rule: {
      vmul2L_regNode *node = new vmul2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2L_mem_rule: {
      vmul2L_memNode *node = new vmul2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2L_mem_0_rule: {
      vmul2L_mem_0Node *node = new vmul2L_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4L_reg_rule: {
      vmul4L_regNode *node = new vmul4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4L_mem_rule: {
      vmul4L_memNode *node = new vmul4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4L_mem_0_rule: {
      vmul4L_mem_0Node *node = new vmul4L_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8L_reg_rule: {
      vmul8L_regNode *node = new vmul8L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8L_mem_rule: {
      vmul8L_memNode *node = new vmul8L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8L_mem_0_rule: {
      vmul8L_mem_0Node *node = new vmul8L_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8I_reg_rule: {
      vmul8I_regNode *node = new vmul8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8I_mem_rule: {
      vmul8I_memNode *node = new vmul8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8I_mem_0_rule: {
      vmul8I_mem_0Node *node = new vmul8I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16I_reg_rule: {
      vmul16I_regNode *node = new vmul16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16I_mem_rule: {
      vmul16I_memNode *node = new vmul16I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16I_mem_0_rule: {
      vmul16I_mem_0Node *node = new vmul16I_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_rule: {
      vmul2FNode *node = new vmul2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_reg_rule: {
      vmul2F_regNode *node = new vmul2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_mem_rule: {
      vmul2F_memNode *node = new vmul2F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_mem_0_rule: {
      vmul2F_mem_0Node *node = new vmul2F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_rule: {
      vmul4FNode *node = new vmul4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_reg_rule: {
      vmul4F_regNode *node = new vmul4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_mem_rule: {
      vmul4F_memNode *node = new vmul4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_mem_0_rule: {
      vmul4F_mem_0Node *node = new vmul4F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8F_reg_rule: {
      vmul8F_regNode *node = new vmul8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8F_mem_rule: {
      vmul8F_memNode *node = new vmul8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8F_mem_0_rule: {
      vmul8F_mem_0Node *node = new vmul8F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16F_reg_rule: {
      vmul16F_regNode *node = new vmul16F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16F_mem_rule: {
      vmul16F_memNode *node = new vmul16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16F_mem_0_rule: {
      vmul16F_mem_0Node *node = new vmul16F_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_rule: {
      vmul2DNode *node = new vmul2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_reg_rule: {
      vmul2D_regNode *node = new vmul2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_mem_rule: {
      vmul2D_memNode *node = new vmul2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_mem_0_rule: {
      vmul2D_mem_0Node *node = new vmul2D_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4D_reg_rule: {
      vmul4D_regNode *node = new vmul4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4D_mem_rule: {
      vmul4D_memNode *node = new vmul4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4D_mem_0_rule: {
      vmul4D_mem_0Node *node = new vmul4D_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8D_reg_rule: {
      vmul8D_regNode *node = new vmul8D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8D_mem_rule: {
      vmul8D_memNode *node = new vmul8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8D_mem_0_rule: {
      vmul8D_mem_0Node *node = new vmul8D_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vcmov8F_reg_rule: {
      vcmov8F_regNode *node = new vcmov8F_regNode();
      node->set_opnd_array(5, MachOperGenerator(LEGVECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vcmov4D_reg_rule: {
      vcmov4D_regNode *node = new vcmov4D_regNode();
      node->set_opnd_array(5, MachOperGenerator(LEGVECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_rule: {
      vdiv2FNode *node = new vdiv2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_reg_rule: {
      vdiv2F_regNode *node = new vdiv2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_mem_rule: {
      vdiv2F_memNode *node = new vdiv2F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_rule: {
      vdiv4FNode *node = new vdiv4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_reg_rule: {
      vdiv4F_regNode *node = new vdiv4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_mem_rule: {
      vdiv4F_memNode *node = new vdiv4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv8F_reg_rule: {
      vdiv8F_regNode *node = new vdiv8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv8F_mem_rule: {
      vdiv8F_memNode *node = new vdiv8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv16F_reg_rule: {
      vdiv16F_regNode *node = new vdiv16F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv16F_mem_rule: {
      vdiv16F_memNode *node = new vdiv16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_rule: {
      vdiv2DNode *node = new vdiv2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_reg_rule: {
      vdiv2D_regNode *node = new vdiv2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_mem_rule: {
      vdiv2D_memNode *node = new vdiv2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4D_reg_rule: {
      vdiv4D_regNode *node = new vdiv4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4D_mem_rule: {
      vdiv4D_memNode *node = new vdiv4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv8D_reg_rule: {
      vdiv8D_regNode *node = new vdiv8D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv8D_mem_rule: {
      vdiv8D_memNode *node = new vdiv8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt_rule: {
      vshiftcntNode *node = new vshiftcntNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt_0_rule: {
      vshiftcnt_0Node *node = new vshiftcnt_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt2D_reg_rule: {
      vsqrt2D_regNode *node = new vsqrt2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt2D_mem_rule: {
      vsqrt2D_memNode *node = new vsqrt2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt4D_reg_rule: {
      vsqrt4D_regNode *node = new vsqrt4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt4D_mem_rule: {
      vsqrt4D_memNode *node = new vsqrt4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt8D_reg_rule: {
      vsqrt8D_regNode *node = new vsqrt8D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt8D_mem_rule: {
      vsqrt8D_memNode *node = new vsqrt8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt2F_reg_rule: {
      vsqrt2F_regNode *node = new vsqrt2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt2F_mem_rule: {
      vsqrt2F_memNode *node = new vsqrt2F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt4F_reg_rule: {
      vsqrt4F_regNode *node = new vsqrt4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt4F_mem_rule: {
      vsqrt4F_memNode *node = new vsqrt4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt8F_reg_rule: {
      vsqrt8F_regNode *node = new vsqrt8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt8F_mem_rule: {
      vsqrt8F_memNode *node = new vsqrt8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt16F_reg_rule: {
      vsqrt16F_regNode *node = new vsqrt16F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt16F_mem_rule: {
      vsqrt16F_memNode *node = new vsqrt16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_rule: {
      vsll2SNode *node = new vsll2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_imm_rule: {
      vsll2S_immNode *node = new vsll2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_reg_rule: {
      vsll2S_regNode *node = new vsll2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_reg_imm_rule: {
      vsll2S_reg_immNode *node = new vsll2S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_rule: {
      vsll4SNode *node = new vsll4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_imm_rule: {
      vsll4S_immNode *node = new vsll4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_reg_rule: {
      vsll4S_regNode *node = new vsll4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_reg_imm_rule: {
      vsll4S_reg_immNode *node = new vsll4S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_rule: {
      vsll8SNode *node = new vsll8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_imm_rule: {
      vsll8S_immNode *node = new vsll8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_reg_rule: {
      vsll8S_regNode *node = new vsll8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_reg_imm_rule: {
      vsll8S_reg_immNode *node = new vsll8S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16S_reg_rule: {
      vsll16S_regNode *node = new vsll16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16S_reg_imm_rule: {
      vsll16S_reg_immNode *node = new vsll16S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll32S_reg_rule: {
      vsll32S_regNode *node = new vsll32S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll32S_reg_imm_rule: {
      vsll32S_reg_immNode *node = new vsll32S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_rule: {
      vsll2INode *node = new vsll2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_imm_rule: {
      vsll2I_immNode *node = new vsll2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_reg_rule: {
      vsll2I_regNode *node = new vsll2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_reg_imm_rule: {
      vsll2I_reg_immNode *node = new vsll2I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_rule: {
      vsll4INode *node = new vsll4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_imm_rule: {
      vsll4I_immNode *node = new vsll4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_reg_rule: {
      vsll4I_regNode *node = new vsll4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_reg_imm_rule: {
      vsll4I_reg_immNode *node = new vsll4I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8I_reg_rule: {
      vsll8I_regNode *node = new vsll8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8I_reg_imm_rule: {
      vsll8I_reg_immNode *node = new vsll8I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16I_reg_rule: {
      vsll16I_regNode *node = new vsll16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16I_reg_imm_rule: {
      vsll16I_reg_immNode *node = new vsll16I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_rule: {
      vsll2LNode *node = new vsll2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_imm_rule: {
      vsll2L_immNode *node = new vsll2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_reg_rule: {
      vsll2L_regNode *node = new vsll2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_reg_imm_rule: {
      vsll2L_reg_immNode *node = new vsll2L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4L_reg_rule: {
      vsll4L_regNode *node = new vsll4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4L_reg_imm_rule: {
      vsll4L_reg_immNode *node = new vsll4L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8L_reg_rule: {
      vsll8L_regNode *node = new vsll8L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8L_reg_imm_rule: {
      vsll8L_reg_immNode *node = new vsll8L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_rule: {
      vsrl2SNode *node = new vsrl2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_imm_rule: {
      vsrl2S_immNode *node = new vsrl2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_reg_rule: {
      vsrl2S_regNode *node = new vsrl2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_reg_imm_rule: {
      vsrl2S_reg_immNode *node = new vsrl2S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_rule: {
      vsrl4SNode *node = new vsrl4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_imm_rule: {
      vsrl4S_immNode *node = new vsrl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_reg_rule: {
      vsrl4S_regNode *node = new vsrl4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_reg_imm_rule: {
      vsrl4S_reg_immNode *node = new vsrl4S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_rule: {
      vsrl8SNode *node = new vsrl8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_imm_rule: {
      vsrl8S_immNode *node = new vsrl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_reg_rule: {
      vsrl8S_regNode *node = new vsrl8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_reg_imm_rule: {
      vsrl8S_reg_immNode *node = new vsrl8S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16S_reg_rule: {
      vsrl16S_regNode *node = new vsrl16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16S_reg_imm_rule: {
      vsrl16S_reg_immNode *node = new vsrl16S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl32S_reg_rule: {
      vsrl32S_regNode *node = new vsrl32S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl32S_reg_imm_rule: {
      vsrl32S_reg_immNode *node = new vsrl32S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_rule: {
      vsrl2INode *node = new vsrl2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_imm_rule: {
      vsrl2I_immNode *node = new vsrl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_reg_rule: {
      vsrl2I_regNode *node = new vsrl2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_reg_imm_rule: {
      vsrl2I_reg_immNode *node = new vsrl2I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_rule: {
      vsrl4INode *node = new vsrl4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_imm_rule: {
      vsrl4I_immNode *node = new vsrl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_reg_rule: {
      vsrl4I_regNode *node = new vsrl4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_reg_imm_rule: {
      vsrl4I_reg_immNode *node = new vsrl4I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8I_reg_rule: {
      vsrl8I_regNode *node = new vsrl8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8I_reg_imm_rule: {
      vsrl8I_reg_immNode *node = new vsrl8I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16I_reg_rule: {
      vsrl16I_regNode *node = new vsrl16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16I_reg_imm_rule: {
      vsrl16I_reg_immNode *node = new vsrl16I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_rule: {
      vsrl2LNode *node = new vsrl2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_imm_rule: {
      vsrl2L_immNode *node = new vsrl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_reg_rule: {
      vsrl2L_regNode *node = new vsrl2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_reg_imm_rule: {
      vsrl2L_reg_immNode *node = new vsrl2L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4L_reg_rule: {
      vsrl4L_regNode *node = new vsrl4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4L_reg_imm_rule: {
      vsrl4L_reg_immNode *node = new vsrl4L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8L_reg_rule: {
      vsrl8L_regNode *node = new vsrl8L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8L_reg_imm_rule: {
      vsrl8L_reg_immNode *node = new vsrl8L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_rule: {
      vsra2SNode *node = new vsra2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_imm_rule: {
      vsra2S_immNode *node = new vsra2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_reg_rule: {
      vsra2S_regNode *node = new vsra2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_reg_imm_rule: {
      vsra2S_reg_immNode *node = new vsra2S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_rule: {
      vsra4SNode *node = new vsra4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_imm_rule: {
      vsra4S_immNode *node = new vsra4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_reg_rule: {
      vsra4S_regNode *node = new vsra4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_reg_imm_rule: {
      vsra4S_reg_immNode *node = new vsra4S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_rule: {
      vsra8SNode *node = new vsra8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_imm_rule: {
      vsra8S_immNode *node = new vsra8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_reg_rule: {
      vsra8S_regNode *node = new vsra8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_reg_imm_rule: {
      vsra8S_reg_immNode *node = new vsra8S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16S_reg_rule: {
      vsra16S_regNode *node = new vsra16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16S_reg_imm_rule: {
      vsra16S_reg_immNode *node = new vsra16S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra32S_reg_rule: {
      vsra32S_regNode *node = new vsra32S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra32S_reg_imm_rule: {
      vsra32S_reg_immNode *node = new vsra32S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_rule: {
      vsra2INode *node = new vsra2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_imm_rule: {
      vsra2I_immNode *node = new vsra2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_reg_rule: {
      vsra2I_regNode *node = new vsra2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_reg_imm_rule: {
      vsra2I_reg_immNode *node = new vsra2I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_rule: {
      vsra4INode *node = new vsra4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_imm_rule: {
      vsra4I_immNode *node = new vsra4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_reg_rule: {
      vsra4I_regNode *node = new vsra4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_reg_imm_rule: {
      vsra4I_reg_immNode *node = new vsra4I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8I_reg_rule: {
      vsra8I_regNode *node = new vsra8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8I_reg_imm_rule: {
      vsra8I_reg_immNode *node = new vsra8I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16I_reg_rule: {
      vsra16I_regNode *node = new vsra16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16I_reg_imm_rule: {
      vsra16I_reg_immNode *node = new vsra16I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand4B_rule: {
      vand4BNode *node = new vand4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand4B_reg_rule: {
      vand4B_regNode *node = new vand4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand4B_mem_rule: {
      vand4B_memNode *node = new vand4B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand4B_mem_0_rule: {
      vand4B_mem_0Node *node = new vand4B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_rule: {
      vand8BNode *node = new vand8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_reg_rule: {
      vand8B_regNode *node = new vand8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_mem_rule: {
      vand8B_memNode *node = new vand8B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_mem_0_rule: {
      vand8B_mem_0Node *node = new vand8B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_rule: {
      vand16BNode *node = new vand16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_reg_rule: {
      vand16B_regNode *node = new vand16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_mem_rule: {
      vand16B_memNode *node = new vand16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_mem_0_rule: {
      vand16B_mem_0Node *node = new vand16B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand32B_reg_rule: {
      vand32B_regNode *node = new vand32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand32B_mem_rule: {
      vand32B_memNode *node = new vand32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand32B_mem_0_rule: {
      vand32B_mem_0Node *node = new vand32B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand64B_reg_rule: {
      vand64B_regNode *node = new vand64B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand64B_mem_rule: {
      vand64B_memNode *node = new vand64B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand64B_mem_0_rule: {
      vand64B_mem_0Node *node = new vand64B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor4B_rule: {
      vor4BNode *node = new vor4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor4B_reg_rule: {
      vor4B_regNode *node = new vor4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor4B_mem_rule: {
      vor4B_memNode *node = new vor4B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor4B_mem_0_rule: {
      vor4B_mem_0Node *node = new vor4B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_rule: {
      vor8BNode *node = new vor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_reg_rule: {
      vor8B_regNode *node = new vor8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_mem_rule: {
      vor8B_memNode *node = new vor8B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_mem_0_rule: {
      vor8B_mem_0Node *node = new vor8B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_rule: {
      vor16BNode *node = new vor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_reg_rule: {
      vor16B_regNode *node = new vor16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_mem_rule: {
      vor16B_memNode *node = new vor16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_mem_0_rule: {
      vor16B_mem_0Node *node = new vor16B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor32B_reg_rule: {
      vor32B_regNode *node = new vor32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor32B_mem_rule: {
      vor32B_memNode *node = new vor32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor32B_mem_0_rule: {
      vor32B_mem_0Node *node = new vor32B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor64B_reg_rule: {
      vor64B_regNode *node = new vor64B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor64B_mem_rule: {
      vor64B_memNode *node = new vor64B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor64B_mem_0_rule: {
      vor64B_mem_0Node *node = new vor64B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor4B_rule: {
      vxor4BNode *node = new vxor4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor4B_reg_rule: {
      vxor4B_regNode *node = new vxor4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor4B_mem_rule: {
      vxor4B_memNode *node = new vxor4B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor4B_mem_0_rule: {
      vxor4B_mem_0Node *node = new vxor4B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_rule: {
      vxor8BNode *node = new vxor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_reg_rule: {
      vxor8B_regNode *node = new vxor8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_mem_rule: {
      vxor8B_memNode *node = new vxor8B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_mem_0_rule: {
      vxor8B_mem_0Node *node = new vxor8B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_rule: {
      vxor16BNode *node = new vxor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_reg_rule: {
      vxor16B_regNode *node = new vxor16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_mem_rule: {
      vxor16B_memNode *node = new vxor16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_mem_0_rule: {
      vxor16B_mem_0Node *node = new vxor16B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor32B_reg_rule: {
      vxor32B_regNode *node = new vxor32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor32B_mem_rule: {
      vxor32B_memNode *node = new vxor32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor32B_mem_0_rule: {
      vxor32B_mem_0Node *node = new vxor32B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor64B_reg_rule: {
      vxor64B_regNode *node = new vxor64B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor64B_mem_rule: {
      vxor64B_memNode *node = new vxor64B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor64B_mem_0_rule: {
      vxor64B_mem_0Node *node = new vxor64B_mem_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma2D_reg_rule: {
      vfma2D_regNode *node = new vfma2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma2D_mem_rule: {
      vfma2D_memNode *node = new vfma2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma4D_reg_rule: {
      vfma4D_regNode *node = new vfma4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma4D_mem_rule: {
      vfma4D_memNode *node = new vfma4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma8D_reg_rule: {
      vfma8D_regNode *node = new vfma8D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma8D_mem_rule: {
      vfma8D_memNode *node = new vfma8D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma4F_reg_rule: {
      vfma4F_regNode *node = new vfma4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma4F_mem_rule: {
      vfma4F_memNode *node = new vfma4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma8F_reg_rule: {
      vfma8F_regNode *node = new vfma8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma8F_mem_rule: {
      vfma8F_memNode *node = new vfma8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma16F_reg_rule: {
      vfma16F_regNode *node = new vfma16F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfma16F_mem_rule: {
      vfma16F_memNode *node = new vfma16F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case smuladd4S2I_reg_rule: {
      smuladd4S2I_regNode *node = new smuladd4S2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladd4S2I_reg_rule: {
      vmuladd4S2I_regNode *node = new vmuladd4S2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case smuladd8S4I_reg_rule: {
      smuladd8S4I_regNode *node = new smuladd8S4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladd8S4I_reg_rule: {
      vmuladd8S4I_regNode *node = new vmuladd8S4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladd16S8I_reg_rule: {
      vmuladd16S8I_regNode *node = new vmuladd16S8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladd32S16I_reg_rule: {
      vmuladd32S16I_regNode *node = new vmuladd32S16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd4S2I_reg_rule: {
      vmuladdadd4S2I_regNode *node = new vmuladdadd4S2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd4S2I_reg_0_rule: {
      vmuladdadd4S2I_reg_0Node *node = new vmuladdadd4S2I_reg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd8S4I_reg_rule: {
      vmuladdadd8S4I_regNode *node = new vmuladdadd8S4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd8S4I_reg_0_rule: {
      vmuladdadd8S4I_reg_0Node *node = new vmuladdadd8S4I_reg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd16S8I_reg_rule: {
      vmuladdadd16S8I_regNode *node = new vmuladdadd16S8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd16S8I_reg_0_rule: {
      vmuladdadd16S8I_reg_0Node *node = new vmuladdadd16S8I_reg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd32S16I_reg_rule: {
      vmuladdadd32S16I_regNode *node = new vmuladdadd32S16I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmuladdadd32S16I_reg_0_rule: {
      vmuladdadd32S16I_reg_0Node *node = new vmuladdadd32S16I_reg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vpopcount2I_rule: {
      vpopcount2INode *node = new vpopcount2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vpopcount4I_rule: {
      vpopcount4INode *node = new vpopcount4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vpopcount8I_rule: {
      vpopcount8INode *node = new vpopcount8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vpopcount16I_rule: {
      vpopcount16INode *node = new vpopcount16INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DIA32=1
#ifndef IA32
#  error "IA32 must be defined"
#endif // IA32
// Check adlc -U_LP64
#ifdef _LP64
#  error "_LP64 must not be defined"
#endif // _LP64
