#line 1 "dfa_x86.cpp"
//
// Copyright (c) 1997, 2018, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 8;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 1;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NCXREGI, ncxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NADXREGI, nadxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NAXREGI, naxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RREGI, rRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, eAXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, eBXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, eCXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, eDXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, eDIRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, eSIRegI_rule, c)
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, load_long_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, load_long_indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(PREGP, pRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NABXREGP, nabxRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NAXREGP, naxRegP_rule, c)
    }
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, eRegP_no_EBP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, indirect_win95_safe_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGP, eRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, anyRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, eAXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGP, eBXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, eCXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, eSIRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGP, eDIRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VLREGF, vlRegF_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, MoveVL2F_rule, c+100)
    }
    if(         
#line 4092 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=1 
#line 150 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(REGF, regF_rule, c)	  // overwrites higher cost rule
    }
    if(         
#line 4073 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE < 2 
#line 158 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGFPR, regFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, regFPR1_rule, c)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VLREGD, vlRegD_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, MoveVL2D_rule, c+100)
    }
    if(         
#line 4110 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 
#line 174 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(REGD, regD_rule, c)	  // overwrites higher cost rule
    }
    if(         
#line 4038 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE < 2 
#line 182 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGDPR, regDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, regDPR1_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, regDPR2_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, regnotDPR1_rule, c)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EADXREGL_LOW_ONLY, eADXRegL_low_only_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGL, eRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, eADXRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, eBCXRegL_rule, c)
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_LEGT, flagsReg_ulong_LEGT_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_EQNE, flagsReg_ulong_EQNE_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_LTGE, flagsReg_ulong_LTGE_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, flagsReg_long_LEGT_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, flagsReg_long_EQNE_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, flagsReg_long_LTGE_rule, c)
    }
    if(         
#line 3990 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
false
#line 232 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, eFlagsRegUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, eFlagsRegU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, eFlagsReg_rule, c)
    }
}
void  State::_sub_Op_VecS(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECS, legVecS_rule, c)
        DFA_PRODUCTION__SET_VALID(VECS, MoveLeg2VecS_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECS, vecS_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECD, legVecD_rule, c)
        DFA_PRODUCTION__SET_VALID(VECD, MoveLeg2VecD_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECD, vecD_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecX(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECX, legVecX_rule, c)
        DFA_PRODUCTION__SET_VALID(VECX, MoveLeg2VecX_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECX, vecX_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecY(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECY, legVecY_rule, c)
        DFA_PRODUCTION__SET_VALID(VECY, MoveLeg2VecY_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECY, vecY_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecZ(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECZ, legVecZ_rule, c)
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECZ, vecZ_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 2673 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 306 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+150;
        DFA_PRODUCTION__SET_VALID(VLREGD, absD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, MoveVL2D_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2661 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 316 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9756 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 330 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, absDPR_reg_rule, c)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 2648 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 344 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+150;
        DFA_PRODUCTION__SET_VALID(VLREGF, absF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, MoveVL2F_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2637 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 354 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) &&
        (
#line 10362 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 368 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR1, absFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, absFPR_reg_rule, c)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2199 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 380 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2187 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 390 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2187 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 404 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2175 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 418 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2164 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 432 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2152 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 446 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2152 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 460 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2140 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 474 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _MULD_REGDPR_REGDPR) &&
        (
#line 9962 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 488 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_MULD_REGDPR_REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_mulDPR_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGDPR_REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9962 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 500 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGDPR_REGDPR]+_kids[1]->_cost[REGDPR]+250;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_mulDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR_IMMDPR, _AddD_regDPR_immDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) &&
        (
#line 9848 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1 && _kids[1]->_leaf->getd() != 0.0 && _kids[1]->_leaf->getd() != 1.0 
#line 524 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR1) &&
        (
#line 9835 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 544 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR1]+125;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_imm1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR__LOADD_MEMORY_, _AddD_regDPR__LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD__LOADD_MEMORY__REGDPR, _AddD__LoadD_memory__regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9805 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 572 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9805 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 592 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR_REGDPR, _AddD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9776 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 616 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2128 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 639 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2116 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2116 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 663 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2104 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 677 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2093 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 691 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2081 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 705 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2081 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 719 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2069 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 733 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF_REGFPR_REGFPR) &&
        (
#line 10634 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 747 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF_REGFPR_REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGFPR_REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10634 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 757 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGFPR_REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF_REGFPR__LOADF_MEMORY_) &&
        (
#line 10612 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 771 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF_REGFPR__LOADF_MEMORY_]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGFPR__LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10612 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 785 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGFPR__LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF__LOADF_MEMORY__REGFPR) &&
        (
#line 10612 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 799 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF__LOADF_MEMORY__REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF__LOADF_MEMORY__REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10612 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 813 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF__LOADF_MEMORY__REGFPR]+_kids[1]->_cost[REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10471 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 827 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10456 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 841 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_imm_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10441 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 856 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10427 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 873 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_cisc_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10427 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 890 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_cisc_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10413 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 907 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10400 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 924 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10400 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 938 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10384 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 952 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10384 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 969 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10350 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 986 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10337 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 1000 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+400;
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[0]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cadd_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI_IMMI_M1, _AddI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI_M1, _AddI__LoadI_memory__immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI1, _AddI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI, _AddI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI__LOADI_MEMORY_, _AddI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__RREGI, _AddI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) &&
        (
#line 7204 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseIncDec
#line 1257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, decI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) &&
        (
#line 7172 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseIncDec
#line 1301 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, incI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML_M1, _AddL__LoadL_memory__immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL_EREGL_IMML_M1, _AddL_eRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, subP_eReg_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, addP_eReg_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI]+110;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP_eReg_immI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET_WIN95_SAFE, indIndexScaleOffset_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2, _AddP_eRegP_no_EBP__LShiftI_rRegI_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE_WIN95_SAFE, indIndexScale_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_NO_EBP_RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_NO_EBP_RREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET_WIN95_SAFE, indIndexOffset_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_NO_EBP_RREGI, _AddP_eRegP_no_EBP_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDOFFSET32_WIN95_SAFE, indOffset32_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(INDOFFSET8_WIN95_SAFE, indOffset8_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_REGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_REGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDOFFSET32, load_long_indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indOffset32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP__LSHIFTI_RREGI_IMMI2) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP__LSHIFTI_RREGI_IMMI2]+_kids[1]->_cost[IMMI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET, indIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxScaleOff_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP__LSHIFTI_RREGI_IMMI2, _AddP_eRegP__LShiftI_rRegI_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE, indIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxScale_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[RREGI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_RREGI]+_kids[1]->_cost[IMMI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET, indIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxOff_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_RREGI, _AddP_eRegP_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMP) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMP]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32X, indOffset32X_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32, indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP32_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8, indOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP8_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_MEMORY, _AndI_rRegI_memory_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI, _AndI_rRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, and_cmpLTMask_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, and_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__CMPLTMASK_RREGI_RREGI, _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__CMPLTMASK_RREGI_RREGI_RREGI, _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 8431 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2096 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8431 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2140 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 8416 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2184 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8416 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2228 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsrI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0__LOADI_MEMORY_) &&
        (
#line 8370 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2272 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0__LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8370 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2316 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) &&
        (
#line 8357 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2360 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8357 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2404 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0_RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsiI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 8343 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2448 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8343 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2492 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 8330 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2536 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8330 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2580 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andnI_rReg_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI, _AndI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__LOADI_MEMORY_, _AndI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__RREGI, _AndI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMU31];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMU31, _AndI__LoadI_memory__immU31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_65535, _AndI__LoadI_memory__immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_255, _AndI__LoadI_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2UB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI, _AndI__LoadUS_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI_255, _AndI__LoadUS_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUB_MEMORY__IMMI, _AndI__LoadUB_memory__immI_rule, c)
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_32BITS]+250;
        DFA_PRODUCTION__SET_VALID(EREGL, zerox_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, zerox_long_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, zerox_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_RREGI_]+_kids[1]->_cost[IMML_32BITS]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convI2L_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 9245 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2918 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9245 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2938 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_EREGL_IMML_M1) &&
        (
#line 9218 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2958 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_ADDL_EREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 9218 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2978 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_EREGL_IMML_M1]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsrL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsrL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsrL_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0__LOADL_MEMORY_) &&
        (
#line 9134 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 2998 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0__LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9134 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3018 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0_EREGL) &&
        (
#line 9109 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3038 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_SUBL_IMML0_EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0_EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 9109 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3058 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0_EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsiL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsiL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsiL_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORL_EREGL_IMML_M1) &&
        (
#line 9088 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3078 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_XORL_EREGL_IMML_M1]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9088 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3098 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_EREGL_IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _XORL_EREGL_IMML_M1) &&
        (
#line 9069 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3118 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_XORL_EREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 9069 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 3138 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_EREGL_IMML_M1]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andnL_eReg_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andnL_eReg_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andnL_eReg_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[IMML_32BITS];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_NADXREGI__IMML_32BITS, _AndL__ConvI2L_nadxRegI__immL_32bits_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EAXREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EAXREGI_]+_kids[1]->_cost[IMML_32BITS];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_EAXREGI__IMML_32BITS, _AndL__ConvI2L_eAXRegI__immL_32bits_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) &&
        (
#line 11925 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 3243 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, array_equalsC_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) &&
        (
#line 11908 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 3263 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, array_equalsB_rule, c)
      }
    }
}
void  State::_sub_Op_AtanD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 10096 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 3309 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, atanD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 10086 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 3319 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, atanDPR_reg_rule, c)
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECZ__LOADVECTOR_MEMORY_, _Binary_vecZ__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECZ_VECZ, _Binary_vecZ_vecZ_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECY__LOADVECTOR_MEMORY_, _Binary_vecY__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECY_VECY, _Binary_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECX__LOADVECTOR_MEMORY_, _Binary_vecX__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECX_VECX, _Binary_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], LEGVECY) && STATE__VALID_CHILD(_kids[1], LEGVECY) ) {
      unsigned int c = _kids[0]->_cost[LEGVECY]+_kids[1]->_cost[LEGVECY];
        DFA_PRODUCTION__SET_VALID(_BINARY_LEGVECY_LEGVECY, _Binary_legVecY_legVecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_VCMPPD) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_VCMPPD]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_VCMPPD_IMMI8, _Binary_cmpOp_vcmppd_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LEGT) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_COMMUTE]+_kids[1]->_cost[FLAGSREG_LONG_LEGT];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT, _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_EQNE) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_EQNE];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FLAGSREG_LONG_EQNE, _Binary_cmpOp_flagsReg_long_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_, _Binary_eRegL__LoadL_load_long_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LTGE) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_LTGE];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FLAGSREG_LONG_LTGE, _Binary_cmpOp_flagsReg_long_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NADXREGI) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[NADXREGI]+_kids[1]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_NADXREGI_EAXREGI, _Binary_nadxRegI_eAXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_EAXREGI, _Binary_eSIRegP_eAXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_IMMI, _Binary_eSIRegP_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[EDXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_EDXREGI, _Binary_eDIRegP_eDXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_ESIREGP, _Binary_eDIRegP_eSIRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EDXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_EDXREGI, _Binary_eSIRegP_eDXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_ECXREGI, _Binary_eDIRegP_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGI_ECXREGI, _Binary_eAXRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGP) && STATE__VALID_CHILD(_kids[1], ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[EAXREGP]+_kids[1]->_cost[ECXREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGP_ECXREGP, _Binary_eAXRegP_eCXRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EBCXREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_EADXREGL_EBCXREGL, _Binary_eADXRegL_eBCXRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGI_RREGI, _Binary_eAXRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EAXREGP]+_kids[1]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGP_EREGP, _Binary_eAXRegP_eRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGL_EREGL, _Binary_eRegL_eRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGFPR_REGFPR, _Binary_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGDPR_REGDPR, _Binary_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGFPR1_REGFPR, _Binary_regFPR1_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGDPR1_REGDPR, _Binary_regDPR1_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_FCMOV) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_FCMOV]+_kids[1]->_cost[EFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FCMOV_EFLAGSREGU, _Binary_cmpOp_fcmov_eFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGP_EREGP, _Binary_eRegP_eRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI__LOADI_MEMORY_, _Binary_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPUCF_EFLAGSREGUCF, _Binary_cmpOpUCF_eFlagsRegUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU_EFLAGSREGU, _Binary_cmpOpU_eFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI_RREGI, _Binary_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_EFLAGSREG, _Binary_cmpOp_eFlagsReg_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    if(         
#line 2021 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Bool()->_test._test != BoolTest::overflow &&
            n->as_Bool()->_test._test != BoolTest::no_overflow
#line 3487 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_VCMPPD, cmpOp_vcmppd_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU_COMMUTE, cmpOpU_commute_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_COMMUTE, cmpOp_commute_rule, c)
    }
    if(         
#line 4629 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->as_Bool()->_test._test != BoolTest::overflow &&
            n->as_Bool()->_test._test != BoolTest::no_overflow
#line 3504 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_FCMOV, cmpOp_fcmov_rule, c)
    }
    if(         
#line 4610 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 3513 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF2, cmpOpUCF2_rule, c)
    }
    if(         
#line 4589 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 3524 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF, cmpOpUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(RREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(EAXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, castX2P_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_EREGP_, _CastP2X_eRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+50;
        DFA_PRODUCTION__SET_VALID(RREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, castPP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, checkCastPP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ECXREGI) && STATE__VALID_CHILD(_kids[1], EDIREGP) &&
        (
#line 11635 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((ClearArrayNode*)n)->is_large()
#line 3743 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ECXREGI]+_kids[1]->_cost[EDIREGP]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_large_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ECXREGI) && STATE__VALID_CHILD(_kids[1], EDIREGP) &&
        (
#line 11576 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!((ClearArrayNode*)n)->is_large()
#line 3752 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ECXREGI]+_kids[1]->_cost[EDIREGP]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 13253 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3765 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 13243 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3775 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 13080 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3787 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 13070 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 12917 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 12907 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3835 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 7107 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 3855 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 7090 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 3869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 7045 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 3883 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 7001 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 3897 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, fcmovDPR_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FCMOV_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR1_REGDPR) &&
        (
#line 6979 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 3917 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FCMOV_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGDPR1_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, fcmovDPR_regU_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_VCMPPD_IMMI8) && STATE__VALID_CHILD(_kids[1], _BINARY_LEGVECY_LEGVECY) &&
        (
#line 7816 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 3939 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_VCMPPD_IMMI8]+_kids[1]->_cost[_BINARY_LEGVECY_LEGVECY]+100;
        DFA_PRODUCTION__SET_VALID(LEGVECY, vcmov4D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VECY, MoveLeg2VecY_rule, c+100)
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 13272 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 13262 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 3961 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 13098 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3971 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 13089 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 3985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 12935 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 3999 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 12926 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 4013 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 7080 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 4027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 7063 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 4041 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 7027 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 4055 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 7014 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 4069 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, fcmovFPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, fcmovFPR_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FCMOV_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR1_REGFPR) &&
        (
#line 6990 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 4083 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FCMOV_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGFPR1_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, fcmovFPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, fcmovFPR_regU_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_VCMPPD_IMMI8) && STATE__VALID_CHILD(_kids[1], _BINARY_LEGVECY_LEGVECY) &&
        (
#line 7800 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 4099 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_VCMPPD_IMMI8]+_kids[1]->_cost[_BINARY_LEGVECY_LEGVECY]+100;
        DFA_PRODUCTION__SET_VALID(LEGVECY, vcmov8F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VECY, MoveLeg2VecY_rule, c+100)
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 13221 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4111 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 13211 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4131 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 13048 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4175 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 13038 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4219 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 12885 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4263 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 12875 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4307 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 6896 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_memUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 6886 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4395 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) &&
        (
#line 6875 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4439 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6865 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4483 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6855 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4527 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6845 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4571 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6828 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!VM_Version::supports_cmov() 
#line 4615 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, jmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) &&
        (
#line 6811 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!VM_Version::supports_cmov() 
#line 4659 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, jmovI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 13200 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4705 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 13189 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4717 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 13027 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 13016 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4757 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 12864 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4777 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 12853 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4797 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 7138 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4817 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 7127 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4837 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 7116 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 4857 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 13232 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 4879 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_LEGT_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 13059 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 4906 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_EQNE_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 12896 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 4971 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_LTGE_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 6942 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 5036 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_regUCF_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 6932 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 5101 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_regU_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+300;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_reg_nonP6_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 6906 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() 
#line 5226 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_reg_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9663 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 5293 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpD_ccmemCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9646 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 5302 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+145;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpD_ccmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9634 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 5311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpD_ccCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9617 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 5322 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+145;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpD_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9569 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 5333 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+200;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpDPR_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9556 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && UseSSE <=1
#line 5344 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpDPR_cc_P6CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9538 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && UseSSE <=1
#line 5355 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpDPR_cc_P6_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9695 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 5368 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+275;
        DFA_PRODUCTION__SET_VALID(XREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpD_regmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9675 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 5388 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+255;
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9603 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 5432 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR0) &&
        (
#line 9589 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 5476 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR0]+280;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpDPR_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10260 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 5522 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpF_ccmemCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10243 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 5531 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+165;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpF_ccmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10231 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 5540 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpF_ccCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10214 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 5551 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+145;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpF_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10166 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE == 0
#line 5562 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+200;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpFPR_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10152 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && UseSSE == 0
#line 5573 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpFPR_cc_P6CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10134 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cmov() && UseSSE == 0
#line 5584 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpFPR_cc_P6_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10292 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 5597 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+275;
        DFA_PRODUCTION__SET_VALID(XREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpF_regmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10272 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 5617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+255;
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10200 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE == 0
#line 5661 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR0) &&
        (
#line 10186 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE == 0
#line 5705 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR0]+280;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpFPR_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_MEMORY]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, cmpL_reg_flags_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+300;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_LEGT) || _cost[FLAGSREG_LONG_LEGT] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, cmpL_zero_flags_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, cmpL_reg_flags_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+200;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_EQNE) || _cost[FLAGSREG_LONG_EQNE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, cmpL_zero_flags_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, cmpL_reg_flags_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_LTGE) || _cost[FLAGSREG_LONG_LTGE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, cmpL_zero_flags_LTGE_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+1000;
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CMPLTMASK_RREGI_RREGI, _CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpLTMask0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[NCXREGI]+400;
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpLTMask_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_ESIREGP_EAXREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_ESIREGP_EAXREGP]+_kids[1]->_cost[IMMP0]+1000;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, partialSubtypeCheck_vs_Zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMI0]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testP_Reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testP_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) &&
        (
#line 12154 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 n->in(2)->in(2)->bottom_type()->reloc() == relocInfo::none 
#line 5912 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_mem_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMP]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGP]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, testU_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_LEGT, cmpUL_reg_flags_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+300;
      if (STATE__NOT_YET_VALID(FLAGSREG_ULONG_LEGT) || _cost[FLAGSREG_ULONG_LEGT] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_LEGT, cmpUL_zero_flags_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_EQNE, cmpUL_reg_flags_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+200;
      if (STATE__NOT_YET_VALID(FLAGSREG_ULONG_EQNE) || _cost[FLAGSREG_ULONG_EQNE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_EQNE, cmpUL_zero_flags_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_LTGE, cmpUL_reg_flags_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(FLAGSREG_ULONG_LTGE) || _cost[FLAGSREG_ULONG_LTGE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_ULONG_LTGE, cmpUL_zero_flags_LTGE_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapB_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapS_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) &&
        (
#line 7377 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cx8()
#line 6048 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGP_ECXREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapP_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapB_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapS_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapI_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) &&
        (
#line 7377 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cx8()
#line 6138 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapL_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGP_ECXREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapP_0_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndExchangeB_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndExchangeS_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndExchangeI_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) &&
        (
#line 7446 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
VM_Version::supports_cx8()
#line 6228 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, compareAndExchangeL_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGP_ECXREGP]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, compareAndExchangeP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, compareAndExchangeP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, compareAndExchangeP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, compareAndExchangeP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_GetAndAddB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], XREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[XREGI]+100;
        DFA_PRODUCTION__SET_VALID(XREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xaddB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7487 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->as_LoadStore()->result_not_used()
#line 6281 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddB_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xaddS_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7511 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->as_LoadStore()->result_not_used()
#line 6307 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddS_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xaddI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7534 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->as_LoadStore()->result_not_used()
#line 6333 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddI_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndSetB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], XREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[XREGI]+100;
        DFA_PRODUCTION__SET_VALID(XREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xchgB_rule, c)
    }
}
void  State::_sub_Op_GetAndSetS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xchgS_rule, c)
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xchgI_rule, c)
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], PREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[PREGP]+100;
        DFA_PRODUCTION__SET_VALID(PREGP, xchgP_rule, c)
    }
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 3600 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && jlong_cast(n->getd()) == 0 
#line 6400 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, loadConD0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100+100)
    }
    if(         
#line 3587 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 6410 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+125+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+125+100)
      }
    }
    if(         
#line 3578 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 6424 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR, immDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR_rule, c+125)
    }
    if(         
#line 3568 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && n->getd() == 1.0 
#line 6436 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR1, immDPR1_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR1_rule, c+125)
      }
    }
    if(         
#line 3558 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && n->getd() == 0.0 && !g_isnan(n->getd()) 
#line 6456 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR0, immDPR0_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR0_rule, c+125)
      }
    }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 3649 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE >= 1 && jint_cast(n->getf()) == 0 
#line 6478 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, loadConF0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100+100)
    }
    if(         
#line 3639 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE >= 1
#line 6488 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+125+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+125+100)
      }
    }
    if(         
#line 3629 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE == 0 
#line 6502 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR, immFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR_rule, c+125)
    }
    if(         
#line 3619 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE == 0 && n->getf() == 1.0F
#line 6512 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR1, immFPR1_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR1_rule, c+125)
      }
    }
    if(         
#line 3609 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE == 0 && n->getf() == 0.0F
#line 6526 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR0, immFPR0_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR0_rule, c+125)
      }
    }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 3687 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_int__ == 65535
#line 6543 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 3678 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 255 
#line 6551 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 3669 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 24 
#line 6559 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 3661 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 16 
#line 6567 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 3467 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 3 
#line 6575 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_3, immI_3_rule, c)
    }
    if(         
#line 3458 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 2 
#line 6583 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_2, immI_2_rule, c)
    }
    if(         
#line 3449 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 1 
#line 6591 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 3440 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ >= 32 && _n_get_int__ <= 63 
#line 6599 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32_63, immI_32_63_rule, c)
    }
    if(         
#line 3431 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ >= 1 && _n_get_int__ <= 31 
#line 6607 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1_31, immI_1_31_rule, c)
    }
    if(         
#line 3422 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_int__ == 32 
#line 6615 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 3412 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_int__ >= 0
#line 6623 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMU31, immU31_rule, c)
    }
    if(         
#line 3401 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
(-32768 <= _n_get_int__) && (_n_get_int__ <= 32767)
#line 6631 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI16, immI16_rule, c)
    }
    if(         
#line 3392 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
(-128 <= _n_get_int__) && (_n_get_int__ <= 127)
#line 6639 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI8, immI8_rule, c)
    }
    if(         
#line 3384 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 6647 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI2, immI2_rule, c)
    }
    if(         
#line 3374 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_int__ == -1
#line 6655 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 3364 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_int__ == 1
#line 6663 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI1, immI1_rule, c)
    }
    if(         
#line 3354 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_int__ == 0
#line 6671 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadConI0_rule, c+50)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadConI_rule, c+100)
      }
    }
   if ( /* RREGI KNOWN_VALID || */ _cost[RREGI] > 100) {
     DFA_PRODUCTION(RREGI, loadConI_rule, 100)
   }
   if ( /* STACKSLOTI KNOWN_VALID || */ _cost[STACKSLOTI] > 100+100) {
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 100+100)
   }
   if ( /* XREGI KNOWN_VALID || */ _cost[XREGI] > 100) {
     DFA_PRODUCTION(XREGI, loadConI_rule, 100)
   }
   if ( /* EAXREGI KNOWN_VALID || */ _cost[EAXREGI] > 100) {
     DFA_PRODUCTION(EAXREGI, loadConI_rule, 100)
   }
   if ( /* NCXREGI KNOWN_VALID || */ _cost[NCXREGI] > 100) {
     DFA_PRODUCTION(NCXREGI, loadConI_rule, 100)
   }
   if ( /* EBXREGI KNOWN_VALID || */ _cost[EBXREGI] > 100) {
     DFA_PRODUCTION(EBXREGI, loadConI_rule, 100)
   }
   if ( /* NADXREGI KNOWN_VALID || */ _cost[NADXREGI] > 100) {
     DFA_PRODUCTION(NADXREGI, loadConI_rule, 100)
   }
   if ( /* ECXREGI KNOWN_VALID || */ _cost[ECXREGI] > 100) {
     DFA_PRODUCTION(ECXREGI, loadConI_rule, 100)
   }
   if ( /* NAXREGI KNOWN_VALID || */ _cost[NAXREGI] > 100) {
     DFA_PRODUCTION(NAXREGI, loadConI_rule, 100)
   }
   if ( /* EDXREGI KNOWN_VALID || */ _cost[EDXREGI] > 100) {
     DFA_PRODUCTION(EDXREGI, loadConI_rule, 100)
   }
   if ( /* EDIREGI KNOWN_VALID || */ _cost[EDIREGI] > 100) {
     DFA_PRODUCTION(EDIREGI, loadConI_rule, 100)
   }
   if ( /* ESIREGI KNOWN_VALID || */ _cost[ESIREGI] > 100) {
     DFA_PRODUCTION(ESIREGI, loadConI_rule, 100)
   }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3546 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_long__ == (int)(_n_get_long__)
#line 6770 "dfa_x86.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML32, immL32_rule, c)
        DFA_PRODUCTION__SET_VALID(EADXREGL_LOW_ONLY, loadConL_low_only_rule, c+250)
    }
    if(         
#line 3536 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 6779 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 3526 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
(0 <= _n_get_long__) && (_n_get_long__ <= 127)
#line 6787 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_127, immL_127_rule, c)
    }
    if(         
#line 3515 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_long__ == -1L 
#line 6795 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 3505 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _n_get_long__ == 0L 
#line 6803 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, loadConL0_rule, c+150)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+150+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadConL0_rule, c+150)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadConL0_rule, c+150)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadConL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadConL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadConL_rule, c+200)
      }
    }
   if ( /* EREGL KNOWN_VALID || */ _cost[EREGL] > 200) {
     DFA_PRODUCTION(EREGL, loadConL_rule, 200)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > 200+200) {
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 200+200)
   }
   if ( /* EADXREGL KNOWN_VALID || */ _cost[EADXREGL] > 200) {
     DFA_PRODUCTION(EADXREGL, loadConL_rule, 200)
   }
   if ( /* EBCXREGL KNOWN_VALID || */ _cost[EBCXREGL] > 200) {
     DFA_PRODUCTION(EBCXREGL, loadConL_rule, 200)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3486 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 n->get_ptr() == 0 
#line 6845 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadConP_rule, c+100+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(PREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(DIRECT, direct_rule, c)
        DFA_PRODUCTION(MEMORY, direct_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(LONG_MEMORY, direct_rule, c)	  // overwrites higher cost rule
    }
     DFA_PRODUCTION(EREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ANYREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EAXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EREGP_NO_EBP, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(INDIRECT_WIN95_SAFE, loadConP_rule, 100+100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EBXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NAXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(PREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ECXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NABXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ESIREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_REGP, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_INDIRECT, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_MEMORY, load_long_indirect_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EDIREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(INDIRECT, loadConP_rule, 100)	  // overwrites higher cost rule
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10799 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 6955 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10776 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==1
#line 6965 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convDPR2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10766 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 6979 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convDPR2FPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1];
        DFA_PRODUCTION__SET_VALID(_CONVD2F_REGDPR1_, _ConvD2F_regDPR1__rule, c)
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10876 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 6996 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convD2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10856 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 7016 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convDPR2I_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10927 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 7062 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10904 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 7074 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convDPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convDPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convDPR2L_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10845 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 7096 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 10826 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==1
#line 7106 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convF2DPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10817 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==1
#line 7118 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, convFPR2D_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10809 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 7139 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convFPR2DPR_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11006 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 7161 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convF2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10985 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 7181 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convFPR2I_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11058 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 7227 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convF2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11034 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 7239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convFPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convFPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convFPR2L_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11154 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && !Compile__current____select_24_bit_instr__
#line 7262 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convI2DPR_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11141 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && UseXmmI2D 
#line 7274 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convXI2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11130 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 
#line 7284 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11120 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && !UseXmmI2D 
#line 7298 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11110 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 7312 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convI2DPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11239 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE>=2 && UseXmmI2F 
#line 7335 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convXI2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11228 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==1 || UseSSE>=2 && !UseXmmI2F 
#line 7345 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11216 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 7359 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, convI2FPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, convI2FPR_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11204 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 7369 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, convI2FPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, convI2FPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11191 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 7383 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+200;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convI2FPR_SSF_mem_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11178 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 7398 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convI2FPR_SSF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11166 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && n->in(1)->Opcode() == Op_AndI && n->in(1)->in(2)->is_Con() && n->in(1)->in(2)->get_int() == 255 
#line 7415 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, conv24I2FPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, conv24I2FPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_RREGI_, _ConvI2L_rRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+375;
        DFA_PRODUCTION__SET_VALID(EREGL, convI2L_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, convI2L_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convI2L_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_EAXREGI_, _ConvI2L_eAXRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NADXREGI) ) {
      unsigned int c = _kids[0]->_cost[NADXREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_NADXREGI_, _ConvI2L_nadxRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMU31]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immU31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUB_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUB_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUB2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadB2L_rule, c)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11301 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 7621 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11287 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 7631 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, convL2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convL2FPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11316 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 7652 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convL2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63) &&
        (
#line 7721 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7681 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63]+1*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_RShift_high_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63) &&
        (
#line 7721 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7727 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63]+1*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_RShift_high_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32) &&
        (
#line 7706 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7773 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32]+0*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_high_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32) &&
        (
#line 7706 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 7819 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32]+0*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_high_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_CONVL2I_EREGL_, _ConvL2I_eRegL__rule, c)
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) &&
        (
#line 12442 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->has_vector_mask_set()
#line 7869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_and_restoreMask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) &&
        (
#line 12425 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->has_vector_mask_set()
#line 7878 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_and_restoreMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) &&
        (
#line 12407 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
n->has_vector_mask_set()
#line 7889 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_and_restoreMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) &&
        (
#line 12390 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!n->has_vector_mask_set()
#line 7900 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) &&
        (
#line 12375 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!n->has_vector_mask_set()
#line 7911 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) &&
        (
#line 12359 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!n->has_vector_mask_set()
#line 7922 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5253 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!UseCountLeadingZerosInstruction
#line 7935 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosI_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5241 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseCountLeadingZerosInstruction
#line 7955 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5301 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!UseCountLeadingZerosInstruction
#line 8001 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosL_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5278 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseCountLeadingZerosInstruction
#line 8021 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5349 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!UseCountTrailingZerosInstruction
#line 8067 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosI_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5337 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseCountTrailingZerosInstruction
#line 8087 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5392 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!UseCountTrailingZerosInstruction
#line 8133 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosL_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5369 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseCountTrailingZerosInstruction
#line 8153 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EAXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, CreateException_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2625 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8223 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2613 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8233 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2601 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2590 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8261 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2578 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8275 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2566 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8289 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_DIVD_REGDPR_REGDPR, _DivD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGNOTDPR1) &&
        (
#line 10015 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && Compile::current()->has_method() && Compile::current()->method()->is_strict() 
#line 8307 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGNOTDPR1]+01;
        DFA_PRODUCTION__SET_VALID(REGDPR1, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, strictfp_divDPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9992 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 8319 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, divDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2554 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8342 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2542 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8352 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2530 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8366 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2519 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8380 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2507 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8394 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2495 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8408 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10679 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8422 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, divFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, divFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10666 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8432 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, divFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBF_REGFPR_REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10650 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8447 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBF_REGFPR_REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, subFPR_divFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, subFPR_divFPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, divI_eReg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML32]+1000;
        DFA_PRODUCTION__SET_VALID(EADXREGL, divL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, divL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, divL_eReg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+10000;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, divL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, divL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, divL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_DivModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModI_eReg_divmod_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EDIREGP_EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EDIREGP_EDXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, encode_iso_array_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EBXREGP) &&
        (
#line 13447 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!Compile::current()->use_rtm()
#line 8527 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EBXREGP]+300;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastLock_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EBXREGP) &&
        (
#line 13431 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
Compile::current()->use_rtm()
#line 8536 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EBXREGP]+300;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastLockRTM_rule, c)
      }
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EAXREGP]+300;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 2821 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA
#line 8555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD_REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, fmaD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 2833 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA
#line 8567 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF_REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, fmaF_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpDir_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_HasNegatives(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, has_negatives_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPU_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_ULONG_LEGT) &&
        (
#line 13179 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le
#line 8608 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU_COMMUTE]+_kids[1]->_cost[FLAGSREG_ULONG_LEGT]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpUL_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LEGT) &&
        (
#line 13139 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le 
#line 8617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_COMMUTE]+_kids[1]->_cost[FLAGSREG_LONG_LEGT]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], FLAGSREG_ULONG_EQNE) &&
        (
#line 13007 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne
#line 8628 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[FLAGSREG_ULONG_EQNE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpUL_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_EQNE) &&
        (
#line 12972 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 8639 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_EQNE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], FLAGSREG_ULONG_LTGE) &&
        (
#line 12844 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge
#line 8650 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[FLAGSREG_ULONG_LTGE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpUL_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LTGE) &&
        (
#line 12806 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 8661 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_LTGE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF2) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF2]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpCon_rule, c)
      }
    }
}
void  State::_sub_Op_Jump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+350;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_rule, c)
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI_32_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI, _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI0_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI, _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_M1, _LShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI_ECXREGI, _LShiftI_ncxRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI8, _LShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI1, _LShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], XREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[XREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_XREGI_IMMI_16, _LShiftI_xRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], XREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[XREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_XREGI_IMMI_24, _LShiftI_xRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, salI_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, salI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shlI_eReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADUS_MEMORY__IMMI_24, _LShiftI__LoadUS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI2, _LShiftI_rRegI_immI2_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+500+200;
        DFA_PRODUCTION__SET_VALID(EREGL, salL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, salL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, salL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_1_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_3) &&
        (
#line 9386 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseNewLongLShift
#line 8888 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_3]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_3_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_3_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_2) &&
        (
#line 9367 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseNewLongLShift
#line 8908 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_2]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 9352 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseNewLongLShift
#line 8928 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(XREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(XREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADD_MEMORY_, _LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5961 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && !UseXmmLoadAndClearUpper
#line 9017 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_partial_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5950 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && UseXmmLoadAndClearUpper
#line 9027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, loadD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5936 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 9041 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGDPR, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadDPR_rule, c)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADF_MEMORY_, _LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5986 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 9059 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGFPR, loadFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5974 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 9069 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGF, loadF_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadKlass_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_MEMORY) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_LOAD_LONG_MEMORY_, _LoadL_load_long_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5883 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && ((LoadLNode*)n)->require_atomic_access()
#line 9130 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+160;
        DFA_PRODUCTION__SET_VALID(EREGL, loadLX_reg_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadLX_reg_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadLX_reg_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5869 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && ((LoadLNode*)n)->require_atomic_access()
#line 9142 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+180;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadLX_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5858 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1 && ((LoadLNode*)n)->require_atomic_access()
#line 9162 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadL_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_MEMORY) &&
        (
#line 5837 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!((LoadLNode*)n)->require_atomic_access()
#line 9182 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_MEMORY]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadPLocked_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADP_MEMORY_, _LoadP_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadS_rule, c)
    }
}
void  State::_sub_Op_LoopLimit(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_NADXREGI_EAXREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_NADXREGI_EAXREGI]+_kids[1]->_cost[IMMI]+300;
        DFA_PRODUCTION__SET_VALID(EAXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loopLimit_eReg_rule, c)
    }
}
void  State::_sub_Op_MulAddS2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RREGI_RREGI]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulAddS2I_rReg_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, maxI_eReg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_0_rule, c)
    }
}
void  State::_sub_Op_SetVectMaskI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2056 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
Matcher::has_predicated_vectors()
#line 9361 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, setMask_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_0_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 6772 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
Matcher::post_store_load_barrier(n)
#line 9406 "dfa_x86.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, minI_eReg_rule, c)
    }
}
void  State::_sub_Op_ModD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 10061 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 9446 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+250;
        DFA_PRODUCTION__SET_VALID(REGD, modD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 10047 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 9456 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, modDPR_reg_rule, c)
    }
}
void  State::_sub_Op_ModF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10719 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 9471 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+250;
        DFA_PRODUCTION__SET_VALID(REGF, modF_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10706 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 9481 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, modFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, modFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10692 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 9491 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, modFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+300;
        DFA_PRODUCTION__SET_VALID(EDXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, modI_eReg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML32]+1000;
        DFA_PRODUCTION__SET_VALID(EADXREGL, modL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, modL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, modL_eReg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+10000;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, modL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, modL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, modL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 11439 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 9549 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+85;
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11426 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 9559 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+95;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_stack_reg_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11412 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 9573 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+125;
        DFA_PRODUCTION__SET_VALID(REGFPR, MoveI2FPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, MoveI2FPR_stack_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11387 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 9595 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, MoveF2I_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11374 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 9615 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11363 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 9659 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+125;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveFPR2I_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11557 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 9744 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+85;
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11544 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && !UseXmmLoadAndClearUpper
#line 9754 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+95;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_sse_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11531 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && UseXmmLoadAndClearUpper
#line 9768 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+95;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11516 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 9782 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
        DFA_PRODUCTION__SET_VALID(REGDPR, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, MoveL2DPR_stack_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+200;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11487 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 9812 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION__SET_VALID(EREGL, MoveD2L_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, MoveD2L_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, MoveD2L_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11475 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 9824 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 11464 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 9844 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+125;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveDPR2L_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2483 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 9881 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2471 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 9891 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2471 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 9905 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2459 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 9919 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2448 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9933 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2436 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9947 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2436 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9961 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2424 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9975 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_MULD_REGDPR_REGDPR, _MulD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9929 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 9993 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR]+200;
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9929 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 10005 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) &&
        (
#line 9915 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && _kids[1]->_leaf->getd() != 0.0 && _kids[1]->_leaf->getd() != 1.0 
#line 10025 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGNOTDPR1) &&
        (
#line 9896 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && Compile::current()->has_method() && Compile::current()->method()->is_strict() 
#line 10045 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGNOTDPR1]+1;
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, strictfp_mulDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9876 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 10065 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2412 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 10088 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2400 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 10098 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2400 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 10112 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2388 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 10126 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2377 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 10140 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2365 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 10154 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2365 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 10168 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2353 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 10182 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_MULF_REGFPR_REGFPR, _MulF_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_MULF_REGFPR__LOADF_MEMORY_, _MulF_regFPR__LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_MULF__LOADF_MEMORY__REGFPR, _MulF__LoadF_memory__regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10577 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 10208 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10561 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 10218 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_imm_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10547 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 10233 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_mem_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10534 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 10250 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10534 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 10264 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10518 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 10278 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10518 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 10295 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10501 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 10312 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10486 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 10326 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+350;
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML_127) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML_127]+2*100+2*400;
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_con_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_con_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_con_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 7855 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
is_operand_hi32_zero(n->in(1)) && is_operand_hi32_zero(n->in(2))
#line 10525 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+1*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_hi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_hi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_hi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 7834 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
is_operand_hi32_zero(n->in(2))
#line 10545 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+2*100+2*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_rhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_rhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_rhi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 7813 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
is_operand_hi32_zero(n->in(1))
#line 10565 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+2*100+2*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_lhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_lhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_lhi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+4*100+3*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_NADXREGI__IMML_32BITS) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_EAXREGI__IMML_32BITS) &&
        /*mask*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_NADXREGI__IMML_32BITS]+_kids[1]->_cost[_ANDL__CONVI2L_EAXREGI__IMML_32BITS]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulIS_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulIS_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulIS_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_EAXREGI__IMML_32BITS) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_NADXREGI__IMML_32BITS) &&
        /*mask*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_EAXREGI__IMML_32BITS]+_kids[1]->_cost[_ANDL__CONVI2L_NADXREGI__IMML_32BITS]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulIS_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulIS_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulIS_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_EAXREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[_CONVI2L_EAXREGI_]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulI2L_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EAXREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_NADXREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EAXREGI_]+_kids[1]->_cost[_CONVI2L_NADXREGI_]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], _CONVI2L_NADXREGI_) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL_LOW_ONLY]+_kids[1]->_cost[_CONVI2L_NADXREGI_];
        DFA_PRODUCTION__SET_VALID(_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_, _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], EADXREGL_LOW_ONLY) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[EADXREGL_LOW_ONLY];
        DFA_PRODUCTION__SET_VALID(_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY, _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule, c)
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 2722 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 10672 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+150;
        DFA_PRODUCTION__SET_VALID(VLREGD, negD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, MoveVL2D_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2710 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 10682 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9766 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 10696 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, negDPR_reg_rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 2698 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 10710 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+150;
        DFA_PRODUCTION__SET_VALID(VLREGF, negF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, MoveVL2F_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2687 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 10720 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) &&
        (
#line 10372 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 10734 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR1, negFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, negFPR_reg_rule, c)
    }
}
void  State::_sub_Op_OnSpinWait(const Node *n){
    {
      unsigned int c = 200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, onspinwait_rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C32_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI1]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, rorI_eReg_i1_0_rule, c)
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_i1_0_rule, c)
      }
        DFA_PRODUCTION__SET_VALID(EBXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, rorI_eReg_i1_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rorI_eReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI8) &&
        (
#line 8559 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
  0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 10864 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI8) &&
        (
#line 8559 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
  0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 10908 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__IMMI, _OrI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORI_RREGI__LOADI_MEMORY_, _OrI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__RREGI, _OrI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_EREGP_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_EREGP_]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_castP2X_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CASTP2X_EREGP_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CASTP2X_EREGP_]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowAddI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowAddI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[EAXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowNegI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowSubI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowSubI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowMulI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, overflowMulI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGP];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_ESIREGP_EAXREGP, _PartialSubtypeCheck_eSIRegP_eAXRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGP]+1100;
        DFA_PRODUCTION__SET_VALID(EDIREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, partialSubtypeCheck_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 5437 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UsePopCountInstruction
#line 11404 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 5425 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UsePopCountInstruction
#line 11424 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 5467 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UsePopCountInstruction
#line 11470 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5450 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UsePopCountInstruction
#line 11490 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 10014 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 16
#line 11536 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vpopcount16I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 10003 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 8
#line 11546 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vpopcount8I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 9992 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 4
#line 11556 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vpopcount4I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) &&
        (
#line 9981 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 2
#line 11566 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vpopcount2I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6335 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==2
#line 11578 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6323 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==1
#line 11587 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6311 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==0
#line 11598 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6299 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
AllocatePrefetchInstr==3
#line 11609 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6289 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && AllocatePrefetchInstr!=3
#line 11620 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc0_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_XREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_XREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, i2s_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_XREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_XREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[ECXREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI8, _RShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI1, _RShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADUS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADUS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadS2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+600;
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_1_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63, _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63, _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32, _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32, _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule, c)
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10756 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12043 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+125;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, roundDouble_mem_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], _DIVD_REGDPR_REGDPR) &&
        (
#line 10033 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 && !(Compile::current()->has_method() && Compile::current()->method()->is_strict()) 
#line 12056 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_DIVD_REGDPR_REGDPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, divDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR_IMMDPR) &&
        (
#line 9861 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1 && _kids[0]->_kids[1]->_leaf->getd() != 0.0 && _kids[0]->_kids[1]->_leaf->getd() != 1.0 
#line 12079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR_IMMDPR]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, addDPR_reg_imm_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR__LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR__LOADD_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__, _RoundDouble__AddD_regDPR__LoadD_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD__LOADD_MEMORY__REGDPR) ) {
      unsigned int c = _kids[0]->_cost[_ADDD__LOADD_MEMORY__REGDPR];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_, _RoundDouble__AddD__LoadD_memory__regDPR__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR_REGDPR) &&
        (
#line 9790 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12110 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR_REGDPR]+250;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, addDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBD_REGDPR_REGDPR) &&
        (
#line 9728 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE <=1
#line 12133 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBD_REGDPR_REGDPR]+250;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, subDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE_REGDPR1_, _RoundDouble_regDPR1__rule, c)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10747 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 12162 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+125;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, roundFloat_mem_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1];
        DFA_PRODUCTION__SET_VALID(_ROUNDFLOAT_REGFPR1_, _RoundFloat_regFPR1__rule, c)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) &&
        (
#line 13495 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
SafepointMechanism::uses_thread_local_poll()
#line 12179 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_tls_rule, c)
    }
    if(         (
#line 13475 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
SafepointMechanism::uses_global_page_poll()
#line 12187 "dfa_x86.cpp"
) ) {
      unsigned int c = 125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD) &&
        (
#line 2795 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 12200 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 2783 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 12210 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2771 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 12224 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10107 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12238 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, sqrtDPR_reg_rule, c)
    }
}
void  State::_sub_Op_SqrtF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF) &&
        (
#line 2759 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 12252 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 2747 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 12262 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2735 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 12276 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], XREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[XREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 6482 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseStoreImmI16
#line 12304 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI16]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_EREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EAXREGP_EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EAXREGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__) &&
        (
#line 9819 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12345 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addDPR_mem_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_) &&
        (
#line 9819 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12354 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addDPR_mem_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 6553 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2
#line 12365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE_REGDPR1_) &&
        (
#line 6540 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12376 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE_REGDPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeDPR_rounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGDPR1) &&
        (
#line 6528 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12387 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGDPR1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeDPR_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF]+50;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMFPR) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMFPR]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVD2F_REGDPR1_) &&
        (
#line 6642 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1
#line 12410 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVD2F_REGDPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_Drounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDFLOAT_REGFPR1_) &&
        (
#line 6630 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 12421 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDFLOAT_REGFPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_rounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGFPR1) &&
        (
#line 6618 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0
#line 12432 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGFPR1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 6586 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=1
#line 12443 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__IMMI]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVL2I_EREGL_) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVL2I_EREGL_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 6439 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && ((StoreLNode*)n)->require_atomic_access()
#line 12593 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[EREGL]+360;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeLX_reg_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], STACKSLOTL) &&
        (
#line 6423 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE>=2 && ((StoreLNode*)n)->require_atomic_access()
#line 12602 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[STACKSLOTL]+380;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeLX_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], STACKSLOTL) &&
        (
#line 6410 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE<=1 && ((StoreLNode*)n)->require_atomic_access()
#line 12613 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[STACKSLOTL]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LONG_MEMORY) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 6383 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
!((StoreLNode*)n)->require_atomic_access()
#line 12624 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[LONG_MEMORY]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], ANYREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[ANYREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_ESIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_EDIREGP_ECXREGI) &&
        (
#line 11730 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UL
#line 12649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_ESIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_EDIREGP_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compareUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ECXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EDXREGI) &&
        (
#line 11715 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LU
#line 12669 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ECXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EDXREGI]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compareLU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ECXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EDXREGI) &&
        (
#line 11700 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UU
#line 12713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ECXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EDXREGI]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compareU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ECXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EDXREGI) &&
        (
#line 11685 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LL
#line 12757 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ECXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EDXREGI]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compareL_rule, c)
      }
    }
}
void  State::_sub_Op_StrCompressedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EDIREGP_EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EDIREGP_EDXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compress_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ESIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ESIREGP]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EAXREGI) &&
        (
#line 11877 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL)
#line 12837 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EAXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexofUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EAXREGI) &&
        (
#line 11861 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU)
#line 12857 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EAXREGI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexofU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EAXREGI) &&
        (
#line 11845 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL)
#line 12901 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EAXREGI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexofL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_IMMI) &&
        (
#line 11818 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL)
#line 12945 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_conUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_IMMI) &&
        (
#line 11790 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU)
#line 12989 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_conU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_IMMI) &&
        (
#line 11762 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL)
#line 13033 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_conL_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], EAXREGI) &&
        (
#line 11893 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE42Intrinsics
#line 13079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[EAXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexofU_char_rule, c)
    }
}
void  State::_sub_Op_StrInflatedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EDIREGP_EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EDIREGP_EDXREGI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, string_inflate_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2341 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 13107 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2329 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 13117 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2317 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 13131 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2306 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 13145 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2294 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 13159 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2282 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 13173 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGDPR_REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9978 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
 UseSSE<=1 
#line 13187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGDPR_REGDPR]+_kids[1]->_cost[REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_mulDPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9743 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE <=1
#line 13199 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_SUBD_REGDPR_REGDPR, _SubD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9715 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE <=1
#line 13223 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2270 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 13246 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2258 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 13256 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2246 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 13270 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2235 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 13284 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2223 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 13298 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2211 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 13312 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_SUBF_REGFPR_REGFPR, _SubF_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10325 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 13330 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, subFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, subFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10312 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 13340 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, subFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_RREGI_RREGI, _SubI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_32) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_32]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_32_ECXREGI, _SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_ECXREGI, _SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0__LOADI_MEMORY_, _SubI_immI0__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, negI_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_RREGI, _SubI_immI0_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__RREGI, _SubI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0__LOADL_MEMORY_, _SubL_immL0__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0_EREGL, _SubL_immL0_eRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(EREGL, negL_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, negL_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, negL_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EBXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EBXREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EAXREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, tlsLoadP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI_ECXREGI, _URShiftI_ncxRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI1, _URShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI_32_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI, _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI0_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI, _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI8, _URShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI_M1, _URShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+600;
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_1_31_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__IMMI, _XorI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI__LOADI_MEMORY_, _XorI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__RREGI, _XorI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 8400 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 13954 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 8400 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 13998 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 8385 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 14042 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 8385 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 14086 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, blsmskI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI_IMMI_M1, _XorI_rRegI_immI_M1_rule, c)
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 9189 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 14203 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9189 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 14223 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_EREGL_IMML_M1) &&
        (
#line 9162 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 14243 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_ADDL_EREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_EREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 9162 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_32.ad"
UseBMI1Instructions
#line 14263 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_EREGL_IMML_M1]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, blsmskL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, blsmskL_eReg_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, blsmskL_eReg_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL_EREGL_IMML_M1, _XorL_eRegL_immL_M1_rule, c)
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6116 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 14289 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6116 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 14299 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6105 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 14313 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6094 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 14327 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6094 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 14337 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6083 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 14351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6072 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 14365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6072 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 14375 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6061 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0  && n->as_Vector()->length() == 16
#line 14389 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6051 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 16
#line 14403 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6040 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14417 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6040 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14427 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6028 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6018 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 14455 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6007 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14469 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6007 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14479 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5995 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5985 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14507 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6257 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14523 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6257 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14533 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6246 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6235 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14561 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6235 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14571 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6224 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 14585 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6213 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6213 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14609 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6202 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14623 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6192 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 14637 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6181 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14651 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6181 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14661 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6170 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6160 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14689 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6149 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14703 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6149 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6138 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0  && n->as_Vector()->length() == 2
#line 14727 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6128 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 14741 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECZ_VECZ) &&
        (
#line 9967 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 16
#line 14757 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_MULADDVS2VI_VECZ_VECZ]+10;
        DFA_PRODUCTION__SET_VALID(VECZ, vmuladdadd32S16I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECZ_VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9967 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 16
#line 14767 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECZ_VECZ]+_kids[1]->_cost[VECZ]+10;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmuladdadd32S16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECY_VECY) &&
        (
#line 9955 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 8
#line 14781 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULADDVS2VI_VECY_VECY]+10;
        DFA_PRODUCTION__SET_VALID(VECY, vmuladdadd16S8I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9955 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 8
#line 14791 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECY_VECY]+_kids[1]->_cost[VECY]+10;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmuladdadd16S8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECX_VECX) &&
        (
#line 9943 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 4
#line 14805 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULADDVS2VI_VECX_VECX]+10;
        DFA_PRODUCTION__SET_VALID(VECX, vmuladdadd8S4I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9943 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 4
#line 14815 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECX_VECX]+_kids[1]->_cost[VECX]+10;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmuladdadd8S4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECD_VECD) &&
        (
#line 9931 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 2
#line 14829 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_MULADDVS2VI_VECD_VECD]+10;
        DFA_PRODUCTION__SET_VALID(VECD, vmuladdadd4S2I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECD_VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9931 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 2
#line 14839 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECD_VECD]+_kids[1]->_cost[VECD]+10;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmuladdadd4S2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6366 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14853 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6366 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14867 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6355 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14881 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6344 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14895 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6344 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14909 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6333 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14923 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6322 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14937 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6322 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6311 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14965 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6301 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14979 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6290 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14993 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6290 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15007 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6279 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15021 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6269 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15035 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5106 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15051 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd16I_reduction_reg_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5078 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15071 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5054 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 15115 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd8I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5030 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15159 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5010 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 15203 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4989 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 2 && UseAVX == 0
#line 15247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rsadd4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4969 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15291 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4951 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 15335 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvadd2I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4932 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 2 && UseAVX == 0
#line 15379 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rsadd2I_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6443 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15425 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6443 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15435 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6432 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15449 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6421 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15463 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6421 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15473 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6410 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15487 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6399 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15501 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6399 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15511 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6388 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15525 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6378 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15539 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6552 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6552 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15565 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6541 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6530 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15593 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6530 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15603 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6519 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6508 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15631 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6508 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15641 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6497 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15655 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6487 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 15669 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6476 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15683 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6476 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15693 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6465 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15707 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6455 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15721 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5323 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGF, radd16F_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5284 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15747 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, radd8F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5261 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15761 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvadd4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5238 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 15775 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsadd4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5223 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15789 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvadd2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5208 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 15803 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsadd2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6629 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15819 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6629 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15829 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6618 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15843 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6607 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15857 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6607 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15867 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6596 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15881 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6585 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15895 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6585 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15905 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6574 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15919 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6564 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15933 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5447 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15949 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGD, rvadd8D_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5424 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15959 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvadd4D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5409 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15973 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvadd2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5394 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 15987 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rsadd2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6772 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 16003 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub64B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6761 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 16013 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6750 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 16027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6739 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 16037 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6728 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 16051 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6717 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 16061 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6707 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 16
#line 16075 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6696 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16089 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6685 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16099 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6675 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 16113 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6664 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16127 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6653 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16137 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6643 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16151 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6913 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 16167 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub32S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6902 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 16177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6891 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 16191 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6880 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 16201 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6869 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16215 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6858 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16225 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6848 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 16239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6837 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16253 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6826 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16263 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6816 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16277 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6805 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16291 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6794 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16301 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6784 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16315 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7022 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16331 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7011 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16341 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7000 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 16355 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6989 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 16365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6978 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16379 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6967 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16389 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6957 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16403 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6946 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16417 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6935 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16427 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6925 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7099 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16457 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8L_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7088 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16467 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7077 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 16481 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7066 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 16491 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7055 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16505 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7044 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16515 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7034 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16529 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7208 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16545 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7197 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7186 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16569 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7175 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7164 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16593 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7153 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16603 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7143 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7132 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16631 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7121 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16641 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7111 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16655 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7285 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16671 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7274 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16681 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7263 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16695 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7252 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16705 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7241 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16719 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7230 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16729 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7220 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16743 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7428 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 16759 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7428 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 16769 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7417 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 16783 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7406 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 16797 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7406 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 16807 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7395 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 16821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7384 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16835 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7384 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16845 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7373 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7363 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 16873 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7352 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16887 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7352 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16897 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7341 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16911 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7331 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16925 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7320 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16939 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7320 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16949 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7309 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16963 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7299 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16977 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7603 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16993 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7603 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17003 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7592 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17017 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7581 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 17031 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7581 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 17041 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7570 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 17055 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7493 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17069 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7493 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7482 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17093 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7472 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 4
#line 17107 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7461 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17121 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7461 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17131 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7450 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17145 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7440 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 2
#line 17159 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5600 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 17175 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvmul16I_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5572 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1
#line 17195 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvmul8I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5548 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvmul4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5525 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && UseAVX == 0
#line 17283 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rsmul4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5505 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17327 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rvmul2I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5486 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && UseAVX == 0
#line 17371 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rsmul2I_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7559 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 17417 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7559 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 17427 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7548 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 17441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7537 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 17455 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7537 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 17465 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7526 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 17479 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7515 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 17493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7515 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 17503 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7504 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 17517 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7712 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17533 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7712 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17543 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7701 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17557 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7690 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17571 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7690 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17581 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7679 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17595 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7668 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17609 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7668 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17619 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7657 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17633 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7647 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17647 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7636 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17661 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7636 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17671 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7625 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17685 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7615 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17699 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5817 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 17715 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGF, rvmul16F_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5778 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17725 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul8F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5755 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17739 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5732 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 17753 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsmul4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5717 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17767 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5702 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 17781 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsmul2F_reduction_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7789 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17797 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7789 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17807 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7778 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7767 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17835 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7767 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17845 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7756 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7745 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17873 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7745 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17883 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7734 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17897 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7724 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17911 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5941 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 17927 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGD, rvmul8D_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5918 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17937 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvmul4D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5903 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvmul2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5888 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 17965 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rsmul2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulAddVS2VI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECZ_VECZ, _MulAddVS2VI_vecZ_vecZ_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECY_VECY, _MulAddVS2VI_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECX_VECX, _MulAddVS2VI_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECD_VECD, _MulAddVS2VI_vecD_vecD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9918 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17997 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmuladd32S16I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9907 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18007 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmuladd16S8I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9896 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18017 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmuladd8S4I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9886 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 2 && UseAVX == 0 && n->as_Vector()->length() == 4
#line 18027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, smuladd8S4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9875 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18041 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmuladd4S2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9865 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 2 && UseAVX == 0 && n->as_Vector()->length() == 2
#line 18051 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, smuladd4S2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_FmaVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ__LOADVECTOR_MEMORY_) &&
        (
#line 9773 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 18067 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECZ, vfma8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ_VECZ) &&
        (
#line 9760 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 18077 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ_VECZ]+150;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vfma8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__LOADVECTOR_MEMORY_) &&
        (
#line 9747 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 18091 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECY, vfma4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 9734 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 18101 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+150;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vfma4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__LOADVECTOR_MEMORY_) &&
        (
#line 9720 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 2
#line 18115 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECX, vfma2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 9707 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 2
#line 18125 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+150;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vfma2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_FmaVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ__LOADVECTOR_MEMORY_) &&
        (
#line 9851 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 16
#line 18141 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECZ, vfma16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ_VECZ) &&
        (
#line 9838 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 16
#line 18151 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ_VECZ]+150;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vfma16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__LOADVECTOR_MEMORY_) &&
        (
#line 9825 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 18165 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECY, vfma8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 9812 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 18175 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+150;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vfma8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__LOADVECTOR_MEMORY_) &&
        (
#line 9799 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 18189 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECX, vfma4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 9786 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 18199 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+150;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vfma4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7932 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 18215 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7921 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 18225 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7910 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7899 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18249 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7888 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18263 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7877 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18273 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7867 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18287 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7856 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18301 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7845 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7835 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18325 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8009 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18341 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7998 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7987 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7976 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18375 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7965 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18389 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7954 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18399 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7944 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18413 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SqrtVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8092 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18429 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 8081 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18439 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8070 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18453 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 8059 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18463 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8048 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18477 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 8037 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18487 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SqrtVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8180 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18503 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 8169 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18513 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8158 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18527 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 8147 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8136 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18551 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 8125 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18561 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8114 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18575 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsqrt2F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) &&
        (
#line 8103 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18585 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsqrt2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8353 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18615 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll32S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8342 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18625 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8331 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 18639 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8320 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 18649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8309 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18663 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8298 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18673 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8288 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18687 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8278 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18701 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8267 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18715 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8256 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18725 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8246 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18739 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8236 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18753 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8225 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18767 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8214 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18777 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8204 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18791 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8194 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18805 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8482 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll16I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8471 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18831 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8460 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18845 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8449 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18855 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8438 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8427 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18879 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8417 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18893 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8407 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18907 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8396 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18921 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8385 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18931 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8375 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18945 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8365 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18959 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8569 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18975 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll8L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8558 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8547 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 18999 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8536 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 19009 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8525 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19023 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8514 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19033 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8504 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19047 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8494 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19061 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9135 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 19077 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsra32S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9124 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 19087 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsra32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9113 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 19101 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9102 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 19111 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9091 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 19125 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9080 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 19135 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9070 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 19149 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9060 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 19163 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9049 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9038 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9028 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19201 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9018 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19215 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9007 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19229 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8996 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8986 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19253 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8976 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19267 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9264 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 19283 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsra16I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9253 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 19293 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsra16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9242 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 19307 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9231 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 19317 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9220 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19331 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9209 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19341 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9199 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19355 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9189 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19369 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9178 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19383 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9167 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19393 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9157 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19407 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9147 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19421 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8746 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 19437 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl32S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8735 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 19447 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8724 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 19461 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8713 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 19471 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8702 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 19485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8691 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 19495 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8681 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 19509 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8671 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 19523 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8660 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8649 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8639 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19561 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8629 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19575 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8618 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19589 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8607 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8597 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19613 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8587 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19627 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8875 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 19643 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl16I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8864 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 19653 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8853 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 19667 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8842 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 19677 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8831 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19691 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8820 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 19701 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8810 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19715 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8800 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 19729 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8789 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19743 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8778 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19753 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8768 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19767 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8758 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19781 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8962 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 19797 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl8L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8951 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 19807 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8940 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 19821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8929 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 19831 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8918 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19845 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8907 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19855 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8897 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8887 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19883 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9409 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19899 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9409 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19909 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9398 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19923 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9387 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19937 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9387 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19947 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9376 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19961 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9365 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19975 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9365 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9354 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19999 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9344 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 16
#line 20013 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9333 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9333 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20037 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9322 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20051 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9312 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 8
#line 20065 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9301 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9301 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20089 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9290 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20103 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9280 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 4
#line 20117 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9551 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 20133 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9551 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 20143 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9540 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 20157 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9529 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 20171 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9529 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 20181 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9518 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 20195 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9507 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 20209 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9507 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 20219 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9496 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 20233 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9486 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 16
#line 20247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9475 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20261 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9475 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9464 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20285 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9454 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 8
#line 20299 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9443 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20313 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9443 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20323 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9432 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20337 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9422 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 4
#line 20351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9693 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 20367 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9693 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 20377 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9682 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 20391 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9671 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 20405 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9671 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 20415 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9660 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 20429 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9649 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 20443 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9649 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 20453 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9638 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 20467 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9628 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 16
#line 20481 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9617 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20495 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9617 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20505 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9606 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 20519 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9596 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 8
#line 20533 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9585 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9585 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20557 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9574 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 20571 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9564 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 4
#line 20585 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADVECTOR_MEMORY_, _LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 3009 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 64 && n->as_LoadVector()->element_size() > 4
#line 20605 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECZ, loadV64_qword_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2996 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 64 && n->as_LoadVector()->element_size() <= 4
#line 20615 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, loadV64_dword_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2954 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 32
#line 20629 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECY, loadV32_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2912 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 16
#line 20639 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECX, loadV16_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2880 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 8
#line 20649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECD, loadV8_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2848 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 4
#line 20659 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECS, loadV4_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 3098 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 64 && n->as_StoreVector()->element_size() > 4
#line 20671 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECZ]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV64_qword_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 3086 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 64 && n->as_StoreVector()->element_size() <= 4
#line 20680 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECZ]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV64_dword_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3075 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 32
#line 20691 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECY]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3064 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 16
#line 20702 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECX]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3053 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 8
#line 20713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECD]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3042 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 4
#line 20724 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECS]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV4_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4358 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2
#line 20737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4345 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 20747 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4332 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20761 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4319 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20771 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4308 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 20781 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4297 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 20795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4286 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20809 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4275 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20823 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4264 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20837 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4253 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20851 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4242 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20865 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4231 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20875 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3970 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32
#line 20885 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3960 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16
#line 20899 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3950 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20913 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3940 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20927 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3929 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20941 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3919 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20955 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3904 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20969 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3890 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20983 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3264 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && !VM_Version::supports_avx512vlbw()
#line 20997 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl64B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3250 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 21011 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3238 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 21025 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3220 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && !VM_Version::supports_avx512vlbw()
#line 21039 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3200 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && !VM_Version::supports_avx512vlbw()
#line 21053 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl64B_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3184 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 21067 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3166 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 21081 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3152 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 21095 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3136 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 21109 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3124 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 21123 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3112 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 21137 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4497 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2
#line 21153 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4484 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 21163 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4471 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4458 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4447 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 21197 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4436 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 21211 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4425 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21225 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4414 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4403 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21253 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4392 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21267 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4381 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21281 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4370 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 21291 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4047 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16
#line 21305 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4037 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 21319 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4027 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 21333 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4017 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21347 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4006 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 21357 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3996 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21371 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3983 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21385 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3418 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 21399 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl32S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3402 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 21413 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl32S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3384 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 21427 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl32S_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3370 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 21441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3356 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 21455 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3340 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 21469 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3328 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vlbw()
#line 21483 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3316 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 21497 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3302 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vlbw()
#line 21511 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3292 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 21525 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3280 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vlbw()
#line 21539 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4614 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4601 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21565 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4588 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4575 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21589 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4564 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4553 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21613 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4542 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21627 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4531 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21641 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4520 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21655 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4509 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21669 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4117 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 21683 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4107 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 21697 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4097 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21711 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4086 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21721 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4073 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4060 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21749 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3538 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 21763 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3524 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21777 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3512 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21791 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3498 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 21805 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3482 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 21819 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16I_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3470 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21833 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3456 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21847 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3446 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21861 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3434 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21875 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4746 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21891 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4735 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21901 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4724 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21915 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4713 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21925 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4700 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21935 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4687 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21949 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 4668 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21963 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 4650 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21977 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4185 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 21991 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4175 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 22005 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4162 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 22019 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 4143 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 22033 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3684 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 22047 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3670 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 22061 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 3654 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 22075 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 3640 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 22089 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 3618 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 22103 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 3599 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 22117 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3555 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && !VM_Version::supports_avx512vlbw()
#line 22131 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4838 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 22147 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4826 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 22157 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4814 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2
#line 22167 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4802 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2
#line 22177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 4791 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 22187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 4780 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 22201 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 4769 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 22215 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 4758 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 22229 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 4208 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 22243 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 4198 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 22257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3792 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX < 3
#line 22271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3782 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX < 3
#line 22285 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3772 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX < 3
#line 22299 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3758 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 22313 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 3744 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22327 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16F_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3732 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 22341 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 3720 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22355 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3710 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22369 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3700 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22383 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4918 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 22399 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4906 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2
#line 22409 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4894 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2
#line 22419 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 4883 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 22429 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 4872 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 22443 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 4861 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 22457 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 4850 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 22471 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 4219 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 22485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 3876 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX < 3
#line 22499 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 3866 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX < 3
#line 22513 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3851 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 22527 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 3837 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22541 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8D_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3825 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 22555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 3813 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22569 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3803 "/tmp/B.hez4kzn8/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 22583 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_VecS: { _sub_Op_VecS(n);
    break;
  }
  case Op_VecD: { _sub_Op_VecD(n);
    break;
  }
  case Op_VecX: { _sub_Op_VecX(n);
    break;
  }
  case Op_VecY: { _sub_Op_VecY(n);
    break;
  }
  case Op_VecZ: { _sub_Op_VecZ(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_AtanD: { _sub_Op_AtanD(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveVD: { _sub_Op_CMoveVD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveVF: { _sub_Op_CMoveVF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapB: { _sub_Op_CompareAndSwapB(n);
    break;
  }
  case Op_CompareAndSwapS: { _sub_Op_CompareAndSwapS(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_WeakCompareAndSwapB: { _sub_Op_WeakCompareAndSwapB(n);
    break;
  }
  case Op_WeakCompareAndSwapS: { _sub_Op_WeakCompareAndSwapS(n);
    break;
  }
  case Op_WeakCompareAndSwapI: { _sub_Op_WeakCompareAndSwapI(n);
    break;
  }
  case Op_WeakCompareAndSwapL: { _sub_Op_WeakCompareAndSwapL(n);
    break;
  }
  case Op_WeakCompareAndSwapP: { _sub_Op_WeakCompareAndSwapP(n);
    break;
  }
  case Op_CompareAndExchangeB: { _sub_Op_CompareAndExchangeB(n);
    break;
  }
  case Op_CompareAndExchangeS: { _sub_Op_CompareAndExchangeS(n);
    break;
  }
  case Op_CompareAndExchangeI: { _sub_Op_CompareAndExchangeI(n);
    break;
  }
  case Op_CompareAndExchangeL: { _sub_Op_CompareAndExchangeL(n);
    break;
  }
  case Op_CompareAndExchangeP: { _sub_Op_CompareAndExchangeP(n);
    break;
  }
  case Op_GetAndAddB: { _sub_Op_GetAndAddB(n);
    break;
  }
  case Op_GetAndAddS: { _sub_Op_GetAndAddS(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndSetB: { _sub_Op_GetAndSetB(n);
    break;
  }
  case Op_GetAndSetS: { _sub_Op_GetAndSetS(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_DivModI: { _sub_Op_DivModI(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_HasNegatives: { _sub_Op_HasNegatives(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_Jump: { _sub_Op_Jump(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_LoopLimit: { _sub_Op_LoopLimit(n);
    break;
  }
  case Op_MulAddS2I: { _sub_Op_MulAddS2I(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_SetVectMaskI: { _sub_Op_SetVectMaskI(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModD: { _sub_Op_ModD(n);
    break;
  }
  case Op_ModF: { _sub_Op_ModF(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OnSpinWait: { _sub_Op_OnSpinWait(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_OverflowAddI: { _sub_Op_OverflowAddI(n);
    break;
  }
  case Op_OverflowSubI: { _sub_Op_OverflowSubI(n);
    break;
  }
  case Op_OverflowMulI: { _sub_Op_OverflowMulI(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PopCountVI: { _sub_Op_PopCountVI(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_SqrtF: { _sub_Op_SqrtF(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrCompressedCopy: { _sub_Op_StrCompressedCopy(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_StrInflatedCopy: { _sub_Op_StrInflatedCopy(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddReductionVI: { _sub_Op_AddReductionVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddReductionVF: { _sub_Op_AddReductionVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_AddReductionVD: { _sub_Op_AddReductionVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulReductionVI: { _sub_Op_MulReductionVI(n);
    break;
  }
  case Op_MulVL: { _sub_Op_MulVL(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulReductionVF: { _sub_Op_MulReductionVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_MulReductionVD: { _sub_Op_MulReductionVD(n);
    break;
  }
  case Op_MulAddVS2VI: { _sub_Op_MulAddVS2VI(n);
    break;
  }
  case Op_FmaVD: { _sub_Op_FmaVD(n);
    break;
  }
  case Op_FmaVF: { _sub_Op_FmaVF(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_SqrtVD: { _sub_Op_SqrtVD(n);
    break;
  }
  case Op_SqrtVF: { _sub_Op_SqrtVF(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
